//==============================================================
// freeze viewer   (STPP.06)
//     for PSP CFW5.00 M33-6
// STEAR 2010-2013
//--------------------------------------------------------------

#ifndef PSP_FREEZEVIEWER_H
#define PSP_FREEZEVIEWER_H

#include <stdio.h>
#include <stdlib.h>
#include <pspiofilemgr.h>
#include "graphics.h"
#include "SMEMO/draw.h"

//----- 萔ݒ -----

#define THUMBFOLDER		"FVthumb"								// TlCۑtH_
#define THUMBID			(0x13)									// TlCt@CIDi0x13,--j
																//   0x01:摜t@C
																//   0x02:A[JCutH_
																//   0x03:t@C
#define THUMBXSIZE		(96)									// TlCXTCY
#define THUMBYSIZE		(54)									// TlCYTCY
#define THUMBMAX		(30)									// TlC擾
#define INILIST			(8)										// ZbgAbvڐ

//----- \ -----

typedef struct {												// bZ[Wp
	int		phase;
	int		error;
	char	msg[INILIST][128];
} iniList;

typedef struct {												// t@C(fBNgGg)
	char			*name;										// O(UTF8)
	char			*name2;										// O(VtgJIS)
	int				type;										// 0:t@C 1:tH_ 2:A[JCu 3:Xe 4:{̃[ 5:ݒ 6:
	u64				size;										// TCY
	u64				diskSize;									// fBATCY
	ScePspDateTime	mtime;										// t@C̍XV
	DrawImg			*thumb;										// TlC摜
	ScePspDateTime	thumbTime;									// TlC̍XV
	int				xSize;										// 摜XTCY
	int				ySize;										// 摜YTCY
	char			*msg;										// bZ[Wp
	char			*settingMsg;								// ݒ荀ڂ̐ݒlbZ[W
	int				setting;									// ݒ荀ڂ̐ݒl
} FileData;

typedef struct {												// Xg
	volatile int	complete;									// Xg̎擾I 0:擾 1: -1:G[I
	int				pos;										// J[\ʒu
	int				count;										// ڐ
	char			path[1024];									// file ̃fBNgpX(UTF8)
	char			path2[1024];								// file ̃fBNgpX(VtgJIS)
	FileData		*file;										// t@C(fBNgGg)
	char			dirName[256];								// O܂ŋfBNg
	int				getDirMode;									// fBNg擾ۂɃTlC擾邩
	int				archiveType;								// ktH_̎ 0:ktH_ł͂Ȃ 1:zip 2:rar
	char			archiveFile[1024];							// ktH_̌ɂȂA[JCuւ̃tpX
	char			archivePass[256];							// ktH_̃pX[h
} DirList;

//----- ̂main.cɂ -----

extern volatile int	gExitRequest;								// [HOME]ɂI`FbN
extern volatile int	gDialogFlag;								// _CAO\Ă邩i0:Noj
extern volatile int	gListDrawFlag;								// ListDrawi0:Noj_CAO֘AtO
extern int			gScrBufFlg;									// wiꎞobt@XVv
extern DrawImg		*gScrBuf1;									// wiޔ̈
extern DrawImg		*gScrMask;									// j[wip
extern DrawImg		*gScrMask2;									// ʔwip
extern DrawImg		*gIconImg[10];								// ACRp
extern DrawImg		*gCsrImg;									// J[\p
extern DrawImg		*gEtcImg;									// ėp
extern DrawImg		*gRollBar;									// XN[o[p

//----- ϐ -----



#endif
