//==============================================================
// Simple IME   (STPP.04)
//     for PSP CFW5.00 M33-6
// STEAR 2009-2010
//--------------------------------------------------------------
// PSPp̊ȈIME쐬Ă݂B
// \tgEFAL[{[hƏnꊿϊƃ[U[i\ϊjB
//--------------------------------------------------------------

#include <pspuser.h>
#include <pspctrl.h>
#include <pspgu.h>
#include <pspdisplay.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

//#include "intraFont.h"
#include "graphics.h"
#include "zenkaku.h"
#include "draw.h"
#include "osk.h"
#include "sime.h"

//----- }N -----


//----- 萔ݒ -----

#define SIMENAME	"Simple IME Ver1.33"

#define DICFILE1	"SIME.DIC"					// {t@C
#define DICFILE2	"ms0:/PSP/COMMON/SIME.DIC"
#define DIC2FILE1	"SIMEUSER.DIC"				// [U[t@C
#define DIC2FILE2	"ms0:/PSP/COMMON/SIMEUSER.DIC"
#define INIFILE1	"SIME.INI"					// ݒt@C
#define INIFILE2	"ms0:/PSP/COMMON/SIME.INI"

#define KBPOSX1		(268)						// \tgEFAL[̈ʒuXiTOzAVXgJ[\j
#define KBPOSY1		(157)						// \tgEFAL[̈ʒuYiTOzAVXgJ[\j
#define KBPOSX3		(217)						// \tgEFAL[̈ʒuXi~TȔzuj
#define KBPOSY3		(142)						// \tgEFAL[̈ʒuYi~TȔzuj
#define MEPOSX		(131)						// ݒʂ̈ʒu
#define MEPOSY		(35)						// ݒʂ̈ʒu
#define KEYREP1		(20)						// L[s[gJn܂ł̎
#define KEYREP2		(3)							// L[s[g̊Ԋu
#define FONTX		(6)							// tHg̒
#define FONTY		(16)						// tHg̍ő卂
#define CHLEN		(32)						// ϊC̍ő啶
#define KLIST		(6)							// ⃊Xg̍s
#define KMAX		(102)						// ⃊Xg̍ő吔
#define CBTIME		(25)						// J[\_Ŏ
#define CURSTEP		(7)							// AVXgJ[\̈ړv
#define YOMILMAX	(102)						// ̐ȉɁu݁v␔Ȃ烊Xg\

#define CORFL1		0xC0A0A0					// g
#define CORFL2		0xF0D0D0					// 邢g
#define CORFL3		0x707070					// Âg
#define CORIN		0x600060					// EBhEwi
#define CORFR		0xA08080					// EBhEOi
#define CORCUR		0xFF8080					// J[\
#define CORCUR1		0x7070FF					// J[\
#define CORCUR2		0x008000					// J[\
#define CORCUR3		0xA0A0E0					// J[\
#define CORCUR4		0xFF8080					// J[\~
#define CORRBAR		0x70E070					// XN[o[
#define CORWCHR		0xFFFFFF					// EBhE
#define CORSCHR		0xB0FFB0					// EBhEꕶ
#define CORFCHR		0x000000					// EBhEg
#define CORCHBK		0xFFFFFF					// ϊCwi
#define CORCHCR		0x000000					// ϊC
#define CORCHCU		0xFF8080					// ϊCÏ

//----- vg^Cv錾 -----

static void putBack(void);
static unsigned int	fcode(char *str);
static unsigned int	getInt(char *str);
static void kList(char wordList[][2][33],int count,int index);
static void getkList(char wordList[][2][33],int count);
static void putkList(void);

//------ O[oϐ -----

static char			gKeyName1[7][25] = {
						"PFSp Ђ炪",
						"QFSp J^Ji",
						"RFp J^Ji",
						"SFSp At@xbg",
						"TFSp L",
						"UFp At@xbg",
						"VFp L",
					};
static char			gKeyTable1[7][161] = {
						"OPQRĂƂSȂɂʂ˂̂T͂ЂӂւقU܂݂ނ߂VJKWXABIHh[uvE@",
						"OACEGIPJLNPRQTVXZ\\R^`cegSijklmTnqtwzU}~VJKWXABI@BDFHHbh[uvE@",
						"0      1      2      3      4      5      6      7      8      9      !      ?       \"      ",
						"O`abcdPQefghiRSjklmnTUopqrsVWtuvwxXIy|CDHmiohfnjp@",
						"OIhiPHfjQR{|}~S^oCGT_pDFUmQOVnb`EcW􁙂X~TU̓́ӃքDc@",
						"0 A B C D E 1 a b c d e 2 F G H I J 3 f g h i j 4 K L M N O 5 k l m n o 6 P Q R S T 7 p q r s t 8 U V W X Y 9 u v w x y ! Z z - , . ? [ ( < { : / ] ) > }   ",
						"7 4 1 0 + * 8 5 2 , - / 9 6 3 . = #             ( < [ { : ! ) > ] } ; ? \" $ % & @ \\ ' ^ _ | ~                                                     \r \b \x7F \t   "
					};

static char			gKeyTable3[7][181] = {
						"ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂񂟂JKAB[uIvHOPQRSTUVWXEicj`|{\t \b \x7F \r @",
						"ACEGIJLNPRTVXZ\\^`cegijklmnqtwz}~@BDFHbJKAB[uIvHOPQRSTUVWXE|i`j{\t \b \x7F \r @",	// u\\vӁI
						"                                                               !  ? 0 1 2 3 4 5 6 7 8 9  ~ | / _ - ( = ) + \t \b \x7F \r   ",
						"OPQRSTUVWX`abcdefghijklmnopqrstuvwxyfCQIiDjHmnFo^p`|{\t \b \x7F \r @",
						"OPQRSTUVWXhCijD{}|~F^_GIQHOmnfbo`pEc􁪁~TÚ̃ӃքDc|⁂\t \b \x7F \r @",
						"0 1 2 3 4 5 6 7 8 9 A B C D E F G H I J K L M N O P Q R S T U V W X Y Z a b c d e f g h i j k l m n o p q r s t u v w x y z ' , _ ! ( . ) ? < [ @ ] > : { / } ; = - * + \\ \t \b \x7F \r   ",
						"0 1 2 3 4 5 6 7 8 9 ! \" # $ % & ( ' ) * + , - . / : < = > ; ? [ \\ ] @ ^ { _ } | '  ~                                                                                   \t \b \x7F \r   "
					};
static long			gHEDtbl[85],gDicWordPos,gDicSize;			// {Ǘp
static DrawImg 		*gBackBuf,									// \tgL[wiҔobt@
					*gInLnBuf,									// ϊCwiҔobt@
					*gkListBuf;									// ⃊XgwiҔobt@
static char			*gDic,gDicFile[33],gDic2File[33],gIniFile[33],
					gSt[CHLEN +1],								// ϊs̕
					gYomi[CHLEN +1],gKouho[CHLEN +1];			// ϊwKp
static int			gSetup = 0,									// ĂHi0:Noj
					gMode,										// Jڏ
					gBDFlag,									// EBhE̋
					gSaveFlag,									// {ɕωHi0:Noj
					gSave,										// {̊wKeۑ邩
					gUSaveFlag,									// [U[ɕωHi0:Noj
					gUSave,										// [U[gp邩
					gUDicAdd,									// [U[ɌǉHi0:Yesj
					gIni,										// ݒɕωHi0:Noj
					gKey,										// \tgL[̎
					gGetFlag = 0,								// EBhEnHi0:Noj
					gCount = 0,									// ϊ̑
					gPage;										// sʃy[W
static int			gCx,gCy,									// J[\̈ʒu
					gCxw,gCyw,									// J[\̌`
					gFont;										// 

static struct {
	int	x;
	int	y;
} gBackBufP,													// \tgL[wïʒu
  gInLnBufP,													// ϊCwïʒu
  gkListBufP;													// ⃊Xgwïʒu

static struct strUsDic {										// [U[Ǘ\
	struct strUsDic	*chain;										// ̌ւ̃|C^iNULLƏI[j
	char			yomi[CHLEN +1];								// u݁v
	char			kouho[CHLEN +1];							// uv
} **gUsDic;


//==============================================================
// {t@C̓ǂݍ
//--------------------------------------------------------------
// ߂l  0:̓ǂݍݐ
//        -1:sȎt@C
//        -2:Ȃ
//        -3:t@CJȂi݂ȂHj
//--------------------------------------------------------------

static int DicLoad(char *DicFile)
{
	int		i,fa,fd;
	long	pos,filesize;

	fa = 0;
	fd = sceIoOpen( DicFile, PSP_O_RDONLY, 0777 );
	if (fd>=0){
		filesize = sceIoLseek(fd, 0, SEEK_END);
		sceIoLseek(fd, 0, SEEK_SET);
		pos = sceIoRead( fd,gHEDtbl, sizeof(gHEDtbl) );
		if (pos!=sizeof(gHEDtbl)){
			fa = -1;											// Wve[uȂ
		} else {
			for (i=0; i<85 ;i++){
				if (gHEDtbl[i]!=0xFFFFFFFF && (gHEDtbl[i]>filesize-pos)){
					fa = -1;									// Wv悪f[^OĂ
				}
			}
			if (!fa){
				gDic = (char*) malloc( filesize - pos );
				if (gDic==NULL){
					fa = -2;									// mۂłȂ
				} else {
					gDicSize = filesize - pos;
					sceIoRead( fd,gDic, gDicSize );
				}
			}
		}
		sceIoClose(fd);
	} else {
		fa = -3;
	}

	if (fa){													// t@CJȂ
		for (i=0; i<85 ;i++){
			gHEDtbl[i] = 0xFFFFFFFF;
		}
	}

	return (fa);
}


//==============================================================
// [U[t@C̏
//--------------------------------------------------------------

static void UserDicInit(void)
{
	int		i;

	gUsDic = (struct strUsDic**) malloc( sizeof(struct strUsDic*) * 85 );
	if (gUsDic){
		for (i=0; i<85 ;i++){
			gUsDic[i] = NULL;
		}
	}
}


//==============================================================
// [U[p̈J
//--------------------------------------------------------------

static void UserDicFree(void)
{
	struct strUsDic	*usdic,*usdic2;
	int		i;

	for (i=0; i<85 ;i++){
		usdic = gUsDic[i];
		if (usdic){												// uvQȂ
			do{
				usdic2 = usdic->chain;
				free(usdic);
				usdic = usdic2;
			}while (usdic);										// uv폜
		}
	}
	free(gUsDic);												// [U[폜
}


//==============================================================
// [U[t@C̓ǂݍ
//--------------------------------------------------------------
// ΏۂƂȂ郆[U[ gDic2File Ŏw肳Ă郂młB
// [U[t@C\Ɉُ킪ꂽꍇ͓ǂݍ݂𒆎~A[U[
// ܂B
//--------------------------------------------------------------

//----- obt@ǂݍ -----

static void UserDicLoadBuf(int fd,char *data,int *pos,int worksize)
{
	if (*pos<worksize) return;
	sceIoRead( fd, data, worksize );
	*pos = 0;
}

//----- P荞 -----

static int UserDicLoadWord(char *str,int fd,char *data,int *pos,int worksize)
{
	char	c;
	int		len;

	len = 0;
	c = -1;
	while (len<33 && c!='\0'){
		c = data[(*pos)++];
		UserDicLoadBuf( fd, data, pos, worksize );				// obt@f[^s瑱[h
		str[len++] = c;
	}
	if (c!='\0'){												// I[o[isȎj
		return (-1);
	}
	return (0);
}

//----- C -----

static void UserDicLoad(void)
{
	const int		ws[4] = {16384,4096,1024,128};
	struct strUsDic	*usdic,*usdic2;
	char	*data,yomi[33],kouho[33];
	int		i,fd,hp,pos,flag,worksize;
	long	filesize,poscnt;

	//----- iʏ͂ȂĂ񂾂ǈꉞj -----

	if (gUsDic){
		UserDicFree();
		UserDicInit();											// [U[
	}

	//-----  -----

	for (i=0; i<4 ;i++){										// o邾傫obt@mۂ
		worksize = ws[i];
		data = (char*) malloc(worksize);
		if (data) break;										// obt@̊mۂɐ
	}
	if (!data) return;											// obt@mۂłȂ̂ŏI
	fd = sceIoOpen( gDic2File, PSP_O_RDONLY, 0777 );
	if (fd>=0){
		filesize = sceIoLseek(fd, 0, SEEK_END);
		sceIoLseek(fd, 0, SEEK_SET);
	} else {													// wt@CJȂ̂ŏI
		free(data);
		return;
	}

	//----- ǂݍ -----

	sceIoRead( fd, data, worksize );
	poscnt = 0;
	pos = 0;
	hp = 0;
	flag = 0;
	while (poscnt<filesize && hp<85){
		if (data[pos]!=0){										// uvQȂ
			usdic2 = NULL;
			while (data[pos]!=0){
				if (UserDicLoadWord( yomi, fd, data, &pos, worksize )){
					flag = -1;									// I[o[isȎj
					break;
				}
				if (UserDicLoadWord( kouho, fd, data, &pos, worksize )){
					flag = -1;									// I[o[isȎj
					break;
				}
				usdic = (struct strUsDic*) malloc( sizeof(struct strUsDic) );
				if (usdic){										// 擾oȂ
					usdic->chain = NULL;
					strcpy( usdic->yomi,yomi );
					strcpy( usdic->kouho,kouho );
					if (!usdic2){								// ŏ́uv
						gUsDic[hp] = usdic;
					} else {									// QԖڈȍ~́uv
						usdic2->chain = usdic;
					}
					usdic2 = usdic;
				} else {										// 擾oȂ
					flag = 1;									// ǂ߂Ƃ܂ł͍̗p
					break;
				}
			}
		}
		if (flag) break;										// ǂݍݒf
		pos++;
		UserDicLoadBuf( fd, data, &pos, worksize );				// obt@f[^s瑱[h
		hp++;
	}
	sceIoClose( fd );

	//----- ُ픭΍ -----

	if (flag<0){												// es
		UserDicFree();
		UserDicInit();											// [U[
	}
}


//==============================================================
// t@C̓ǂݍ݂Ɗe평
//--------------------------------------------------------------
// flag      0:EBhEɔwi𕜌
//        ȊO:EBhEɉȂiCō悷ׂj
// ߂l    1:ɏĂ
//           0:̓ǂݍݐ
//          -1:sȎt@C
//          -2:Ȃ
//          -3:t@CJȂi݂ȂHj
//--------------------------------------------------------------
// t@CIMEݒǂݍ݂܂B
// ɏĂꍇ flag ̐ݒύX̂ݎs܂B
// ݒt@C͎t@CƓtH_ɔzu܂B
// [U[ǂ߂Ȃꍇ̌x͂܂B
//--------------------------------------------------------------

int InitSIME(int flag)
{
	char	str[256],*p;
	int		ret,type,val;
	FILE*	fp1;

	//----- ϐ -----

	if (flag){
		gBDFlag = 1;											// EBhEɉȂ
	} else {
		gBDFlag = 0;											// EBhEɔwi𕜌
	}

	if (gSetup) return (1);
	gSetup = 1;

	gMode = 0;
	gCxw = 2;													// J[\̑傫
	gDicWordPos = -1;
	gDicSize = 0;
	gSaveFlag = 0;
	gSave = 0;													// IɎ̋Lڏۑ
	gUSaveFlag = 0;
	gUSave = 0;													// [U[g
	gUDicAdd = 0;												// [U[Ɍǉ
	gIni = 0;
	gKey = 0;													// \tgL[̎
	gPage = 0;
	gSt[0] = '\0';
	gkListBufP.x = -1;

	//----- {[h -----

	ret = DicLoad( DICFILE1 );
	strcpy( gDicFile ,DICFILE1 );
	strcpy( gDic2File ,DIC2FILE1 );
	strcpy( gIniFile ,INIFILE1 );
	if (ret){
		ret = DicLoad( DICFILE2 );								// COMMONtH_
		strcpy( gDicFile ,DICFILE2 );
		strcpy( gDic2File ,DIC2FILE2 );
		strcpy( gIniFile ,INIFILE2 );
		if (ret){
			gDicFile[0] = '\0';
			strcpy( gIniFile ,INIFILE1 );
		}
	}

	//----- ݒ胍[h -----

	fp1 = fopen( gIniFile, "r" );								// ݒt@C̓ǂݍ
	if (fp1!=NULL){
		while (1){
			if (fgets( str,256,fp1 )==NULL) break;
			p = strtok( str," =\t" );
			type = 0;
			if (strstr( p,"KEYTYPE" )!=NULL) type = 1;
			if (strstr( p,"SAVEMODE" )!=NULL) type = 2;
			if (strstr( p,"SAVEMODE2" )!=NULL) type = 3;
			if (strstr( p,"USERDICADD" )!=NULL) type = 4;
			p = strtok( NULL," =\t" );
			val = (int)strtol( p,NULL,0 );						// 񁨐lϊ
			if (val==0){										// ł͂Ȃۂ̂
				if (strstr( p,"YES" )!=NULL) val = 1;
				if (strstr( p,"NO" )!=NULL) val = 2;
				if (type==2 && val>0) gSave = val -1;
				if (type==3 && val>0) gUSave = val -1;
				if (type==4 && val>0) gUDicAdd = val -1;
			} else {
				if (type==1 && val>0 && val<=3) gKey = val -1;
			}
		}
		fclose (fp1);
	}

	//----- [U[ǂݍ -----

	UserDicInit();												// [U[
	if (!gUSave) UserDicLoad();

	return (ret);
}


//==============================================================
// t@C֏
//--------------------------------------------------------------
// ̕בւʂɏ
//--------------------------------------------------------------

static void DicSave(void)
{
	int		fd;

	if (!gSave && gSaveFlag && gDicSize){
		fd = sceIoOpen( gDicFile, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777 );
		if (fd>=0){
			sceIoWrite( fd, gHEDtbl, sizeof(gHEDtbl) );
			sceIoWrite( fd, gDic, gDicSize );
			sceIoClose( fd );
		}
	}
}


//==============================================================
// [U[t@C֏
//--------------------------------------------------------------

//----- obt@t@C֏o -----
// obt@ςɂȂt@C֏oB
// obt@ɗ]TƂ͉ȂB
// t@C֏oƂ̓|C^̒l0ɂB
// obt@ւ̃f[^ǉ1oCgsB

static void UserDicFlash(int fd,char *tmp,int *pos,int bufsize)
{
	if (*pos<bufsize) return;
	sceIoWrite( fd, tmp, *pos );
	*pos = 0;
}

//----- C -----

static void UserDicSave(void)
{
	const int		ws[4] = {16384,4096,1024,128};
	struct strUsDic	*usdic;
	char	*data;
	int		i,j,fd,pos,worksize;

	if (!gUSaveFlag) return;									// [U[ɕωȂ

	for (i=0; i<4 ;i++){										// o邾傫obt@mۂ
		worksize = ws[i];
		data = (char*) malloc(worksize);
		if (data) break;										// obt@̊mۂɐ
	}
	if (!data) return;											// obt@mۂłȂ̂ŏI

	fd = sceIoOpen( gDic2File, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777 );
	if (fd>=0){
		pos = 0;
		for (i=0; i<85 ;i++){
			usdic = gUsDic[i];
			if (!usdic){										// uvQo^ĂȂ
				data[pos++] = 0;
				UserDicFlash( fd, data, &pos, worksize );
			} else {
				do{
					for (j=0; j<=strlen(usdic->yomi) ;j++){		// '\0'܂߂
						data[pos++] = usdic->yomi[j];
						UserDicFlash( fd, data, &pos, worksize );
					}
					for (j=0; j<=strlen(usdic->kouho) ;j++){	// '\0'܂߂
						data[pos++] = usdic->kouho[j];
						UserDicFlash( fd, data, &pos, worksize );
					}
					usdic = usdic->chain;
				}while (usdic);									// ́uvJԂ
				data[pos++] = 0;								// uvQI
				UserDicFlash( fd, data, &pos, worksize );
			}
		}
		UserDicFlash( fd, data, &pos, 0 );						// obt@̋o
		sceIoClose(fd);
	}
	free(data);													// obt@
}


//==============================================================
// I
//--------------------------------------------------------------
// ɕێĂt@Cɏ߂AJB
// sɓd؂铙Ɗ̕בւɔf܂B
// ܂AIMEf[^ݒt@Cɕۑ܂B
// ݒt@C̈ʒu͎t@CƓtH_ɂȂ܂A
// Ȃꍇ EBOOT.PBP ƓtH_ɂȂ܂B
//--------------------------------------------------------------

void EndSIME(void)
{
	FILE*	fp1;
	char	str[256],item[2][4] = {"YES","NO"},s[3] = {"1\n"};

	if (gIni){
		fp1 = fopen( gIniFile, "w" );
		if (fp1!=NULL){
			strcpy( str,"KEYTYPE = " );
			s[0] = '1' + gKey;
			strcat( str,s );
			fputs( str,fp1 );
			strcpy( str,"SAVEMODE = " );
			strcat( str,item[gSave] );
			strcat( str,"\n" );
			fputs( str,fp1 );
			strcpy( str,"SAVEMODE2 = " );
			strcat( str,item[gUSave] );
			strcat( str,"\n" );
			fputs( str,fp1 );
			strcpy( str,"USERDICADD = " );
			strcat( str,item[gUDicAdd] );
			strcat( str,"\n" );
			fputs( str,fp1 );
			fclose(fp1);
		}
	}
	UserDicSave();												// [U[ۑ
	UserDicFree();												// [U[p
	DicSave();													// {ۑ
	free(gDic);
	DrawImgFree(gBackBuf);
	DrawImgFree(gInLnBuf);
	DrawImgFree(gkListBuf);
	gSetup = 0;
}


//==============================================================
// tHgw
//--------------------------------------------------------------
// font   tHg
// cyw    tHg̍i16܂Łj
// ߂l w肷ÕtHg
//--------------------------------------------------------------
// ϊsɎgp镶tHgw肷B
// eEBhDɕ\镶͓_tHgɌŒB
//--------------------------------------------------------------

int SIMEfont(int font,int cyw)
{
	int		fontBak;

	if (cyw<1) cyw = 1;
	if (cyw>16) cyw = 16;
	gCyw = cyw;
	fontBak = gFont;
	gFont = font;
	return (fontBak);
}


//==============================================================
// J[\w
//--------------------------------------------------------------
// xw  J[\X̕i0ȉFJ[\\Ȃj
// yw  J[\Y̕
// x,y J[\ʒu
//--------------------------------------------------------------
// J[\Ww肷ϐƃJ[\`w肷B
// J[\\Sgets()sĂԂɍXV܂B
// J[\I^ŁAY̑傫SIMEfont()Ŏw肵܂B
//--------------------------------------------------------------

void SIMEcursor(int xw,int x,int y)
{
	gCx = x;
	gCy = y;
	gCxw = xw;
	if (gCxw<0) gCxw = 0;
	if (gCxw>16) gCxw =16;
}


//==============================================================
// ʍݒ
//--------------------------------------------------------------
// page sʃy[Wi01j
//--------------------------------------------------------------
// sʃy[Ww肵܂B
// sceGuDrawBuffer()Ƃ̐ݒ͍lĂ܂B
// VRAM̐擪c272hbgɃy[W0,1ƌߑłĂ܂B
// C̍dlɂĂ͎gȂƎv܂A͓̎K
// CׂB
//--------------------------------------------------------------

void SIMESetDraw(int page)
{
	gPage = page * 272;
}


//==============================================================
// L[
//--------------------------------------------------------------
// ߂l 0:͂Ȃ
//        :0x1C :0x1D :0x1E :0x1F
//        :0x0Di[Enter]j ~:0x1Bi[Esc]j :0x08i[BS]j :0x02 L:0x03 R:0x04
//        [START]:0x05 [SELECT]:0x06
//--------------------------------------------------------------
// e{^̏ԂL[{[hȃL[s[gŎ擾B
// ̏ꍇ͍Ōɉ{^ɑΉR[hԂB
// ͕͂͂ȂǁAL[s[gŃL[͂sꍇȂǂ
// z肵ėpӂĂ܂B
//--------------------------------------------------------------

int SIMEgetchar(SceCtrlData pad1)
{
	static SceCtrlData	pad2;
	static int			rep = 0,kcode = 0,button = 0;

	if ((pad1.Buttons & PSP_CTRL_UP) && !(pad2.Buttons & PSP_CTRL_UP)){			// uԂo
		rep = 0;																// s[gJE^Zbg
		kcode = 0x1E;															// o̓R[h
		button = PSP_CTRL_UP;													// s[gĎ{^
	}
	if ((pad1.Buttons & PSP_CTRL_DOWN) && !(pad2.Buttons & PSP_CTRL_DOWN)){
		rep = 0;
		kcode = 0x1F;
		button = PSP_CTRL_DOWN;
	}
	if ((pad1.Buttons & PSP_CTRL_LEFT) && !(pad2.Buttons & PSP_CTRL_LEFT)){
		rep = 0;
		kcode = 0x1D;
		button = PSP_CTRL_LEFT;
	}
	if ((pad1.Buttons & PSP_CTRL_RIGHT) && !(pad2.Buttons & PSP_CTRL_RIGHT)){
		rep = 0;
		kcode = 0x1C;
		button = PSP_CTRL_RIGHT;
	}
	if ((pad1.Buttons & PSP_CTRL_TRIANGLE) && !(pad2.Buttons & PSP_CTRL_TRIANGLE)){
		rep = 0;
		kcode = 0x02;
		button = PSP_CTRL_TRIANGLE;
	}
	if ((pad1.Buttons & PSP_CTRL_CROSS) && !(pad2.Buttons & PSP_CTRL_CROSS)){
		rep = 0;
		kcode = 0x1B;
		button = PSP_CTRL_CROSS;
	}
	if ((pad1.Buttons & PSP_CTRL_SQUARE) && !(pad2.Buttons & PSP_CTRL_SQUARE)){
		rep = 0;
		kcode = 0x08;
		button = PSP_CTRL_SQUARE;
	}
	if ((pad1.Buttons & PSP_CTRL_CIRCLE) && !(pad2.Buttons & PSP_CTRL_CIRCLE)){
		rep = 0;
		kcode = 0x0D;
		button = PSP_CTRL_CIRCLE;
	}
	if ((pad1.Buttons & PSP_CTRL_LTRIGGER) && !(pad2.Buttons & PSP_CTRL_LTRIGGER)){
		rep = 0;
		kcode = 0x03;
		button = PSP_CTRL_LTRIGGER;
	}
	if ((pad1.Buttons & PSP_CTRL_RTRIGGER) && !(pad2.Buttons & PSP_CTRL_RTRIGGER)){
		rep = 0;
		kcode = 0x04;
		button = PSP_CTRL_RTRIGGER;
	}
	if ((pad1.Buttons & PSP_CTRL_START) && !(pad2.Buttons & PSP_CTRL_START)){
		rep = 0;
		kcode = 0x05;
		button = PSP_CTRL_START;
	}
	if ((pad1.Buttons & PSP_CTRL_SELECT) && !(pad2.Buttons & PSP_CTRL_SELECT)){
		rep = 0;
		kcode = 0x06;
		button = PSP_CTRL_SELECT;
	}

	pad2 = pad1;

	if (pad1.Buttons & button){
		rep++;
		if (rep>KEYREP1) rep -= KEYREP2;						// L[s[g
		if (rep==1 || rep==KEYREP1) return (kcode);				// Ă
	} else {
		rep = 0;
		kcode = 0;
		button = 0;
	}

	return (0);													// ĂȂ
}


//==============================================================
// eLXgg̕\
//--------------------------------------------------------------
// 񂾃t[ɃeLXg\܂B
//--------------------------------------------------------------

static void DrawTextbox(char *str,int x,int y,int wx,long txcor,long bkcor)
{
	BoxFill( x, y, wx, 12+2, CORFL2, bkcor );
	HLine( x, y, wx-1, CORFL3 );								// 
	VLine( x, y, 12+2-1, CORFL3 );								// 
	mh_print( x+2, y+1, str, txcor );							// 
}


//==============================================================
// EBhEg̕\
//--------------------------------------------------------------

static void DrawWindow(char *title,int x,int y,int wx,int wy)
{
	y += gPage;

	BoxFill( x, y, wx-1, 12+3, CORFL1 , CORFL1 );
	HLine( x +2       , y +2 , wx-4   , CORFL3 );				// 
	VLine( x +2       , y +2 , 12+2   , CORFL3 );				// 
	HLine( x +2       , y +14, wx-4   , CORFL2 );				// 
	VLine( x +2 +wx -4, y +2 , 12+2   , CORFL2 );				// E
	mh_print( x +5, y +2, title, CORFCHR );						// ^Cg
	HLine( x       , y    , wx, CORFL2 );						// 
	VLine( x       , y    , wy, CORFL2 );						// 
	HLine( x       , y +wy, wx, CORFL3 );						// 
	VLine( x +wx -1, y    , wy, CORFL3 );						// E
}


//==============================================================
// EBhEwȋҔ
//--------------------------------------------------------------

static void getBack(void)
{
	if (gBDFlag) return;

	if (gBackBuf){												// obt@
		DrawImgFree(gBackBuf);
		gBackBuf = NULL;
	}

	switch (gKey){
	case 0:
	case 1:
		gBackBuf = DrawImgCreate( 210,98 +15 );					// \tgL[wiҔobt@
		gBackBufP.x = KBPOSX1;
		gBackBufP.y = KBPOSY1;
		BoxCopy( gBackBuf, gBackBufP.x, gPage+gBackBufP.y );
		break;
	case 2:
		gBackBufP.x = KBPOSX3;
		gBackBufP.y = KBPOSY3;
		gBackBuf = DrawImgCreate( 261,129 );					// \tgL[wiҔobt@
		BoxCopy( gBackBuf, gBackBufP.x, gPage+gBackBufP.y );
		break;
	}
}


//==============================================================
// EBhEwi̕
//--------------------------------------------------------------

static void putBack(void)
{
	if (gBDFlag) return;

	BoxPaste( gBackBuf, gBackBufP.x, gPage+gBackBufP.y );
}


//==============================================================
// \tgEFAL[{[h̕\iTOzAVXgJ[\j
//--------------------------------------------------------------
// x[],y[]   J[\̓BڕWʒu
// xx[],yy[] J[\̌ʒu
// step      J[\̓BWi0:ڕWʒuj
//--------------------------------------------------------------
// xyNULLꍇ̓J[\͕\܂B
//--------------------------------------------------------------

static void DrawKey1(int *x,int *y,int t,int *xx,int *yy,int step)
{
	char	key[3] = "  ";
	int		i,j,s,mx,my;
	long	cor[3] = { CORCUR1,CORCUR3,CORCUR4 };

	DrawWindow( gKeyName1[t],KBPOSX1,KBPOSY1,210,97 +15 );						// EBhEt[
	if (t==0){
		mh_print( KBPOSX1 +210-2-3.5*13, gPage+KBPOSY1 +2, ":ϊ", CORCUR2 );
	}
	BoxFill( KBPOSX1 +1, gPage+KBPOSY1 +15, 210-2, 97, CORFL1, CORIN );			// 
	if (x!=NULL && y!=NULL){
		for (i=0; i<3 ;i++){													// J[\̕\
			mx = (x[i] - xx[i]) *16 * step / CURSTEP;
			my = (y[i] - yy[i]) *16 * step / CURSTEP;
			DrawChar2( KBPOSX1 +1 + x[i]*16 -mx, gPage+KBPOSY1 +15 + y[i]*16 -my, i, cor[i] );
		}
	}
	if (t==2 || t>4){															// p̈ʒu␳
		s = 3;
	}else{
		s = 0;
	}
	for (i=0; i<6 ;i++){
		for (j=0; j<13 ;j++){
			key[0] = gKeyTable1[t][(j*6+i)*2];
			key[1] = gKeyTable1[t][(j*6+i)*2+1];								// L[}bvꕶo
			mh_print( KBPOSX1 +1 +2 + j*16 +s, gPage+KBPOSY1 +15 +2 + i*16, key, CORWCHR );
		}
	}
	if (t==6){
		mh_print( KBPOSX1 +1 +2 + 12*16-4 , gPage+KBPOSY1 +15 +2 + 1*16, "Ret", CORSCHR );
		mh_print( KBPOSX1 +1 +2 + 12*16-1 , gPage+KBPOSY1 +15 +2 + 2*16, "BS", CORSCHR );
		mh_print( KBPOSX1 +1 +2 + 12*16-4 , gPage+KBPOSY1 +15 +2 + 3*16, "Del", CORSCHR );
		mh_print( KBPOSX1 +1 +2 + 12*16-4 , gPage+KBPOSY1 +15 +2 + 4*16, "Tab", CORSCHR );
	}
	mh_print( KBPOSX1 +1 +2 + 12*16 , gPage+KBPOSY1 +15 +2 + 5*16, "SP", CORSCHR );
}


//==============================================================
// \tgEFAL[{[h̕\i~Tȕϊj
//--------------------------------------------------------------
// xy}CiXꍇ̓J[\͕\܂B
//--------------------------------------------------------------

static void DrawKey3(int x,int y,int t)
{
	char key[3] = "  ";
	int i,j,k,s;
	int map[5][2] = {{1,0} , {0,1} , {1,1} , {2,1} , {1,2} };

	DrawWindow( gKeyName1[t],KBPOSX3,KBPOSY3,261,127 );						// EBhEt[
	BoxFill(KBPOSX3 +1, gPage+KBPOSY3 +15, 261 -2, 112, CORFL1, CORIN);		// 
	for (i=0; i<3 ;i++){													// r
		HLine(KBPOSX3 +1       , gPage+KBPOSY3 +15 + i*37, 261 -2, CORFL1);
	}
	for (i=0; i<6 ;i++){
		VLine(KBPOSX3 +1 + i*43, gPage+KBPOSY3 +15       , 112, CORFL1);
	}
	if (x>=0 && y>=0)
		BoxFill(KBPOSX3 +1 + x*43, gPage+KBPOSY3 +15 + y*37, 44, 38, CORFL1, CORCUR);

	if (t==2 || t>4){														// p̈ʒu␳
		s = 3;
	}else{
		s = 0;
	}

	for (i=0; i<3 ;i++){													// \tgEFAL[{[h
		for (j=0; j<6 ;j++){
			for (k=0; k<5 ;k++){
				key[0] = gKeyTable3[t][(i*30+j*5+k)*2];
				key[1] = gKeyTable3[t][(i*30+j*5+k)*2+1];					// L[}bvꕶo
				mh_print(KBPOSX3 +1 + j*43 + map[k][0]*13+3 +s, gPage+KBPOSY3 +15 + i*37 + map[k][1]*12+1, key, CORWCHR);
			}
		}
	}
	if (t==0){
		mh_print(KBPOSX3 +1 +4*43 +2 +27, gPage+KBPOSY3 +15 +2*37+1*12+1, "", CORSCHR);
	}
	mh_print(KBPOSX3 +1 +5*43 +2 +12, gPage+KBPOSY3 +15 +2*37+0*12+1, "Tab", CORSCHR);
	mh_print(KBPOSX3 +1 +5*43 +2    , gPage+KBPOSY3 +15 +2*37+1*12+1, "BS", CORSCHR);
	mh_print(KBPOSX3 +1 +5*43 +2 +24, gPage+KBPOSY3 +15 +2*37+1*12+1, "Ret", CORSCHR);
	mh_print(KBPOSX3 +1 +5*43 +2 + 6, gPage+KBPOSY3 +15 +2*37+2*12+1, "space", CORSCHR);
}


//==============================================================
// ϊC̈ʒu
//--------------------------------------------------------------
// gCx,gCyŎw肳ĂJ[\ʒuɕϊCWJꍇ̎ۂ̍WƃTCYvZB
// ʒ[\tgL[ƂԂȂJnʒuCB
//--------------------------------------------------------------

static void InLinePos(char *str,int *x,int *wx)
{
	int		cx,cy;

	if (gKey==2){
		cx = KBPOSX3;
		cy = KBPOSY3;
	} else {
		cx = KBPOSX1;
		cy = KBPOSY1;
	}

	*wx = GetStrWidth( gFont,str );
	*x = gCx;
	if (*x+*wx>480) *x = 480 - *wx;								// ʂ͂ݏoȂJnʒu炷
	if (gCy+gCyw>cy && gMode==1){								// \tgL[ƏdȂȂJnʒu炷
		if (*x+*wx>cx) *x = cx - *wx -gCxw;
	}
}


//==============================================================
// ϊC̕\
//--------------------------------------------------------------
// blk ϊΏۂ̕
//--------------------------------------------------------------
// gCx,gCyŎw肳ĂJ[\ʒuɕϊC̕\sB
// \tgL[Ɋ|Ȃ悤Ɉʒu␳܂B
// blkŎw肳ꂽ擪̔wiFς܂B
//--------------------------------------------------------------

static void InLine(char *str,int blk)
{
	char	buf[64];
	int	x,wx,wx1,wx2,blkLen;

	InLinePos( str,&x,&wx );									// ϊCʒu
	if (wx){
		strncpy( buf,str,blk );
		buf[blk] = '\0';
		blkLen = GetStrWidth( gFont,buf );
		if (blkLen >= wx){
			wx1 = wx;
			wx2 = 0;
		} else {
			wx1 = blkLen;
			wx2 = wx - wx1;
		}
		if (wx1){
			BoxFill( x,gPage+gCy,wx1,gCyw,CORCHCU,CORCHCU );	// wiiϊʁj
		}
		if (wx2){
			BoxFill( x+wx1,gPage+gCy,wx2,gCyw,CORCHBK,CORCHBK );	// wiiϊʁj
		}
		pf_print2( x,gPage+gCy,gFont,str,CORCHCR );				// ϊC
	}
}


//==============================================================
// ϊC̔wȋҔ
//--------------------------------------------------------------

static void getInLine(char *str)
{
	int	x,wx;

	if (gBDFlag) return;

	if (gInLnBuf){												// obt@
		DrawImgFree(gInLnBuf);
		gInLnBuf = NULL;
	}

	InLinePos( str,&x,&wx );									// ϊCʒu
	gInLnBuf = DrawImgCreate( wx,16 );
	gInLnBufP.x = x;
	gInLnBufP.y = gCy;
	BoxCopy( gInLnBuf, gInLnBufP.x, gPage+gInLnBufP.y );
}


//==============================================================
// ϊC̔wi̕
//--------------------------------------------------------------

static void putInLine(void)
{
	if (gBDFlag) return;

	BoxPaste( gInLnBuf, gInLnBufP.x, gPage+gInLnBufP.y );
}


//==============================================================
// J[\̍
//--------------------------------------------------------------

static void DrawCursorSub()
{
	int x,cx,cy;

	if (gCxw==0 || gCyw==0) return;								// J[\̑傫0

	if (gKey==2){												// \tgL[̈ʒu
		cx = KBPOSX3;
		cy = KBPOSY3;
	} else {
		cx = KBPOSX1;
		cy = KBPOSY1;
	}

	x = gCx;
	if (gCy+gCyw>cy && gMode==1){								// \tgL[ƏdȂȂJnʒu炷
		if (x+gCxw>cx) x = cx - gCxw;
	}

	XFill( x, gPage+gCy, gCxw, gCyw, 0xFFFFFF );
}


//==============================================================
// J[\\
//--------------------------------------------------------------
// ch -1  FEBhEnƃJ[\
//    0   FJ[\_ł
//    ȊOFJ[\/\Ȃ
//--------------------------------------------------------------
// SIMEgetchar()P̂ł̓J[\\sȂ߁AJ[\\ꍇ
// ɂgpB
// )
//   ch = SIMEgetchar(pad1);
//   SIMEDrawCursor(ch);
//
// ܂AL[Ƃ͕ʂɃEBhE̕\nꍇ-1w肷B
//--------------------------------------------------------------

void SIMEDrawCursor(int ch)
{
	static int bk = 0,count = 0;

	if (ch==-1 && gMode){										// EBhEn
		putBack();
		if (gCount){
			putkList();
		}
		putInLine();
		gGetFlag = 1;
	}

	if (ch){
		if (bk && !gBDFlag) DrawCursorSub();					// L[͂J[\
		bk = 0;
		count = CBTIME;											// ͒\
	} else {
		count++;
		if (count>CBTIME){										// J[\_Ŏ
			count = 0;
			bk ^= 1;
		}
		if (gBDFlag){
			if (bk) DrawCursorSub();
		} else {
			if (!count) DrawCursorSub();
		}
	}
}


//==============================================================
// ړ[h̏
//--------------------------------------------------------------

static void move(char *str,SceCtrlData pad1)
{
	int		ch;

	ch = SIMEgetchar(pad1);
	SIMEDrawCursor(ch);											// J[\̍
	if (ch==0x02){												//  i\tgL[[hցj
		ch = 0;
		gMode = 3;												// \tgL[[hJڏ
	} else {
		str[0] = ch;
		str[1] = 0;
	}
}


//==============================================================
// VtgJIS̑P`FbN
//--------------------------------------------------------------
// ߂l  0:Pł͂Ȃ
//        -1:Pł
//--------------------------------------------------------------

int chkSJIS(unsigned char cr)
{
	if (cr<0x80U || (cr>=0xA0U && cr<0xE0U) || cr>=0xFDU){
		return (0);
	} else {
		return (-1);
	}
}


//==============================================================
// ̓CfbNX擾
//--------------------------------------------------------------
// ͓ƂɌQ𕪊i85ɕjĊǗĂ܂B
//i{A[U[ƂɁj
// w肳ꂽǂ̌QɑΉ邩𒲂ׂ܂B
//--------------------------------------------------------------

static int dicIndex(char *str)
{
	unsigned int	cr;
	int				hp;

	if (chkSJIS(str[0])){										// 擪SpȂ
		cr = fcode(str);										// 擪
		if (cr<0x8200U){										// LȂ
			hp = 0;
		} else if (cr<0x829FU){									// ƃAt@xbg
			hp = -3;
		} else if (cr<0x82F2U){									// Ђ炪ȂȂ
			hp = cr - 0x829FU +1;
		} else if (cr==0x8394U){								// uv
			hp = 84;
		} else {
			hp = -1;											// sȂ
		}
	} else {													// 擪pȂ
		hp = -2;
	}
	return (hp);
}


//==============================================================
// [U[
//--------------------------------------------------------------
// count    P̐
// wordList PꃊXgichar wordList[50][2][33]̔zw肷邱Ɓj
// ߂l   count   :PꃊXǧiP`j
//          wordList:PꃊXg
//--------------------------------------------------------------
// gStƎ́u݁vrAsvoȂƂB
//--------------------------------------------------------------

static void setUserKanji(char wordList[][2][33],int *count)
{
	struct strUsDic	*usdic;
	int		hp,pos;

	hp = dicIndex( gSt );										// ̓CfbNX擾
	if (hp<0) return;											// o^ΏۊOȂ̂ŏI
	if (gUsDic[hp]==NULL) return;								// o^Ăuv̂ŏI

	usdic = gUsDic[hp];
	do{
		pos = 0;
		while (gSt[pos]!='\0'){
			if (gSt[pos]!=usdic->yomi[pos]) break;
			pos++;
		}
		if (gSt[pos]=='\0'){									// uv
			strcpy( wordList[(*count)  ][0],usdic->yomi );		// u݁vŗD揇ʂւ鎞Ɏgp
			strcpy( wordList[(*count)++][1],usdic->kouho );		// uv
		}
		usdic = usdic->chain;
	}while (usdic && *count<KMAX-1);
}


//==============================================================
// [U[Ɍǉ
//--------------------------------------------------------------
// [U[́u݁vuPvPZbgɂĒP`FC\ŊǗĂ܂B
// u݁v̓ƂɌQ𕪊Č̎ԂȂĂ܂B
// 擾oȂꍇ͉܂B
// ǉꂽ/ǉ悤Ƃ͐擪ʒuɒûŁAϊɂ͂悭g
// قǑO̕ɗ܂B
//--------------------------------------------------------------

//----- [U[ɒǉ -----

static void dicAddSub(int hp,char *yomi,char *kouho,struct strUsDic *usdic)
{
	struct strUsDic	*usdic2;

	usdic2 = (struct strUsDic*) malloc( sizeof(struct strUsDic) );
	if (usdic2){												// 擾oȂ
		usdic2->chain = usdic;
		strcpy( usdic2->yomi,yomi );
		strcpy( usdic2->kouho,kouho );
		gUsDic[hp] = usdic2;
	}
	gUSaveFlag = -1;											// [U[ɕω
}

//----- C -----

static void dicAdd(char *yomi,char *kouho)
{
	struct strUsDic	*usdic,*usdic2;
	int		hp,flag;

	hp = dicIndex( yomi );										// ̓CfbNX擾
	if (hp<0) return;											// o^ΏۊOȂ̂ŏI

	if (gUsDic[hp]==NULL){										// ɑΉuvQ̂ŐVKǉ
		dicAddSub( hp, yomi, kouho, NULL );						// uvQ͂ŏI
	} else {													// ɑΉuvQLꍇ
		usdic = gUsDic[hp];
		usdic2 = NULL;
		flag = 0;
		do{
			if (strcmp(usdic->yomi,yomi)==0 && strcmp(usdic->kouho,kouho)==0){
				flag = 1;										// ɓo^ς݂
				break;
			}
			usdic2 = usdic;
			usdic = usdic->chain;								// ́uv
		}while (usdic);
		if (flag){												// o^ς݁uv擪ʒuɈړ
			if (usdic2){										// uvȂꍇ͉Ȃ
				usdic2->chain = usdic->chain;
				usdic2 = gUsDic[hp];
				gUsDic[hp] = usdic;
				usdic->chain = usdic2;
				gUSaveFlag = -1;								// [U[ɕω
			}
		} else {												// Vuv擪ʒuɒǉ
			if (!gUDicAdd){										// ǉݒȂ
				dicAddSub( hp,yomi, kouho, gUsDic[hp] );
			}
		}
	}
}


//==============================================================
// [U[폜
//--------------------------------------------------------------
// w肳ꂽu݁vuv̑gݍ킹Ȃ͉܂B
//--------------------------------------------------------------

static void dicDel(char *yomi,char *kouho)
{
	struct strUsDic	*usdic,*usdic2;
	int		hp,flag;

	hp = dicIndex( yomi );										// ̓CfbNX擾
	if (hp<0) return;											// o^ΏۊOȂ̂ŏI

	if (gUsDic[hp]){
		usdic = gUsDic[hp];
		usdic2 = NULL;
		flag = 0;
		do{
			if (strcmp(usdic->yomi,yomi)==0 && strcmp(usdic->kouho,kouho)==0){
				flag = 1;
				break;
			}
			usdic2 = usdic;
			usdic = usdic->chain;								// ́uv
		}while (usdic);
		if (flag){												// ړÍuv𔭌
			if (usdic2){										// QԖڈȍ~̏ꍇ
				usdic2->chain = usdic->chain;
			} else {											// ŏ̈ڂ̏ꍇ
				gUsDic[hp] = usdic->chain;
			}
			free(usdic);
			gUSaveFlag = -1;									// [U[ɕω
		}
	}
}


//==============================================================
// ͕̓𒲂ׂ
//--------------------------------------------------------------
// ߂l                 ̐
// str[4][3]              ɎgpĂpxʂQ̕ƏꍇɂẮuJv
// wordList[KMAX][2][33] u݁v⃊Xg
// count                  u݁v⃊XǧiőKMAXj
//--------------------------------------------------------------
// ܂łɕϊsɓ͂ꂽɎ𒲂ׂē͒Ǝv̌
// 擾͂̃AVXgsB
// Ђ炪Ȃ̓͒̏ꍇɂ̂ݓ삵܂B
// ݂̂Ɏgpx̍ʂQ́uȁvIA܂Oɓ͂
// uȁvɑt\ȂXɁuJvI܂B
//--------------------------------------------------------------

static int nextChr(char str[][3],char wordList[][2][33],int *count)
{
	char	sTbl1[] = "ĂƂ͂Ђӂւ",
			sTbl2[] = "Âłǂ΂тԂׂ",
			sTbl3[] = "ς҂Ղ؂";
	unsigned int	cr,p[2];
	int		i,hp,sp,sp2,tmp,max[2],len,crCnt,cc[85];
	long	pos;

	cr = 0;

	if (chkSJIS(gSt[0])){										// 擪SpȂ
		cr = fcode(&gSt[0]);									// 擪
		if (cr<0x829FU){										// LAApȂ
			return (0);
		} else if (cr<0x82F2U){									// Ђ炪ȂȂ
			hp = cr - 0x829FU +1;
		} else if (cr==0x8394U){								// uv
			return (0);
		} else {
			return (0);											// sȂ
		}
	} else {													// 擪pȂ
		return (0);
	}

	pos = gHEDtbl[hp];											// ɑΉ鎫R[h̊Jnʒu
	if (pos==0xFFFFFFFF) return (0);							// ɓo^Ȃ

	pos += 2;
	sp2 = 0;
	len = strlen(gSt);
	for (i=0; i<85 ;i++){
		cc[i] = 0;
	}
	while(1){
		sp = 0;
		while (gDic[pos+sp]!=0){								// ݂ɑΉP茟
			if (gDic[pos+sp]!=gSt[sp]) break;
			sp++;
			if (sp==len) break;
		}
		if (sp==len){
			if (*count<KMAX){									// u݁v⃊Xg̎擾
				wordList[*count][0][0] = '\0';					// {Ȃ̂Łu݁v͎gȂ
				strcpy( wordList[*count][1],&gDic[pos] );		// uv
				(*count)++;
			}
			cr = fcode(&gDic[pos+sp]);
			if (cr==0x815B){									// u[v
				cr = 84;
			} else {
				cr -= 0x829F;
			}
			if (cr<85) cc[cr]++;								// ̊̕YJEg
		}
		if (sp<sp2){											// v镶OZȂTI
			break;
		}
		sp2 = sp;
		tmp = getInt(&gDic[pos-2]);								// ̒Pւ̑΋iintj
		if (tmp==0xFFFF) break;									// ITI
		pos += tmp;
	}

	max[0] = max[1] = 0;
	for (i=0; i<85 ;i++){										// opx̍QT
		if (cc[i]>=max[0]){
			max[1] = max[0];
			p[1] = p[0];
			max[0] = cc[i];
			p[0] = i;
		}
	}
	crCnt = 0;
	for (i=0; i<2 ;i++){
		if (max[i]){
			if (p[i]<84){
				p[i] += 0x829F;
			} else {
				p[i] = 0x815B;									// u[v
			}
			str[i][0] = p[i] / 0x100;
			str[i][1] = p[i] & 0xFF;
			str[i][2] = '\0';
			if (strstr( sTbl2,str[i] )!=NULL){					// uvuvϊ
				str[i][1]--;
			}
			if (strstr( sTbl3,str[i] )!=NULL){					// uρvúvϊ
				str[i][1] -= 2;
			}
			crCnt++;
		}
	}

	if (len>=2){
		len -= 2;												// ϊsŌ̕
		if (strstr( sTbl1,&gSt[len] )!=NULL){					// OƂt͂ĂȂ
			str[crCnt][0] = 0x81;
			str[crCnt][1] = 0x4A;								// uJv
			str[crCnt][2] = '\0';
			crCnt++;
		}
	}

	return (crCnt);
}


//==============================================================
// J[\w蕶ʒuɈړ
//--------------------------------------------------------------
// reset J[\ʒȕC 0:̓AVXg 1:tH[[VZbg 2:AVXgȂ
//--------------------------------------------------------------
// AVXgJ[\pB
// ϊTAJ[\ʒũAVXgsB
//--------------------------------------------------------------

static void setCur(int *x,int *y,int bt,int *xx,int *yy,int reset,char wordList[][2][33],int *count)
{
	static int lock = 0;
	char	nchr[4][3];
	int		i,j,pos,flag,crCnt,zx,zy;
	int		dx[3] = {0,4,9},dy[3] = {0,2,4};

	for (i=0; i<3 ;i++){										// ړۊ
		xx[i] = x[i];
		yy[i] = y[i];
	}
	if (lock || reset){											// J[\tH[[ṼZbg
		zx = x[bt];
		zy = y[bt];
		for (i=0; i<3 ;i++){
			x[bt] = zx + dx[i];
			if (x[bt]>12) x[bt] -= 13;
			y[bt] = zy + dy[i];
			if (y[bt]>5) y[bt] -= 6;
			bt++;
			if (bt>2) bt = 0;
		}
		lock = 0;
	}

	*count = 0;
	if (!gUSave){
		setUserKanji( wordList,count );							// [U[
	}
	crCnt = nextChr( nchr,wordList,count );						// ͕̓𒲂ׂ
	if (crCnt){													// ₪Ȃ
		for (j=0; j<crCnt ;j++){
			pos = -1;
			for (i=0; i<78 ;i++)
				if (gKeyTable1[0][i*2]==nchr[j][0] && gKeyTable1[0][i*2+1]==nchr[j][1]){
					pos = i;									// ̈ʒu
					break;
				}
			if (pos!=-1){										// ʒuΉWɕϊ
				zx = pos / 6;
				zy = pos % 6;
				flag = 1;
				for (i=0; i<3 ;i++){							// d`FbN
					if (x[i]==zx && y[i]==zy) flag = 0;
				}
				if (flag && !reset){							// dĂȂȂ
					x[bt] = zx;
					y[bt] = zy;
				}
				bt++;
				if (bt>2) bt = 0;
			}
		}
		lock = 1;
	}
}


//==============================================================
// ϊsɕǉ
//--------------------------------------------------------------
// ǉ邾ł͂ȂA̕tȂǂĂ܂B
//--------------------------------------------------------------

static void addInline(char *str,char *si,int t)
{
	char	sdt[] = "ĂƂ͂ЂӂւكJLNPRTVXZ\\^`cegnqtwz",	// uJvt
			sht[] = "͂Ђӂւكnqtwz";																	// uKvt
	char	cr[3] = "  ";
	int		pos,len;

	if (!chkSJIS(si[0])) si[1] = '\0';
	if (gSt[0]!=0){												// Qڈȍ~
		putInLine();											// ϊCwi𕜌
		pos = strlen(gSt) - 2;
		cr[0] = gSt[pos];
		cr[1] = gSt[pos+1];
		if (strcmp( si,"J" )==0){
			if ((unsigned char)cr[0]==0x83 &&
			    (unsigned char)cr[1]==0x45){					//uEvuvϊ
				gSt[pos+1] = 0x94;
				si[0] = 0;
				si[1] = 0;
			} else {
				if (strstr( sdt,cr )!=NULL){					// uJv̕tȂO̕C
					gSt[pos+1]++;
					si[0] = 0;
					si[1] = 0;
				}
			}
		}else if (strcmp( si,"K" )==0){
			if (strstr( sht,cr )!=NULL){						// uKv̕tȂO̕C
				gSt[pos+1] += 2;
				si[0] = 0;
				si[1] = 0;
			}
		}
	} else {													// P
		if (t==2 || t>4 || si[0]==0x7F || (unsigned char)si[0]<32){	// p̏ꍇ
			str[0] = si[0];										// ̂܂܏o
			str[1] = 0;
			si[0] = 0;
		}
	}

	if (si[1]){													// Spǉꍇ
		len = CHLEN -2;
	} else {													// pǉꍇ
		len = CHLEN -1;
	}
	if (strlen(gSt)<=len){										// ϊC
		strcat( gSt,si );										// ǉ
		getInLine(gSt);											// ϊCwi̎擾
	}
}


//==============================================================
// \tgL[[h̏iTOzAVXgJ[\j
//--------------------------------------------------------------

static void softkey1(char *str,SceCtrlData pad1)
{
	static char	wordList[KMAX][2][33];
	static int	t = 0,bt = 0,pc = 0,index = 0,
				x[3] = {0,4,9},y[3] = {1,3,5},xx[3],yy[3];
	int		i,p,s,ch,fp,pos;
	char	si[3];

	fp = 0;														// ʂɕύX
	si[2] = 0;

	ch = SIMEgetchar(pad1);
	if (!strlen(gSt)){
		if (ch==0 || ch>=32 || ch==0x02 || ch==0x08 || ch==0x0D || ch==0x1B){
			SIMEDrawCursor(ch);									// J[\\
		}
	}
	switch (ch){
	case 0x03:													// L
		break;
	case 0x04:													// R
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			t++;												// ύX
			if (t>6) t = 0;
		} else {
			setCur( x,y,bt,xx,yy,1,wordList,&gCount );			// J[\tH[[VftHg
			pc = CURSTEP;
		}
		break;
	case 0x06:													// [SELECT]
		t--;													// ύX
		if (t<0) t = 6;
		break;
	case 0x05:													// [START]
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gCount){
				if (strlen(wordList[index][0])){				// [L]+[START] [U[獀ڂ폜
					dicDel( wordList[index][0], wordList[index][1] );
					si[0] = '\0';
					si[1] = '\0';
					fp = 1;
				}
			}
		} else {
			if (gSt[0]!=0){
				putInLine();									// ϊCU
				if (gCount){
					putkList();
				}
			}
			gCount = 0;
			gMode = 5;											// ݒʂ
		}
		break;
	case 0x02:													// 
		setCur( x,y,bt,xx,yy,1,wordList,&gCount );				// J[\tH[[VftHg
		pc = CURSTEP;
		if (gCount){
			putkList();
		}
		gCount = 0;
		if (gSt[0]==0){
			gMode = 0;
		} else {
			putInLine();										// ϊCU
			gMode = 2;											// ϊ
			strcpy( gYomi,gSt );								// wKpɁu݁vۊǂĂ
			gKouho[0] = '\0';									// wKpuvNAĂ
		}
		break;
	case 0x08:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]!=0){
				putInLine();									// ϊCwi𕜌
				if (gCount){
					putkList();
				}
				pos = strlen(gSt);
				pos--;
				p = 0;
				while (1){										// Sp␳
					s = 1 -chkSJIS(gSt[p]);
					if (p+s>pos) break;
					p += s;
				}
				gSt[p] = 0;
				if (s==2) gSt[p+1] = 0;
				getInLine(gSt);									// ϊCwi擾
				if (t==0){
					setCur( x,y,bt,xx,yy,0,wordList,&gCount );	// J[\̕ʒu
				} else {
					setCur( x,y,bt,xx,yy,1,wordList,&gCount );	// J[\̕ʒu
				}
				index = 0;
				getkList( wordList,gCount );
			} else {
				str[0] = ch;									// obNXy[Xo
				SIMEDrawCursor(ch);
			}
		} else {
			si[0] = gKeyTable1[t][(x[1]*6+y[1]) *2];
			si[1] = gKeyTable1[t][(x[1]*6+y[1]) *2+1];
			bt = 1;
			fp = 1;
		}
		break;
	case 0x0D:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gCount==0){
				setCur( x,y,bt,xx,yy,1,wordList,&gCount );		// J[\tH[[VftHg
				pc = CURSTEP;
				if (gCount){
					putkList();
				}
				gCount = 0;
				if (gSt[0]==0){
					str[0] = ch;								// [Enter]o
					SIMEDrawCursor(ch);
				} else {
					putInLine();								// ϊCwi𕜌
					for (i=0; i<CHLEN ;i++){
						str[i] = gSt[i];
						gSt[i] = 0;
					}
				}
			} else {
				if (gCount && gCount<=YOMILMAX){
					putInLine();								// ϊCwi𕜌
					putkList();
					strcpy( str,wordList[index][1] );
					if (strlen(wordList[index][0])){			// [U[LڌȂ
						dicAdd( wordList[index][0], wordList[index][1] );	// LڈʒuŏɈړ
					}
					gSt[0] = '\0';
					gCount = 0;
				}
			}
		} else {
			si[0] = gKeyTable1[t][(x[0]*6+y[0]) *2];
			si[1] = gKeyTable1[t][(x[0]*6+y[0]) *2+1];
			bt = 0;
			fp = 1;
		}
		break;
	case 0x1B:													// ~
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			setCur( x,y,bt,xx,yy,1,wordList,&gCount );			// J[\tH[[VftHg
			pc = CURSTEP;
			if (gCount){
				putkList();
			}
			gCount = 0;
			if (gSt[0]==0){
				gMode = 0;
			} else {
				putInLine();									// ϊCwi𕜌
				for (i=0; i<CHLEN ;i++){
					gSt[i] = 0;
				}
			}
		} else {
			si[0] = gKeyTable1[t][(x[2]*6+y[2]) *2];
			si[1] = gKeyTable1[t][(x[2]*6+y[2]) *2+1];
			bt = 2;
			fp = 1;
		}
		break;
	case 0x1C:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				str[0] = ch;
				SIMEDrawCursor(ch);
			} else {
				if (gCount && gCount<=YOMILMAX){
					putInLine();								// ϊCwi𕜌
					putkList();
					strcpy( gSt,wordList[index][1] );
					getInLine(gSt);								// ϊCwi擾
					gCount = 0;
				}
			}
		} else {
			for (i=0; i<3 ;i++){
				x[i]++;
				if (x[i]>12) x[i] = 0;
			}
		}
		break;
	case 0x1D:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				str[0] = ch;
				SIMEDrawCursor(ch);
			}
		} else {
			for (i=0; i<3 ;i++){
				x[i]--;
				if (x[i]<0) x[i] = 12;
			}
		}
		break;
	case 0x1E:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				str[0] = ch;
				SIMEDrawCursor(ch);
			} else {
				if (gCount){
					index--;
					if (index<0) index = gCount -1;
				}
			}
		} else {
			for (i=0; i<3 ;i++){
				y[i]--;
				if (y[i]<0) y[i] = 5;
			}
		}
		break;
	case 0x1F:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				str[0] = ch;
				SIMEDrawCursor(ch);
			} else {
				if (gCount){
					index++;
					if (index>gCount-1) index = 0;
				}
			}
		} else {
			for (i=0; i<3 ;i++){
				y[i]++;
				if (y[i]>5) y[i] = 0;
			}
		}
		break;
	default:													// ̑i̒ړ́Hj
		if (ch>=32){
			si[0] = ch;
			fp = 1;
		}
		break;
	}

	if (fp){													// ϊsɒǉ
		if (gCount){
			putkList();
		}
		addInline( str,si,t );
		if (pad1.Buttons & PSP_CTRL_RTRIGGER || gKey==1){		// [R]Ă邩AVXgOFFȂ
			setCur( x,y,bt,xx,yy,2,wordList,&gCount );			// J[\ʒu͂̂܂
		} else {
			setCur( x,y,bt,xx,yy,0,wordList,&gCount );			// J[\̕ʒu
		}
		getkList( wordList,gCount );
		pc = CURSTEP;
		index = 0;
	}

	if (str[0]){												// o͂ꍇ̓EBhEꎞIɏ
		putBack();
		if (gCount){
			putkList();
		}
		gGetFlag = 1;
	} else {
		if (gGetFlag){											// OEBhEĂiCō悵Ă邩jȂwiĎ擾
			getBack();
			getkList( wordList,gCount );
			getInLine(gSt);										// ϊCwi擾
			gGetFlag = 0;
		}
		if (gMode==1){											// [hɑJڂƂ͎sȂ
			InLine( gSt,0 );									// ϊC\
			if (pad1.Buttons & PSP_CTRL_LTRIGGER){
				if (gCount<=YOMILMAX){
					kList( wordList,gCount,index );				// uȁv⃊Xg\
				}
				DrawKey1( NULL,NULL,t,xx,yy,pc );				// \tgL[\
			} else {
				if (gCount<=YOMILMAX){
					kList( wordList,gCount,-1 );				// uȁv⃊Xg\
				}
				DrawKey1( x,y,t,xx,yy,pc );						// \tgL[\
			}
			pc--;
			if (pc<0) pc = 0;
		} else {
			putBack();											// \tgL[
			if (gCount){
				putkList();
			}
		}
	}
}


//==============================================================
// \tgL[[h̏i~TȔzj
//--------------------------------------------------------------

static void softkey3(char *str,SceCtrlData pad1)
{
	static char	wordList[KMAX][2][33];
	static int	x = 0,y = 0,t = 0,index = 0,
				xd[4],yd[4],xx[4],yy[4];
	int		i,p,s,ch,fp,pos;
	char	si[3];

	fp = 0;														// ʂɕύX
	si[2] = 0;

	ch = SIMEgetchar(pad1);
	if (!strlen(gSt)){
		if (ch==0 || ch>=32 || ch==0x02 || ch==0x08 || ch==0x0D || ch==0x1B){
			SIMEDrawCursor(ch);										// J[\\
		}
	}
	switch (ch){												// J[\L[
	case 0x02:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gCount){
				putkList();
			}
			gCount = 0;
			if (gSt[0]==0){
				gMode = 0;
			} else {
				putInLine();									// ϊCU
				strcpy( gYomi,gSt );							// wKpɁu݁vۊǂĂ
				gKouho[0] = '\0';								// wKpuvNAĂ
				gMode = 2;
			}
		} else {
			si[0] = gKeyTable3[t][(y*30+x*5+0) *2];
			si[1] = gKeyTable3[t][(y*30+x*5+0) *2+1];
			fp = 1;
		}
		break;
	case 0x04:													// R
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			t++;												// ύX
			if (t>6) t = 0;
		} else {
			si[0] = gKeyTable3[t][(y*30+x*5+2) *2];
			si[1] = gKeyTable3[t][(y*30+x*5+2) *2+1];
			fp = 1;
		}
		break;
	case 0x06:													// [SELECT]
		t--;													// ύX
		if (t<0) t = 6;
		break;
	case 0x05:													// [START]
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gCount){
				if (strlen(wordList[index][0])){				// [L]+[START] [U[獀ڂ폜
					dicDel( wordList[index][0], wordList[index][1] );
					si[0] = '\0';
					si[1] = '\0';
					fp = 1;
				}
			}
		} else {
			if (gSt[0]!=0){
				putInLine();									// ϊCU
				if (gCount){
					putkList();
				}
			}
			gCount = 0;
			gMode = 5;											// ݒʂ
		}
		break;
	case 0x08:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER || gKeyTable3[t][(y*30+x*5+1) *2]=='\b'){
			if (gSt[0]!=0){
				putInLine();									// ϊCwi𕜌
				if (gCount){
					putkList();
				}
				pos = strlen(gSt);
				pos--;
				p = 0;
				while (1){										// Sp␳
					s = 1 -chkSJIS(gSt[p]);
					if (p+s>pos) break;
					p += s;
				}
				gSt[p] = 0;
				if (s==2) gSt[p+1] = 0;
				getInLine(gSt);									// ϊCwi擾
				if (t==0){
					setCur( xd,yd,0,xx,yy,0,wordList,&gCount );	// J[\̕ʒu
				} else {
					setCur( xd,yd,0,xx,yy,1,wordList,&gCount );	// J[\̕ʒu
				}
				index = 0;
				getkList( wordList,gCount );
			} else {
				str[0] = ch;									// obNXy[Xo
				SIMEDrawCursor(ch);
			}
		} else {
			si[0] = gKeyTable3[t][(y*30+x*5+1) *2];
			si[1] = gKeyTable3[t][(y*30+x*5+1) *2+1];
			fp = 1;
		}
		break;
	case 0x0D:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER || gKeyTable3[t][(y*30+x*5+3) *2]=='\r'){
			if (gCount==0){
				if (gCount){
					putkList();
				}
				gCount = 0;
				if (gSt[0]==0){
					str[0] = ch;								// [Enter]o
					SIMEDrawCursor(ch);
				} else {
					putInLine();								// ϊCwi𕜌
					for (i=0; i<CHLEN ;i++){
						str[i] = gSt[i];
						gSt[i] = 0;
					}
				}
			} else {
				if (gCount && gCount<=YOMILMAX){
					putInLine();								// ϊCwi𕜌
					putkList();
					strcpy( str,wordList[index][1] );
					if (strlen(wordList[index][0])){			// [U[LڌȂ
						dicAdd( wordList[index][0], wordList[index][1] );	// LڈʒuŏɈړ
					}
					gSt[0] = '\0';
					gCount = 0;
				}
			}
		} else {
			si[0] = gKeyTable3[t][(y*30+x*5+3) *2];
			si[1] = gKeyTable3[t][(y*30+x*5+3) *2+1];
			fp = 1;
		}
		break;
	case 0x1B:													// ~
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gCount){
				putkList();
			}
			gCount = 0;
			if (gSt[0]==0){
				gMode = 0;
			} else {
				putInLine();									// ϊCwi𕜌
				for (i=0; i<CHLEN ;i++){
					gSt[i] = 0;
				}
			}
		} else {
			si[0] = gKeyTable3[t][(y*30+x*5+4) *2];
			si[1] = gKeyTable3[t][(y*30+x*5+4) *2+1];
			fp = 1;
		}
		break;
	case 0x1C:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				str[0] = ch;
				SIMEDrawCursor(ch);
			} else {
				if (gCount && gCount<=YOMILMAX){
					putInLine();								// ϊCwi𕜌
					putkList();
					strcpy( gSt,wordList[index][1] );
					getInLine(gSt);								// ϊCwi擾
					gCount = 0;
				}
			}
		} else {
			x++;
			if (x>5) x = 0;
		}
		break;
	case 0x1D:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				str[0] = ch;
				SIMEDrawCursor(ch);
			}
		} else {
			x--;
			if (x<0) x = 5;
		}
		break;
	case 0x1E:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				str[0] = ch;
				SIMEDrawCursor(ch);
			} else {
				if (gCount){
					index--;
					if (index<0) index = gCount -1;
				}
			}
		} else {
			y--;
			if (y<0) y = 2;
		}
		break;
	case 0x1F:													// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				str[0] = ch;
				SIMEDrawCursor(ch);
			} else {
				if (gCount){
					index++;
					if (index>gCount-1) index = 0;
				}
			}
		} else {
			y++;
			if (y>2) y = 0;
		}
		break;
	default:													// ̑i̒ړ́Hj
		if (ch>=32){
			si[0] = ch;
			fp = 1;
		}
		break;
	}

	if (fp){													// ϊsɒǉ
		if (strcmp(si,"")==0){								// ϊJn
			if (gCount){
				putkList();
			}
			gCount = 0;
			if (gSt[0]==0){
				gMode = 0;
			} else {
				putInLine();									// ϊCU
				strcpy( gYomi,gSt );							// wKpɁu݁vۊǂĂ
				gKouho[0] = '\0';								// wKpuvNAĂ
				gMode = 2;
			}
		} else {
			if (gCount){
				putkList();
			}
			addInline( str,si,t );
			setCur( xd,yd,0,xx,yy,0,wordList,&gCount );			// u݁v⃊Xg̎擾̂ݎgp
			getkList( wordList,gCount );
			index = 0;
		}
	}

	if (str[0]){												// o͂ꍇ̓EBhEꎞIɏ
		putBack();
		if (gCount){
			putkList();
		}
		gGetFlag = 1;
	} else {
		if (gGetFlag){											// OEBhEĂȂwiĎ擾
			getBack();
			getkList( wordList,gCount );
			getInLine(gSt);										// ϊCwi擾
			gGetFlag = 0;
		}
		if (gMode==1){											// [hɑJڂƂ͎sȂ
			InLine( gSt,0 );									// ϊC\
			if (pad1.Buttons & PSP_CTRL_LTRIGGER){
				if (gCount<=YOMILMAX){
					kList( wordList,gCount,index );				// uȁv⃊Xg\
				}
				DrawKey3( -1,-1,t );							// \tgL[\iJ[\Ȃj
			} else {
				if (gCount<=YOMILMAX){
					kList( wordList,gCount,-1 );				// uȁv⃊Xg\
				}
				DrawKey3( x,y,t );								// \tgL[\
			}
		} else {
			putBack();											// \tgL[
			if (gCount){
				putkList();
			}
		}
	}
}


//==============================================================
// \tgL[[h̏
//--------------------------------------------------------------
// ZNgĂez̏ɕ
//--------------------------------------------------------------

static void keyboard(char *str,SceCtrlData pad1)
{
	switch (gKey){
	case 0:														// 50zAVXgJ[\
	case 1:														// 50z
		softkey1( str,pad1 );
		break;
	case 2:														// ~TȔz
		softkey3( str,pad1 );
		break;
	default:
		gKey = 0;
		break;
	}
}


//==============================================================
// char񂩂SpR[h擾
//--------------------------------------------------------------

static unsigned int fcode(char *str)
{
	if (str[0]=='\0'){
		return (0);
	} else {
		return ((unsigned char)str[0] * 0x100 + (unsigned char)str[1]);
	}
}


//==============================================================
// char񂩂intf[^擾
//--------------------------------------------------------------

static unsigned int getInt(char *str)
{
	return ((unsigned char)str[0] + (unsigned char)str[1] * 0x100);
}


//==============================================================
// Spʂ̐؂蕪
//--------------------------------------------------------------

static int codeChk(char *str,unsigned int ar1,unsigned int ar2)
{
	unsigned int cr;
	int pos;

	pos = 0;
	while (pos<strlen(str)){
		if (chkSJIS(str[pos])){
			cr = fcode(&str[pos]);
			pos += 2;
		} else {												// p瑦I
			break;
		}
		if (cr<ar1 || cr>ar2){
			break;												// ͈͊O̕I
		}
	}
	return (pos);
}


//==============================================================
// ϊ
//--------------------------------------------------------------
// len      ϊΏۂƂȂ镶ߒioCgj
// adjust      0:ߒ͎wlɋŒ
//          ȊO:ߒ͎wlZύXꍇ
// count    P̐
// wordList PꃊXgichar wordList[KMAX][2][33]̔zw肷邱Ɓj
//
// ߂l   Tsu݁v̒ioCgj
//          count   :PꃊXǧiP`j
//          wordList:PꃊXg
//--------------------------------------------------------------
// gSt̓ǂ݂Ɋ{擾B
// Ƀ[U[̌⌟sꂽƂɃRŝŁA
// o^ς݌ɒǉ`ɂȂ܂B
// wordList̍Ōɂ͒Tsߒ́u݁v̂̂ĂB
// Ɉv̂ꍇłŒłu݁v͕Ԃ܂B
//--------------------------------------------------------------

static int setkanji(int len,int adjust,int *count,char wordList[][2][33])
{
	unsigned int	cr;
	const char		kazu[21] = {"ZOlܘZ"};
	int		i,j,hp,sp,sp2,sp3,tmp,top,sjis;
	long	pos,pos2;

	cr = 0;
	gDicWordPos = -1;

	hp = dicIndex( &gSt[0] );									// ̓CfbNX擾

	if (hp<0){													// sȂꍇiőΉĂȂ擪j
		if (adjust){
			if (hp==-2){										// p̕I
				for (sp=0; sp<strlen(gSt) ;sp++){
					if (chkSJIS(gSt[sp])) break;
				}
			} else {											// ̑Sp^Cvɂ܂Ƃ߂
				cr = fcode(&gSt[0]);							// 擪
				if (cr<0x8259U){								// 
					sp = codeChk( gSt,0x824F,0x8258 );
				} else if (cr<0x829BU){							// At@xbg
					sp = codeChk( gSt,0x8260,0x829A );
				} else if (cr<0x8397U){							// J^Ji
					sp = codeChk( gSt,0x8340,0x8396 );
				} else if (cr<0x83D7U){							// MV
					sp = codeChk( gSt,0x839F,0x83D6 );
				} else if (cr<0x8492U){							// VA
					sp = codeChk( gSt,0x8440,0x8491 );
				} else {										// L
					sp = codeChk( gSt,0x84A0,0x879F );
				}
			}
		} else {
			sp = len;											// ^Cv͖
		}

	} else {													// ϊsꍇ
		pos = gHEDtbl[hp];										// ɑΉ鎫R[h̊Jnʒu
		if (pos==0xFFFFFFFF){									// ɓo^Ȃ
			sp = 2;
		} else {												// ɐ擪o^Ăꍇ
			pos += 2;
			sp2 = sp3 = 0;
			pos2 = -1;
			while(1){
				sp = 0;
				while (gDic[pos+sp]!=0){						// ݂ɑΉP茟
					if (gDic[pos+sp]!=gSt[sp]) break;
					sp++;
					if (sp==len) break;
				}
				if (gDic[pos+sp]==0){							// P┭iƒv̂邩Ȃ̂ŒT͏IȂj
					pos2 = pos;
					sp3 = sp;
				}
				if (hp==0){										// L̏ꍇ̏I
					if (fcode(&gDic[pos])>0x829E){
						break;
					}
				} else {										// Ђ炪Ȃ̏ꍇ̏I
					if (sp<sp2){								// v镶OZȂTI
						break;
					}
				}
				sp2 = sp;
				tmp = getInt(&gDic[pos-2]);						// ̒Pւ̑΋iintj
				if (tmp==0xFFFF) break;							// ITI
				pos += tmp;
			}

			if (pos2==-1){										// ɍڂĂȂiLϊ悤ƂꍇɋN肦j
				sp = 2;
			} else if (adjust==0 && sp3!=len){					// w肳ꂽߒɑȂ
				sp = len;
			} else {											// PꃊXg荞
				sp = sp3;
				pos = pos2 + strlen(&gDic[pos2]) +1;
				gDicWordPos = pos;								// ŎLڏւ邽߂
				top = *count;
				*count += gDic[pos++];							// Pꐔibytej
				if (*count>KMAX-1) *count = KMAX-1;				// Pꐔiobt@I[o[t[΍j
				for (i=top; i<*count ;i++){						// P荞
					tmp = strlen(&gDic[pos]);
					if (tmp>32) tmp = 32;						// P̒iobt@I[o[t[΍j
					sjis = 0;
					for (j=0; j<tmp ;j++){
						wordList[i][1][j] = gDic[pos+j];
						if (sjis){								// ɈꍇɃS~c鋰ꂪ̂
							sjis = 0;
						} else {
							sjis = chkSJIS(gDic[pos+j]);
						}
					}
					wordList[i][1][j+sjis] = '\0';
					pos += strlen(&gDic[pos])+1;
				}
			}
		}
	}

	if (hp>0 || hp==-3){										// ϊ
		tmp = 0;
		for (i=0; i<sp ;i+=2){
			cr = fcode(&gSt[i]);
			if (cr>=0x824F && cr<0x8259){						// 
				wordList[*count][1][i  ] = kazu[(cr-0x824F)*2  ];
				wordList[*count][1][i+1] = kazu[(cr-0x824F)*2+1];
				tmp = 1;
			} else if (cr>=0x829F && cr<0x82F2){
				if (cr>=0x82DE) cr++;							// sJISR[h́u~vƁuv̊Ԃɂ󗓂͉낤H
				cr += 161;										// Ђ炪ȁJ^Ji
				wordList[*count][1][i  ] = cr >> 8;
				wordList[*count][1][i+1] = cr & 0x00FF;
				tmp = 1;
			} else {											// ̑͂̂܂
				wordList[*count][1][i  ] = cr >> 8;
				wordList[*count][1][i+1] = cr & 0x00FF;
				tmp = 1;
			}
		}
		if (tmp){												// R[hϊsĂꍇ
			wordList[*count][1][i] = '\0';
			(*count)++;
		}
	}

	for (i=0; i<sp ;i++){										// ŌɁu݁v̂̂PꃊXgɒǉ
		wordList[*count][1][i] = gSt[i];
	}
	wordList[*count][1][i] = '\0';
	(*count)++;

	return (sp);
}


//==============================================================
// ⃊Xg̈ʒu
//--------------------------------------------------------------
// ϊC̉Ɋ⃊Xg̈ʒuݒ肷B
// ʒ[ƂԂȂɐݒ肵܂B
//--------------------------------------------------------------

static void kListPos(int *x,int *y,int *wx,int *wy,char wordList[][2][33],int count)
{
	int i,len,max,xl,yl,xx;

	InLinePos( gSt,x,wx );										// xW擾
	xx = *x;

	max = 0;
	for (i=0; i<count ;i++){
		len = strlen(wordList[i][1]);
		if (len>max) max = len;
	}
	*wx = 2+ max * FONTX +3 +4 +1;
	if (count>KLIST){
		*wy = KLIST * (12+1)+2 -1;
	} else {
		*wy = count * (12+1)+2 -1;
	}

	if (*x+*wx>480) *x = 480 - *wx;								// ʂ͂ݏoȂJnʒu炷
	*y = gCy + gCyw+1;
	if (*y+*wy>272) *y = gCy -1 - *wy;

	if (gMode==1){												// \tgL[[hȂ\tgL[
		if (gKey==2){
			xl = KBPOSX3;
			yl = KBPOSY3;
		} else {
			xl = KBPOSX1;
			yl = KBPOSY1;
		}
		if (*x+*wx>=xl && *y+*wy>=yl){							// \tgL[ɏdȂ
			if (*x<xl){
				*x = xl - *wx;
			} else {
				*y = gCy -1 - *wy;
				if (*y<0){
					*x = xx - *wx;
					*y = yl -1 -*wy;
				}
			}
		}
	}
}


//==============================================================
// ⃊Xg̕\
//--------------------------------------------------------------
// gCx,gCyŎw肳ĂJ[\ʒủɊ⃊Xg̕\sB
// index  -1 ̂Ƃ̓J[\\ȂB
//--------------------------------------------------------------

static void kList(char wordList[][2][33],int count,int index)
{
	int	i,page,len,pos,n,x,y,wx,wy,df;

	if (!count) return;

	kListPos( &x, &y, &wx, &wy, wordList, count );				// ⃊Xgʒu
	y += gPage;
	BoxFill( x, y, wx-5, wy, CORFL1, CORIN );

	BoxFill( x + wx-1-4-1, y, 5, wy, CORFL1, CORFR );
	if (index>=0){
		df = 1;
	} else {
		df = 0;
		index = 0;
	}
	page = index / KLIST;
	if (count<KLIST){
		pos = 0;
		len = wy -2;
	} else {
		pos = page * (wy-2) * KLIST / count;
		len = (wy-1) * KLIST / count;
	}
	if (len>wy-2) len = wy -2;									// XN[o[̃TCY␳
	if (pos+len>wy-2) pos = wy-2 -len;							// XN[o[̈ʒu␳
	for (i=0; i<4 ;i++){										// XN[o[
		VLine( x + wx-2-i, y+1 +pos, len, CORRBAR );
	}

	pos = index % KLIST;
	y += 1;
	x += 1;
	if (df){
		BoxFill( x, y +pos *(12+1), wx-2-4-1, 12, CORCUR, CORCUR );
	}
	n = page * KLIST;
	for (i=0; i<KLIST ;i++){
		if (n>=count) break;
		mh_print( x+2,y,wordList[n][1],CORWCHR );				// ϊC
		y += 12 +1;
		n++;
	}
}


//==============================================================
// ⃊Xg̔wȋҔ
//--------------------------------------------------------------

static void getkList(char wordList[][2][33],int count)
{
	int	x,y,wx,wy;

	if (gBDFlag) return;

	if (!count){
		gkListBufP.x = -1;
		return;
	}
	if (gkListBuf){												// obt@
		DrawImgFree(gkListBuf);
		gkListBuf = NULL;
	}
	kListPos( &x, &y, &wx, &wy, wordList, count );				// ⃊Xgʒu
	gkListBuf = DrawImgCreate( wx,wy );
	gkListBufP.x = x;
	gkListBufP.y = y;
	BoxCopy( gkListBuf, gkListBufP.x, gPage+gkListBufP.y );
}


//==============================================================
// ⃊Xg̔wi̕
//--------------------------------------------------------------

static void putkList(void)
{
	if (gkListBufP.x==-1) return;

	if (gBDFlag) return;

	BoxPaste( gkListBuf, gkListBufP.x, gPage+gkListBufP.y );
}


//==============================================================
// {Lڏ̓ւ
//--------------------------------------------------------------

static void dicWordEx(int index)
{
	long	pos,pos2;
	char	str[65];
	int		i,n,len;

	if (gDicWordPos==-1) return;								// ʒuw肳ĂȂ
	if (gDic[gDicWordPos]<(index+1)) return;					// o^ꐔȏw肵Ă
	if (!index) return;											// ɐ擪ʒuɂ

	gSaveFlag = -1;

	pos = gDicWordPos +1;
	pos2 = pos;
	n = 0;
	while (n<index){											// ڕẄʒuT
		pos += strlen(&gDic[pos]) +1;
		n++;
	}
	strcpy(str,&gDic[pos]);										// 擪ɈړҔ
	len = strlen(&gDic[pos]) +1;								// ړTCY
	n = pos - pos2;
	pos--;
	for (i=n; i>0 ;i--){										// ̑̌ړ
		gDic[pos+len] = gDic[pos];
		pos--;
	}
	strcpy(&gDic[pos2],str);									// ڕW擪ɏ߂
}


//==============================================================
// I[h
//--------------------------------------------------------------

static void change(char *str,SceCtrlData pad1)
{
	static char	wordList[KMAX][2][33],ILstr[64];
	static int	mode = 0,count,len,index,getFlag = 0;
	int	l,p,s,ch,df;

	if (!mode){													// ϊJn̏ݒ
		count = 0;
		len = setkanji( strlen(gSt),1,&count,wordList );		// {
		index = 0;
		mode = 1;
		strcpy( ILstr,wordList[index][1] );						// ϊΏ
		strcat( ILstr,&gSt[len] );								// ϊΏ
		getInLine(ILstr);										// Ԃ̕ϊCwi擾
		getkList( wordList,count );
	}

	df = 0;

	ch = SIMEgetchar(pad1);
	switch (mode){
	case 1:														// I[h
		switch (ch){
		case 0x03:												// L
			putkList();											// ⃊Xg
			if (index==0){
				index = count -1;
			} else {
				index -= KLIST;
				if (index<0) index = 0;
			}
			df = 1;
			break;
		case 0x04:												// R
			putkList();											// ⃊Xg
			if (index==count-1){
				index = 0;
			} else {
				index += KLIST;
				if (index>count-1) index = count -1;
			}
			df = 1;
			break;
		case 0x0D:												// 
			strcat( gKouho,wordList[index][1] );				// wKpɁAIꂽ~ςĂ
			strcpy( str,wordList[index][1] );
			strcpy( gSt,&gSt[len] );
			if (strlen(gSt)==0){								// u݁vSĖȂ\tgL[[h
				if (!gUSave){
					dicAdd( gYomi,gKouho );						// [U[ɍڂǉ
				}
				gMode = 3;
			}
			if ((count-1)!=index){								// ⃊Xg̍Ō̌́u݁vȂ̂œւ͍sȂ
				dicWordEx(index);
			}
			mode = 0;
			break;
		case 0x08:												// 
		case 0x1B:												// ~
			putInLine();										// ϊC
			putkList();											// ⃊Xg
			mode = 0;
			gMode = 3;											// \tgL[[h
			break;
		case 0x1C:												// 
			putInLine();										// ϊC
			putkList();											// ⃊Xg
			len += 1 -chkSJIS(gSt[len]);						// Sp␳
			l = strlen(gSt);
			if (len>l) len = l;
			strcpy( ILstr,gSt );
			getInLine(ILstr);
			getkList( wordList,count );
			mode = 2;
			break;
		case 0x1D:												// 
			putInLine();										// ϊC
			putkList();											// ⃊Xg
			len--;
			if (len<1) len = 1;
			p = 0;
			while (1){											// Sp␳
				s = 1 -chkSJIS(gSt[p]);
				if (p+s>len) break;
				p += s;
			}
			if (p==0) p = 2;
			len = p;
			strcpy( ILstr,gSt );
			getInLine(ILstr);
			getkList( wordList,count );
			mode = 2;
			break;
		case 0x1E:												// 
			putkList();											// ⃊Xg
			index--;
			if (index<0) index = count -1;
			df = 1;
			break;
		case 0x1F:												// 
		case 0x02:												// 
			putkList();											// ⃊Xg
			index++;
			if (index>count-1) index = 0;
			df = 1;
			break;
		}
		break;
	
	case 2:														// ߒI[h
		switch (ch){
		case 0x03:												// L
			break;
		case 0x04:												// R
			break;
		case 0x0D:												// 
			strncpy( str,gSt,len );
			str[len] = '\0';
			strcat( gKouho,str );								// wKpɁAIꂽ~ςĂ
			strcpy( gSt,&gSt[len] );
			if (strlen(gSt)==0){								// u݁vSĖȂ\tgL[[h
				putInLine();									// ϊC
				if (!gUSave){
					dicAdd( gYomi,gKouho );						// [U[ɍڂǉ
				}
				gMode = 3;
			}
			mode = 0;
			break;
		case 0x08:												// 
		case 0x1B:												// ~
			putInLine();										// ϊC
			mode = 0;
			gMode = 3;											// \tgL[[h
			break;
		case 0x1C:												// 
			len += 1 -chkSJIS(gSt[len]);						// Sp␳
			l = strlen(gSt);
			if (len>l) len = l;
			break;
		case 0x1D:												// 
			len--;
			if (len<1) len = 1;
			p = 0;
			while (1){											// Sp␳
				s = 1 -chkSJIS(gSt[p]);
				if (p+s>len) break;
				p += s;
			}
			if (p==0) p = 2;
			len = p;
			break;
		case 0x1E:												// 
			count = 0;
			len = setkanji( len,0,&count,wordList );
			index = count -1;
			mode = 1;
			df = 1;
			break;
		case 0x1F:												// 
		case 0x02:												// 
			count = 0;
			len = setkanji( len,0,&count,wordList );
			index = 0;
			mode = 1;
			df = 1;
			break;
		}
		break;
	}

	if (df){													// ϊɕω
		putInLine();											// ϊC
		strcpy( ILstr,wordList[index][1] );						// ϊΏ
		strcat( ILstr,&gSt[len] );								// ϊΏ
		getInLine(ILstr);
		getkList( wordList,count );
	}

	if (str[0]){												// o͂ꍇ̓EBhEꎞIɏ
		putInLine();											// ϊC
		putkList();												// ⃊Xg
		getFlag = 1;
	} else {
		if (getFlag){											// OEBhEĂȂwiĎ擾
			getInLine(ILstr);
			getkList( wordList,count );
			getFlag = 0;
		}
		if (gMode==2){											// \tgL[[hɑJڂƂ͎sȂ
			switch (mode){										// ϊC\
			case 1:
				InLine( ILstr,strlen(wordList[index][1]) );
				kList( wordList,count,index );
				break;
			case 2:
				InLine(ILstr,len);
				break;
			}
		}
	}
}


//==============================================================
// ݒEBhE̍
//--------------------------------------------------------------

static void DrawMenu(int pos,char *strKey,char *strSave,char *strUSave,char *strUDAdd)
{
	int		y;

	DrawWindow( SIMENAME,MEPOSX,MEPOSY,218,212 );				// EBhEt[
	y = gPage + MEPOSY +15;
	BoxFill( MEPOSX +1, y, 218-2, 197, CORFL1, CORFR );			// 
	y += 6;

	mh_print( MEPOSX +4 +4 , y, "gpĂ鎫", CORFCHR );
	DrawTextbox( gDicFile,MEPOSX +4 +26,y +12+2,176,CORFCHR,CORFL1 );
	DrawTextbox( gDic2File,MEPOSX +4 +26,y +12+2+12+2,176,CORFCHR,CORFL1 );
	y += 48;

	if (pos==0)
		BoxFill( MEPOSX +4 +4 -1, y, 96 +2, 12, CORCUR, CORCUR );
	mh_print( MEPOSX +4 +4 , y, "\\tgL[̎", CORFCHR );
	DrawTextbox( strKey,MEPOSX +4 +94,y +12+2,108,CORWCHR,CORIN );
	y += 36;

	if (pos==1)
		BoxFill( MEPOSX +4 +4 -1, y, 180 +2, 12, CORCUR, CORCUR );
	mh_print( MEPOSX +4 +4 , y, "IɎ̋Lڏۑ", CORFCHR );
	DrawTextbox( strSave,MEPOSX +4 +154,y +12+2,48,CORWCHR,CORIN );
	y += 36;

	if (pos==2)
		BoxFill( MEPOSX +4 +4 -1, y, 132 +2, 12, CORCUR, CORCUR );
	mh_print( MEPOSX +4 +4 , y, "[U[gp", CORFCHR );
	DrawTextbox( strUSave,MEPOSX +4 +154,y +12+2,48,CORWCHR,CORIN );
	y += 36;

	if (pos==3)
		BoxFill( MEPOSX +4 +4 -1, y, 168 +2, 12, CORCUR, CORCUR );
	mh_print( MEPOSX +4 +4 , y, "[U[Ɍǉ", CORFCHR );
	DrawTextbox( strUDAdd,MEPOSX +4 +154,y +12+2,48,CORWCHR,CORIN );
}


//==============================================================
// ݒEBhEwȋҔ
//--------------------------------------------------------------

static void getMenu()
{
	if (gBDFlag) return;

	if (gBackBuf){												// obt@
		DrawImgFree(gBackBuf);
		gBackBuf = NULL;
	}
	gBackBuf = DrawImgCreate( 218,214 );						// \tgL[wiҔobt@
	gBackBufP.x = MEPOSX;
	gBackBufP.y = MEPOSY;
	BoxCopy( gBackBuf, gBackBufP.x, gPage+gBackBufP.y );
}


//==============================================================
// eݒ
//--------------------------------------------------------------

static void menu(SceCtrlData pad1)
{
	static int pos = 0,mode = 0,item[4];
	char	strKey[][21] = {"TOzAC","TOz","~TȔzu"},
			strSave[][7] = {"","Ȃ"};
	int ch;

	ch = SIMEgetchar(pad1);
	switch (mode){
	case 0:														// ݒ
		item[0] = gKey;
		item[1] = gSave;
		item[2] = gUSave;
		item[3] = gUDicAdd;
		pos = 0;
		mode = 1;
		break;

	case 1:														// I[h
		switch (ch){
		case 0x03:												// L
			break;
		case 0x04:												// R
			break;
		case 0x0D:												// 
			if (gKey!=item[0] || gSave!=item[1] || gUSave!=item[2]){
				gIni = 1;										// f[^ύXꂽ
			}
			gKey = item[0];
			gSave = item[1];
			gUSave = item[2];
			gUDicAdd = item[3];
			mode = 0;
			gMode = 3;											// \tgL[[h
			break;
		case 0x08:												// 
			break;
		case 0x05:												// [START]
		case 0x1B:												// ~
			mode = 0;
			gMode = 3;											// \tgL[[h
			break;
		case 0x1C:												// 
			if (pos==0){
				item[pos]++;
				if (item[pos]>2) item[pos] = 2;
			} else {
				item[pos] = 1;
			}
			break;
		case 0x1D:												// 
			item[pos]--;
			if (item[pos]<0) item[pos] = 0;
			break;
		case 0x1E:												// 
			if (pos>0) pos--;
			break;
		case 0x1F:												// 
			if (pos<3) pos++;
			break;
		case 0x02:												// 
			break;
		}
		break;
	}

	if (gMode==4){
		DrawMenu( pos, strKey[item[0]], strSave[item[1]], strSave[item[2]], strSave[item[3]] );
	} else {
		putBack();
	}
}


//==============================================================
// 
//--------------------------------------------------------------
// *str   ͂ꂽiő33oCg asciizj
// pad1   pbh
// ߂l str̂
//--------------------------------------------------------------
// \tgL[{[hɂ镶̓́B
// ȉpIMEɂ銿ϊsB
// łȂJ[\L[̊e{^Rg[R[hƂĕԂB
// ͕́im肳ꂽꍇ́jstrɓĂ܂B
//--------------------------------------------------------------

char *SIMEgets(char *str,SceCtrlData pad1)
{
	int i;

	for (i=0; i<=CHLEN ;i++){
		str[i] = 0;
	}

	switch (gMode){
	case 0:														// ړ[h
		move( str,pad1 );
		break;

	case 1:														// L[{[h[h
		keyboard( str,pad1 );
		break;

	case 2:														// I[h
		change( str,pad1 );
		break;

	case 3:														// \tgL[[hɑJڂ
		gMode = 1;
		getInLine(gSt);
		getBack();
		keyboard( str,pad1 );
		break;

	case 4:														// eݒ
		menu(pad1);
		break;

	case 5:														// ݒʂɑJڂ
		gMode = 4;
		getMenu();
		menu(pad1);
		break;

	}
	return (str);
}


//==============================================================
// ͐؂ւ
//--------------------------------------------------------------
// ime ̓\[Xi0:Simple IME ȊO:OSKj
// str ͂ꂽ
// pad pbh
//--------------------------------------------------------------
// ̓\[XSimple IMEOSKŐ؂ւ܂B
// OSKgpɉʃC[WҔobt@mۂłȂꍇ
// Simple IMEgp܂B
//--------------------------------------------------------------

void SIMEselInput(int ime,char *str,SceCtrlData pad)
{
	DrawImg	*image;

	if (ime){													// OSKI
		image = DrawImgCreate(480,272);
		if (image){
			str[0] = SIMEgetchar(pad);
			SIMEDrawCursor(str[0]);								// SIMEJ[\̍
			if (str[0]==0x02){									// Ă
				BoxCopy( image, 0, 0 );
				oskSetupGu();
				oskInput( "", "", str );
				initGraphics();
				flipScreen();									// ftHgł̓y[Wݒɕsŝ
				BoxPaste( image, 0, 0 );
			}
			if (image){
				DrawImgFree(image);
			}
		} else {												// wȋҔoȂꍇ
			SIMEgets( str, pad );
		}

	} else {													// Simple IMEI
		SIMEgets( str, pad );									// ͕̎擾
	}
}


