//==============================================================
// Xg\iȈՃt@C[[hj
//--------------------------------------------------------------

#include "FreezeViewer.h"
#include "fvTool.h"
#include <psputility.h>
#include <psppower.h>
#include <pspdisplay.h>
#include <psprtc.h>
#include <pspgu.h>
#include <kubridge.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <malloc.h>
#include <zlib.h>

#include "psp2chIni.h"
#include "fileList.h"
#include "fvView.h"
#include "mp3Audio.h"
#include "charConv.h"
#include "fvDraw.h"
#include "dialog.h"
#include "intraFont.h"
#include "message.h"
#include "unzip/FVunzip.h"
#include "FVunrar.h"
#include "sound.h"

//----- 萔ݒ -----

#define LISTPITCH		(26)									// Xg̍s
#define LISTCOUNT		(9)										// Xg̍s
#define LISTSHIFT		(64)									// Xg̗
#define MENUSHIFT0		(50)									// j[WJ̃Xgړ
#define MENUSHIFT1		(110)									// j[WJ̃j[ړ
#define MENUSHIFT2		(144)									// j[WJ̃j[ړʁij
#define MENUSHIFT3		(70)									// j[WJ̃j[ړʁij
#define MENUALPHA		(0.8f)									// j[̊{ߗ
#define STARTX			(125)									// Xg\̊ʒu
#define STARTY			(125)									// Xg\̊ʒu
#define ROLLX			(472)									// XN[o[ʒu
#define ROLLY			(0)										// XN[o[ʒu

//----- OQ -----

extern S_2CH s2ch;							// fvTool.c
extern char keyWords[128];					// fvTool.c

//------ O[oϐ -----

DirList		gFileList[4];										// Xg
int			gScrBufFlg;											// wiꎞobt@XVv
int			gThumbReadFlag;										// ʓ̃TlCǂݍ݂i0:yesj

static int		gThumbId,										// TlC擾Xbh
				gConfigSaveId,									// RtBOZ[uXbh
				gBgmImageId,									// BGMWPbg摜C[WXbh
				gBgmImageSubId;									// WPbg摜̓WJ/Xbh
int				gGetDirId[2];									// tH_ꗗ擾Xbh
static int		gFileCtrlId;									// t@CXbh
static char		gCopyFile[1024],								// Rs[t@C̃tpX
				gCopyName[256],									// Rs[t@C̃t@C
				gCopyArchive[1024],								// Rs[A[JCut@C̃tpX
				gCopyArchivePass[256],							// Rs[A[JCũpX[h
				gSrchName[256],									// j[߂ɃJ[\ړt@C
				gArchiveFile[1024];								// WJt@C
static int		gCopyFileMode,									// 0:Rs[ 1:؂
				gCopyArchiveType;								// Rs[A[JCu̎ 0:ktH_ł͂Ȃ 1:zip 2:rar
volatile int	gGetThumbEnd;									// TlCWXbh̋~w
volatile int	gGetThumbCount;									// TlC擾
volatile int	gGetDirEnd[2];									// tH_W֘AXbh̋~w
volatile int	gFileCtrlEnd;									// t@CXbh̋~w
int				gMenuCount;										// j[̓WJʒu 0:JĂȂ 1`:j[WJ
int				gMenuCount2;									// BGMj[̓WJʒu

static char	*gMenuItem[] = { "\\t", "ɓWJ", "VKtH_쐬", "ŊJ", "Rs[", "؂", "O̕ύX",
			                 "폜", "폜", "WJt@C", "ŊJ", "A[g[N\", "A[g[N̏o" };
enum menuTyp	{ PASTE, EXPAND, MAKEFOLDER, MEMOOPEN, COPY, CUT, RENAME, DELETEFILE, DELETEFOLDER, EXPANDFILE ,
				  ARCMEMO, IMAGEVIEW, IMAGESAVE };

//----- \ -----

typedef struct {
	char		path[1024];										// TlCtH_
	DirList		*DList;											// TlC擾t@Cւ̃|C^
} strGetThumb;

typedef struct {
	int				type;										// j[̎ށi0:t@C, 1:ݒ荀ځj
	int				top;										// ڂ̕\Jnʒu
	int				pos;										// J[\ʒu
	int				size;										// j[̉
	int				count1;										// ڌQ1iΏ:tH_ǰ
	enum menuTyp	item1[4];									// ڌQ1̊e
	int				count2;										// ڌQ2iΏ:t@Cǰ
	enum menuTyp	*item2;										// ڌQ2̊e
	char			**item3;									// ݒ胁j[pڃXg
} strMenu;														// j[

typedef struct DiskInfo {
	unsigned long	cluster_max;								// NX^
	unsigned long	cluster_free;								// 󂫃NX^
	int				sector_max;									// ̂󂫃NX^
	int				sector_size;								// ZN^̃oCg
	int				sector_count;								// NX^̃ZN^
} DiskInfo;

strMenu		gMenu;												// j[
strFileCtl	gFCdata;											// t@C

typedef struct {
	char	*msg;
	char	*info;
	int		*val;
	int		type;
	int		size;
	int		itemCnt;
} strSettingList;												// ݒ荀ڊǗ\



//----- vg^Cv錾 -----

int	SMEMOfile(char *path);										// PSP
int	SMEMOtext(char *text,char *name);							// PSP

int mainRAR(int argc, char *argv[]);													// rar.cpp


//==============================================================
// fBNgXg̍폜
//--------------------------------------------------------------

static void deleteDirList(DirList **DListPtr)
{
	DirList	*DList;
	int		i;

	DList = *DListPtr;
	if (DList->file == NULL) return;

	for (i = 0; i < DList->count; i++) {
		free( DList->file[i].settingMsg );
		free( DList->file[i].msg );
		free( DList->file[i].name2 );
		free( DList->file[i].name );
		DrawImgFree( DList->file[i].thumb );
	}
	free( DList->file );
	DList->file = NULL;
	DList->count = 0;
	DList->pos = 0;
	DList->complete = 1;
}


//==============================================================
// Xe[^X\
//--------------------------------------------------------------
// resetF1   :BGMt@C/
//        ȊO:BGMtȂt@C\
//--------------------------------------------------------------
// \BGMt@C\sB
// GU̍ݒsAs邱ƁB
//--------------------------------------------------------------

//===== ݂̃pXBGMt@C =====

void statusDraw1(DirList *DList, int reset)
{
	struct mallinfo	minfo;
	char			str[64];
	unsigned int	blk;
	int				len;
	static float	x_scroll1, x_scroll2;
	static char		bgmFileUtf8[FILE_PATH];
	static int		pathLen = -1, bgmID;
	unsigned char	rate;

	//--- ݃pX ---

	intraFontSetStyle( gJpn0, 0.7f, 0, 0, 0 );
	len = strlen( DList->path );
	if (len != pathLen) {										// ݃pXω
		x_scroll2 = 5;
	}
	pathLen = len;
	intraFontSetStyle( gJpn0, 0.7f, 0xC0FFFFFF, 0x404040, INTRAFONT_SCROLL_LEFT );
	x_scroll2 = intraFontPrintColumn( gJpn0, x_scroll2, 16, 325, DList->path );

	//---  ---

	if (0) {
		minfo = mallinfo();
		blk = minfo.uordblks;									// malloc
		sprintf( str, "%dKB", blk/1024 );
		if_print( 5, 32, str, 0.7f, 0xFFFFFF, 0x404040, 0.7f );
	}

	//--- BGMt@C ---

	if (reset==1 || gBGM.bgmID!=bgmID) {						// BGMς
		bgmID = gBGM.bgmID;
		psp2chSjis2UTF8( (u8*)bgmFileUtf8, (u8*)s2ch.bgmFile );
		x_scroll1 = 300;
	}
	if (reset!=1 && strlen(s2ch.bgmFile)) {						// BGMt@C
		rate = (255 * 0.7f) * (7 - gMenuCount) / 8.0f;
		intraFontSetStyle( gJpn0, 0.7f, 0x00FFFFFF | rate << 24, 0x00404040 | rate << 24, INTRAFONT_SCROLL_LEFT );
		x_scroll1 = intraFontPrintColumn( gJpn0, x_scroll1, 32, 170, bgmFileUtf8 );
	}
}


//===== ƃobe[c =====
// check     0:\s
//        ȊO:\͍s킸AωǂԂ
// ߂l 0:ωȂ
//--------------------------------

int statusDraw2(int	check)
{
	pspTime		time;
	char		str[64], buf[32];
	int			ret, battery, w;
	static int	backMinutes = 0;

	ret = sceRtcGetCurrentClockLocalTime( &time );				// 
	if (!check) {
		if (ret < 0) {
			strcpy( str, "--/-- --:--" );
		} else {
			sprintf( str, "%d/%d %d:%02d", time.month, time.day, time.hour, time.minutes );
		}
		battery = scePowerGetBatteryLifePercent();				// obe[
		if (battery < 0) {
			strcat( str, "  ---%" );
		} else {
			sprintf( buf, "  %d%%", battery );
			strcat( str, buf );
		}
		intraFontSetStyle( gJpn0, 0.7f, 0, 0, 0 );
		w = intraFontMeasureText( gJpn0, str );
		if_print( 475-w, 16, str, 0.7f, 0xFFFFFF, 0x404040, 0.7f-(gMenuCount/(7*10/7.0f)) );
	}

	if (backMinutes != time.minutes) {							// ԕω
		backMinutes = time.minutes;
		return 1;
	} else {
		return 0;
	}
}


//==============================================================
// XN[o[eNX`[̍쐬
//--------------------------------------------------------------

void rollbar(DirList *DList)
{
	MakeRollBar( gRollBar, DList->count, LISTCOUNT / 2, 272 - ROLLY, 0x00F07070 );
}


//==============================================================
// Xg\pTlC̍
//--------------------------------------------------------------

void thumbDraw(DirList *DList, int x, int y, int alpha, int start, int count, int max)
{
	int		i, x2, y2, icon, type;
	float	alp, range;

	if (DList->file == NULL) return;

	for (i = start; i < start + count; i++) {
		if (i >= 0) {
			if (i >= max) {										// XgI[zȂ
				break;
			}
			if (i == DList->pos) {								// J[\ʒu
				alp = alpha / 100.0f;
				range = 68.0f / THUMBXSIZE;
				switch (DList->file[i].type) {
				case 0:											// t@C
					if (DList->file[i].thumb) {					// TlC摜Ȃ
						x2 = x      - (DList->file[i].thumb->wx * range / 2);
						y2 = y + 20 - (DList->file[i].thumb->wy * range / 2);
						DrawPicAlpha( x2, y2, DList->file[i].thumb, alp, range );
					} else {									// TlC摜Ȃ
						icon = getIconNo( DList->file[i].name2 );
						x2 = x      - (gIconImg[icon]->wx * range / 2);
						y2 = y + 27 - (gIconImg[icon]->wy * range / 2);
						DrawPicAlpha( x2, y2, gIconImg[icon], alp, range );
					}
					break;
				case 1:											// tH_
					x2 = x      - (gIconImg[0]->wx * range / 2);
					y2 = y + 20 - (gIconImg[0]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[0], alp, range );
					break;
				case 2:											// A[JCu
					x2 = x      - (gIconImg[1]->wx * range / 2);
					y2 = y + 20 - (gIconImg[1]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[1], alp, range );
					break;
				case 3:											// [XeBbN
					x2 = x      - (gIconImg[6]->wx * range / 2);
					y2 = y + 27 - (gIconImg[6]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[6], alp, range );
					break;
				case 4:											// {̃[
					x2 = x      - (gIconImg[7]->wx * range / 2);
					y2 = y + 20 - (gIconImg[7]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[7], alp, range );
					break;
				case 5:											// ݒ
					x2 = x      - (gIconImg[8]->wx * range / 2);
					y2 = y + 20 - (gIconImg[8]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[8], alp, range );
					break;
				case 6:											// ݒ荀
					x2 = x      - (gIconImg[9]->wx * range / 2);
					y2 = y + 27 - (gIconImg[9]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[9], alp, range );
					break;
				}
			} else {											// J[\ȊÖʒu
				alp = (0.6f - 0.3f * (gMenuCount/7.0f)) * y / (y<=19 ? 19 : y) * alpha / 100;
				if (alp < 0.05f) alp = 0;
				range = 40.0f / THUMBXSIZE;
				switch (DList->file[i].type) {
				case 0:											// t@C
					if (DList->file[i].thumb) {					// TlC摜Ȃ
						x2 = x     - (DList->file[i].thumb->wx * range / 2);
						y2 = y + 8 - (DList->file[i].thumb->wy * range / 2);
						DrawPicAlpha( x2, y2, DList->file[i].thumb, alp, range );
					} else {									// TlC摜Ȃ
						type = checkExt(DList->file[i].name2);
						icon = 2;
						if (type < EXT_TYPE_IMAGE) {			// 摜t@C
							icon = 3;
						} else if (type < EXT_TYPE_SOUND) {		// t@C
							icon = 4;
						} else if (type < EXT_TYPE_MOVIE) {		// t@C
							
						} else if (type < EXT_TYPE_TEXT) {		// eLXgt@C
							icon = 5;
						}
						x2 = x      - (gIconImg[icon]->wx * range / 2);
						y2 = y + 13 - (gIconImg[icon]->wy * range / 2);
						DrawPicAlpha( x2, y2, gIconImg[icon], alp, range );
					}
					break;
				case 1:											// tH_
					x2 = x     - (gIconImg[0]->wx * range / 2);
					y2 = y + 8 - (gIconImg[0]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[0], alp, range );
					break;
				case 2:											// A[JCu
					x2 = x     - (gIconImg[1]->wx * range / 2);
					y2 = y + 8 - (gIconImg[1]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[1], alp, range );
					break;
				case 3:											// [XeBbN
					x2 = x     - (gIconImg[6]->wx * range / 2);
					y2 = y + 13 - (gIconImg[6]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[6], alp, range );
					break;
				case 4:											// {̃[
					x2 = x     - (gIconImg[7]->wx * range / 2);
					y2 = y + 8 - (gIconImg[7]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[7], alp, range );
					break;
				case 5:											// ݒ
					x2 = x     - (gIconImg[8]->wx * range / 2);
					y2 = y + 8 - (gIconImg[8]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[8], alp, range );
					break;
				case 6:											// ݒ荀
					x2 = x      - (gIconImg[9]->wx * range / 2);
					y2 = y + 13 - (gIconImg[9]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[9], alp, range );
					break;
				}
			}
		}
		if (i == DList->pos) y += LISTPITCH;
		y += LISTPITCH;
	}
}


//==============================================================
// t@CXg\
//--------------------------------------------------------------
// alpha Ft@C̓ߌW
// alpha2FTlC̓ߌW
// reset Fw
//           0 Jڕ\
//           1 Jڏ󋵃ZbgABGMpX̕\͂Ȃ
//           2 Jڏ󋵃Zbg
//           3 Jڏ󋵃ZbgAJ[\ʒuX|bg\
//           4 Jڏ󋵃ZbgAJ[\ʒu_ŃZbg
//--------------------------------------------------------------
// ʑŜXVăt@CXgꗗ\܂B
// ʂɕωȂVRAMҔ̈gpč敉ׂyĂB
//--------------------------------------------------------------

//===== GgʂƂ̕F =====

static Color ListDrawSubColor(int type)
{
	switch (type) {
	case 1:														// tH_
		return 0x00FFFF;
		break;
	case 2:														// A[JCu
		return 0x00FF00;
		break;
	default:													// t@C/̑
		return 0xFFFFFF;
		break;
	}
}

//===== J[\ʒũXg\ =====

static void ListDrawSubOnCsr(DirList *DList, int pos, int x, int y, int yPos, int reset, int alpha, int alpha2, unsigned char blink)
{
	char			buf[256], buf2[32];
	int				yy, yv;
	float			alp;
	Color			cor;
	static float	xr;
	static int		posBak;

	//----- ⑫ -----

	if (DList->file[pos].type <= 2) {									// t@Cn
		sprintf( buf, "%04d/%02d/%02d  %d:%02d", DList->file[pos].mtime.year, DList->file[pos].mtime.month, DList->file[pos].mtime.day
		                                       , DList->file[pos].mtime.hour, DList->file[pos].mtime.minute );
		if (DList->file[pos].type==0 || DList->file[pos].type==2) {		// t@CTCY
			if (DList->file[pos].size < 1024) {
				sprintf( buf2, "  %dB", (u32)DList->file[pos].size );
			} else if (DList->file[pos].size < 1024 * 1024) {
				sprintf( buf2, "  %.2fKB", (float)DList->file[pos].size / 1024 );
			} else {
				sprintf( buf2, "  %.2fMB", (float)DList->file[pos].size / (1024 * 1024) );
			}
			strcat( buf, buf2 );
		}
		if (DList->file[pos].xSize != 0) {								// 摜TCY
			sprintf( buf2, "  %dx%d", DList->file[pos].xSize, DList->file[pos].ySize );
			strcat( buf, buf2 );
		}

	} else if (DList->file[pos].type==3 || DList->file[pos].type ==4) {	// hCun
		psp2chSjis2UTF8( (u8*)buf, "󂫗e" );
		sprintf( buf2, " %dMB", (u32)DList->file[pos].size / (1024 * 1024) );
		strcat( buf, buf2 );
		psp2chSjis2UTF8( (u8*)buf2, "  [U[e" );
		strcat( buf, buf2 );
		if (DList->file[pos].diskSize / 1024 < 10) {
			sprintf( buf2, " %dMB", (u32)DList->file[pos].diskSize );
		} else {
			sprintf( buf2, " %dGB", (u32)DList->file[pos].diskSize / 1024 );
		}
		strcat( buf, buf2 );

	} else if (DList->file[pos].msg != NULL) {							// ݒn
		strcpy( buf, DList->file[pos].msg );

	} else {
		buf[0] = '\0';
	}

	if (reset == 3) {
		alp = alpha2 / 100.0f;
	} else {
		alp = alpha / 100.0f;
	}
	yy = y + yPos * LISTPITCH;
	if_print( x, yy+32, buf, 0.6f, 0xFFFFFF, 0x101010, alp );	// ⑫
	if (buf[0]) {												// ⑫ꍇ̕\ʒu␳
		yv = 0;
	} else {
		yv = 7;
	}

	//----- Gg -----

	if (reset!=0 && reset!=3) xr = 0;
	if (pos != posBak) {
		xr = 0;
		posBak = pos;
	}
	cor = ListDrawSubColor(DList->file[pos].type);				// ʂƂ̕F
	if (DList->file[pos].type != 6) {
		intraFontSetStyle( gJpn0, 0.8f, cor | ((int)(0xFF*alp)<<24),
		                                blink/2 | ((blink/2)<<8) | (blink<<16) | ((int)(0xFF*alp)<<24),
		                                INTRAFONT_SCROLL_LEFT );
		xr += x;
		xr = intraFontPrintColumn( gJpn0, xr, yy+14+yv, 330, DList->file[pos].name );
		xr -= x;
	} else {													// ݒ荀
		if_clipText( buf, DList->file[pos].name, 235, 0.8f );
		if_print( x, yy+14+yv, buf, 0.8f, cor, blink/2 + ((blink/2)<<8) + (blink<<16), alp );
		if (DList->file[pos].settingMsg != NULL) {
			if_clipText( buf, DList->file[pos].settingMsg, 145, 0.6f );
			if_print( x+200, yy+14+yv, buf, 0.6f, cor, blink/2 | ((blink/2)<<8) | (blink<<16), alp * ((7-gMenuCount)/7.0f) );
		}
	}
	if (alpha==100 || reset==3) {
		DrawLineGu( x-3, yy+19+yv, x+335, yy+19+yv, 0xFFFFFF, 0.7 );
	}
}

//===== S̓IȃXg\ =====

void ListDrawSub(DirList *DList, DirList *DList2, int x, int y,int alpha, int alpha2, int reset)
{
	static float			fy, yBak, startBak;
	static unsigned char	blink = 0;
	static int				blFlg = 1, resetFlg, backScrFlag, xBak;
	Color					cor;
	float					sy, alp;
	char					buf[256];
	int						a, i, yy, yPos, start, count, max;

	if (gBackScrBreak) {										// _CAOɂVRAMҔ̈悪j󂳂ꂽ
		gBackScrBreak = 0;
		backScrFlag = 0;										// ʂVRAMҔ蒼
	}
	if (gScrBufFlg) {											// VRAMҔ̈悪j󂳂ꂽ
		gScrBufFlg = 0;
		backScrFlag = 0;										// ʂVRAMҔ蒼
	}

	if (reset != 0) resetFlg = 1;

	count = LISTCOUNT;
	sy = DList->pos * LISTPITCH;								// _ł̖ڕWzW
	if (resetFlg) {
		fy = sy;
		blink = 0;
		blFlg = 1;
		resetFlg = 0;
	} else {
		a = abs(sy - fy);
		fy += (sy - fy) / (a<24 ? 8 : 5);
		if (a == 0) {											// ړ~
			fy = sy;
		} else {												// ړ
			count++;											// ړ͕\鍀ڐP₷
		}
	}
	if (blFlg > 0) {											// e̓_
		blink += 6;
		if (blink > 0xF8) blFlg = -blFlg;
	} else {
		blink -= 6;
		if (blink < 0x10) blFlg = -blFlg;
	}
	if (reset == 4) blink = 0;									// J[\ʒu_ŃZbg

	//----- Y\ʒu␳ -----

	start = (fy / LISTPITCH) - 4;								// 4:J[\ʒu
	if (start<0) {
		count -= start;
	}
	yy = y;														// TlC\ʒuۑp
	y -= fy - start * LISTPITCH;
	startBak = fy / LISTPITCH;

	//----- Xg\ -----

	if (x!=xBak || fy!=yBak || gThumbReadFlag) {				// ʏԂɕω̂VRAMҔXVv
		backScrFlag = 0;										// ʂVRAMҔ蒼
	}

	max = DList->count;
	if (backScrFlag) {											// VRAMɑҔꂽʃC[WȂ
		ScreenPaste2();											// wi
		guStart();
		if (max==0 || DList->file == NULL || DList->complete == 0) return;

	} else {													// Xg\ꂩ\z
		blitImageToScreen( 0, 0, 480, 272, gScrBuf1, 0, 0 );	// wiI[o[Ch
		guStart();
		sceGuClear( GU_DEPTH_BUFFER_BIT );

		if (DList2 != NULL) {									// ÕtH_TlC
			thumbDraw( DList2, x-36-LISTSHIFT, yy-4*LISTPITCH, 50, DList2->pos-4, LISTCOUNT, DList2->count );
		}

		if (max == 0) {											// Xgꍇ
			switch (DList->complete) {
			case -2:											// foOp
				strcpy( buf, "Gg擾G[ 2" );
				break;
			case -1:
				strcpy( buf, "Gg擾G[" );
				break;
			case 0:
				buf[0] = '\0';
				DrawRollBar( gRollBar, ROLLX, ROLLY, startBak, max, LISTCOUNT / 2, 272 - ROLLY );
				break;
			case 1:
				strcpy( buf, "No Data" );
				break;
			}
			if_printSjis( x, yy+14, buf, 0.8f, 0xC0C0FF, 0x101010, alpha2/100 );
			return;
		}

		if (DList->file == NULL || DList->complete == 0) {		// t@CGg擾҂
			DrawRollBar( gRollBar, ROLLX, ROLLY, startBak, max, LISTCOUNT / 2, 272 - ROLLY );
			return;
		}

		//----- XN[o[ -----

		if (reset != 3) {
			DrawRollBar( gRollBar, ROLLX, ROLLY, startBak, max, LISTCOUNT / 2, 272 - ROLLY );
		}

		//----- eړe\ -----

		thumbDraw( DList, x-36, y, alpha2, start, count, max );	// TlC̕\

		yPos = 0;
		for (i = start; i < start + count; i++) {
			if (i >= 0) {
				if (i >= max) {										// XgI[zȂ
					break;
				}
				if (DList->file[i].name!=NULL && i!=DList->pos) {	// J[\ȊÖʒu
					cor = ListDrawSubColor(DList->file[i].type);	// ʂƂ̕F
					yy = y + yPos * LISTPITCH;
					alp = 0.5f * yy / (yy<=19 ? 19 : yy) * alpha / 100;
					if (alp > 0.05f) {
						if (DList->file[i].type != 6) {
							if_clipText( buf, DList->file[i].name, 335, 0.8f );
							if_print( x, yy+14, buf, 0.8f, cor, 0x101010, alp );
						} else {									// ݒ荀
							if_clipText( buf, DList->file[i].name, 235, 0.8f );
							if_print( x, yy+14, buf, 0.8f, cor, 0x101010, alp );
							if (DList->file[i].settingMsg != NULL) {
								if_clipText( buf, DList->file[i].settingMsg, 145, 0.6f );
								if_print( x+200, yy+14, buf, 0.6f, cor, 0x101010, alp );
							}
						}
					}
				}
			}
			if (i == DList->pos) yPos++;
			yPos++;
		}
		if (xBak==x && yBak==fy && !gThumbReadFlag && !backScrFlag) {	// ړĂ炸AʃC[WҔĂȂȂ
			backScrFlag = 1;
			ScreenCopy3(1);
		}
	}
	ListDrawSubOnCsr( DList, DList->pos, x, y, DList->pos - start, reset, alpha, alpha2, blink );
	xBak = x;
	yBak = fy;
}


//==============================================================
// gqɑΉ
//--------------------------------------------------------------
// 摜t@C̏ꍇ͑đỎ摜t@C\鎖B
//--------------------------------------------------------------

static void doFile(char *path, char *file, DirList *DList)
{
	char	*name, *text, *p;
	int		ret, type, dFlag, size;

	//----- gqɏʂ -----

	dFlag = 0;
	name = DList->file[DList->pos].name2;
	type = checkExt( name );									// gq
	if (type < EXT_TYPE_IMAGE) {
		ret = imageView( path, DList, &dFlag );
	} else if (type == EXT_TYPE_MP3) {
		if (DList->archiveType == 0) {							// ʏtH_
			audioPlay( path, name );
		}
		ret = COMPLETE;
	} else if (type >= EXT_TYPE_MOVIE && type < EXT_TYPE_TEXT) {	// eLXg
		if (DList->archiveType == 0) {							// ʏtH_
			SMEMOfile( file );									// wt@CPSPŊJ
		} else {
			text = expandToMem( file, DList, &size );			// A[JCuWJ
			if (text) {
				text[size] = '\0';								// '\0'p̃͊mۂĂ
				p = strrchr( file, '/' );
				SMEMOtext( text, &p[1] );						// WJꂽf[^PSPŊJ
				free( text );
			}
		}
		ret = COMPLETE;
	}

	//----- wi摜荞 -----

	if (type < EXT_TYPE_MOVIE && dFlag) {
		blitImageToScreen( 0, 0, 480, 272, gScrBuf1, 0, 0 );	// wiI[o[Ch
		guStart();
		DrawBoxfillGu( 0, 0, 480, 272, s2ch.BakCor, 0.75 );		// ʂÂ
		sceGuFinish();
		sceGuSync( GU_SYNC_FINISH, GU_SYNC_WHAT_DONE );
		flipScreen( 0 );
		blitScreenToImage( 0, 0, 0, 480, 272, gScrBuf1, 0, 0 );
	}

	gGetThumbEnd = 0;											// TlC擾XbhĊJ
}


//==============================================================
// TlC擾Xbh
//--------------------------------------------------------------
//  getDirThread() N܂B
// J[\̈ړɍ킹ăTlCtH_̃TlCǂݍ݂܂B
// xNƒ~܂ŋNςȂB
// DList.pos̑OTHUMBMAX̃TlCǂݍ݁AȊO͍폜܂B
// DList.posɋ߂ʒuǂݍł܂B
// gGetThumbEnd-1wƏ𒆒fďI܂B
// gGetThumbEnd1wƏꎞfA0ɂȂĊJB
// fgGetThumbEnd2ɂȂB
//--------------------------------------------------------------

static int getThumbnailThread(SceSize args, void *argp)
{
	unsigned short			*buf;
	SceUID					fd;
	SceIoStat				st;
	DrawImg					*thumb;
	volatile strGetThumb	*th;
	volatile FileData		*FData, *FDataP;
	int						i, limit, pos, pos2, posBak, count, sg, ab;
	char					path[1024];

	th = *(strGetThumb**)argp;
	FData = th->DList->file;									// t@Cz
	posBak = -1;
	gGetThumbCount = 0;

	while (gGetThumbEnd>=0) {
		count = th->DList->count;								// t@Č
		if (gGetThumbEnd>0) {									// ̈ꎞf
			gGetThumbEnd = 2;
			posBak = -1;
			gThumbReadFlag = 0;
			sceDisplayWaitVblankStart();
			continue;
		}
		if (th->DList->pos == posBak || count == 0) {			// J[\ʒuωĂȂȂ
			gThumbReadFlag = 0;
			sceDisplayWaitVblankStart();
			continue;
		}
		posBak = th->DList->pos;
		pos = th->DList->pos;
		for (i = 0; i < count; i++) {							// ͈͊OTlC폜
			if (abs(pos - i)>THUMBMAX/2 &&
			        abs(pos + count - i)>THUMBMAX/2 &&
			        abs(pos -count - i)>THUMBMAX/2) {
				FData[i].xSize = 0;
				DrawImgFree(FData[i].thumb);
				FData[i].thumb = NULL;
				gGetThumbCount--;
			}
		}
		sg = -1;												// 
		ab = 0;													// Βl
		gThumbReadFlag = 1;										// TlCǂݍݒ
		for (i = 0; i < THUMBMAX; i++) {						// TlCt@C̓ǂݍ
			if (i >= count) break;
			if (pos != th->DList->pos) break;					// J[\ʒuɕω璆f
			if (gGetThumbEnd) break;
			pos2 = pos + sg * ab;								// TlC擾Ώ
			if (pos2 < 0) pos2 += count;
			if (pos2 >= count) pos2 -= count;
			FDataP = &FData[pos2];
			if (FDataP->type==0 && FDataP->xSize==0) {
				strcpy( path, (s8*)th->path );
				strcat( path, "/" );
				strcat( path, FDataP->name2 );
				strcat( path, ".dat" );
				if (sceIoGetstat( path, &st ) >= 0) {			// TlCt@CȂRRŎsnY
					fd = sceIoOpen( path, PSP_O_RDONLY, FILE_PARMISSION );
					if (fd >= 0) {
						limit = st.st_size;
						if (limit >= 32 + THUMBXSIZE * THUMBYSIZE * sizeof(Color) + 32) {
							limit = 32 + THUMBXSIZE * THUMBYSIZE * sizeof(Color) + 32 - 1;
						}
						buf = (unsigned short*)malloc( limit );
						if (buf == NULL) break;
						if (sceIoRead(fd, buf, limit) == limit) {
							if (buf[0]==(THUMBID | 0x0100) &&
							       buf[1]<=THUMBXSIZE && buf[2]<=THUMBYSIZE) {	// LȃTlCt@CȂ
								if (!FDataP->thumb || 
								       (FDataP->thumbTime.year==buf[3] &&
								        FDataP->thumbTime.month==buf[4] &&
								        FDataP->thumbTime.day==buf[5] &&
								        FDataP->thumbTime.hour==buf[6] &&
								        FDataP->thumbTime.minute==buf[7] &&
								        FDataP->thumbTime.second==buf[8]) ) {	// TlCÂȂȂ
									thumb = DrawImgCreate( buf[1], buf[2] );	// TlC摜
									if (thumb) {
										FDataP->thumb = thumb;
										FDataP->thumbTime.year   = buf[3];
										FDataP->thumbTime.month  = buf[4];
										FDataP->thumbTime.day    = buf[5];
										FDataP->thumbTime.hour   = buf[6];
										FDataP->thumbTime.minute = buf[7];
										FDataP->thumbTime.second = buf[8];
										FDataP->xSize            = buf[9];
										FDataP->ySize            = buf[10];
										limit = malloc_usable_size( thumb->data );
										uncompress( (Bytef*)thumb->data, &limit, (Bytef*)&buf[16], limit - 32 );
										gGetThumbCount++;
									}
								}
							}
						}
						free( buf );
						sceIoClose( fd );
					}
				}
			}
			if (sg < 0) ab++;									// }CiXȂΒl+1
			sg = -sg;											// 𔽓]
			if (i > LISTCOUNT) gThumbReadFlag = 0;				// ʓɑ͈͂̓ǂݍ݂͊
		}
	}
	gThumbReadFlag = 0;

	sceKernelExitThread( 0 );
	return 0;
}


//==============================================================
// fBNg擾Xbh
//--------------------------------------------------------------
//  GetDir() N܂B
// gGetDirEnd-1wƏ𒆒fďI܂B
// t@Cꗗ擾oTlC擾XbhN܂B
//--------------------------------------------------------------

//===== ʏtH_Gg̎擾 =====

static FileData *getSceDir(DirList *DList, char *path)
{
	SceUID		fd;
	SceIoDirent	dir;
	FileData	*FData;
	char		*buf, utf8[1536];
	int			i, count, type;

	//----- Gg̃JEg -----

	if ((fd = sceIoDopen(path)) < 0) {							// tH_ɃANZXoȂ
		return NULL;
	}
	memset( &dir, 0, sizeof(dir) );								// ȂreadɎs
	count = 0;
	while (sceIoDread(fd, &dir) > 0) {							// tH_Gg̃JEg
		if (gGetDirEnd[DList->getDirMode]) {					// f
			break;
		}
		if (dir.d_name[0] == '.') {
			if (dir.d_name[1] == '\0' || (dir.d_name[1] == '.' && dir.d_name[2] == '\0')) {
				continue;
			}
		}
		count++;
	}
	sceIoDclose( fd );

	//----- Ggȅ -----

	FData = (FileData*)malloc( sizeof(FileData) * count );		// GgXgpӂĂ
	DList->file = FData;
	if (FData == NULL) {										// mۂłȂ
		return NULL;
	}

	for (i=0; i<count; i++) {
		FData[i].name = NULL;
		FData[i].name2 = NULL;
		FData[i].thumb = NULL;
		FData[i].xSize = 0;
		FData[i].msg = NULL;
		FData[i].settingMsg = NULL;
	}
	DList->count = count;

	//----- Gge擾 -----

	if ((fd = sceIoDopen(path)) < 0) {							// ł͎sȂnY
		free( FData );
		return NULL;
	}
	i = 0;
	memset( &dir, 0, sizeof(dir) );
	while (sceIoDread(fd, &dir) > 0) {							// Gge擾
		if (gGetDirEnd[DList->getDirMode]) {					// f
			count = i;
			break;
		}
		if (dir.d_name[0] == '.') {
			if (dir.d_name[1] == '\0' || (dir.d_name[1] == '.' && dir.d_name[2] == '\0')) {
				continue;
			}
		}
		buf = (char*)malloc( sizeof(char) * (strlen(dir.d_name) + 1) );
		if (buf==NULL) {										// ȂI
			count = i;											// 擾ł܂ł͗L
			break;
		}
		FData[i].name2 = buf;
		strcpy( FData[i].name2, dir.d_name );					// t@C(VtgJIS)
		if (s2ch.cfg.hbl) {
			strcpy( utf8, dir.d_name );
		} else {
			psp2chSjis2UTF8( (u8*)utf8, (u8*)dir.d_name );
		}
		buf = (char*)malloc( sizeof(char) * (strlen(utf8) + 1) );
		if (buf == NULL) {										// ȂI
			free( FData[i].name2 );
			FData[i].name2 = NULL;
			count = i;											// 擾ł܂ł͗L
			break;
		}
		FData[i].name = buf;
		if (dir.d_stat.st_attr & FIO_SO_IFDIR) {				// fBNgHt@CH
			FData[i].type = 1;									// fBNg
		} else {
			type = checkExt( dir.d_name );
			if (type >= EXT_TYPE_TEXT && type < EXT_TYPE_ARCHIVE) {
				FData[i].type = 2;								// A[JCu
			} else {
				FData[i].type = 0;								// t@C
			}
		}
		strcpy( FData[i].name, utf8 );							// t@C(UTF8)
		FData[i].size = dir.d_stat.st_size;						// t@CTCY
		FData[i].mtime = dir.d_stat.st_mtime;					// XV
		FData[i].thumb = NULL;
		FData[i].xSize = 0;										// 摜XTCY (0:擾ĂȂ)
		FData[i].ySize = 0;										// 摜YTCY
		i++;
		if (i >= count) break;
	}
	sceIoDclose( fd );
	DList->count = count;
	return FData;
}

//===== TlC擾Xbh̋N =====

static void startThumbThread(DirList *DList)
{
	static strGetThumb	thDat, *th;
	char	*p;
	int		pos;

	if (!gGetDirEnd[DList->getDirMode] && DList->getDirMode==1) {
		p = strchr( DList->path2, ':' );
		if (p) {												// hCu^[Ȃ
			pos = p - DList->path2 + 1;
			strncpy( thDat.path, DList->path2, pos );
			thDat.path[pos] = '/';
			thDat.path[pos+1] = '\0';
			strcat( thDat.path, THUMBFOLDER );					// TlCtH_
			strcat( thDat.path, &DList->path2[pos] );			// TlCۑĂnỸtH_
			thDat.DList = DList;
			th = &thDat;
			gGetThumbEnd = 0;
			sceKernelStartThread( gThumbId, sizeof(strGetThumb**), (void*)&th );
		}
	}
}

//===== \[g =====

int dirSort(const void * a , const void * b )
{
	FileData	*FData1, *FData2;

	FData1 = ( FileData*  )a;
	FData2 = ( FileData*  )b;

	if ((strcmp(FData1->name,FData2->name)>0 && FData1->type==FData2->type)
	        || (!FData1->type && FData2->type)) {
		return 1;
	} else if (strcmp(FData1->name,FData2->name) == 0) {
		return 0;
	}
	return -1;
}

//===== C =====

static int getDirThread(SceSize args, void *argp)
{
	DirList		*DList;
	FileData	*FData;
	char		inPath[1024];

	//----- ݒ -----

	DList = *(DirList**)argp;

	//----- Xgꗗ擾 -----

	FData = NULL;
	switch (DList->archiveType) {
	case 0:														// ʏtH_
		FData = getSceDir( DList, DList->path2 );
		break;
	case 1:														// zipktH_
		if (strlen(DList->path2) <= strlen(DList->archiveFile)) {
			inPath[0] = '\0';
		} else {
			strcpy( inPath, &DList->path2[ strlen(DList->archiveFile) + 1 ] );
		}
		FData = unzipGetEntry( DList, DList->archiveFile, inPath );
		break;
	case 2:														// rarktH_
		if (strlen(DList->path2) <= strlen(DList->archiveFile)) {
			inPath[0] = '\0';
		} else {
			strcpy( inPath, &DList->path2[ strlen(DList->archiveFile) + 1 ] );
		}
		FData = unrarGetEntry( DList, DList->archiveFile, inPath );
		break;
	}

	if (FData == NULL) {
		DList->file = NULL;
		DList->count = 0;
		DList->complete = -1;
		sceKernelExitThread( 0 );
		return 0;
	}
	DList->file = FData;

	//----- t@Cz\[g -----

	if (s2ch.cfg.fileSort && !gGetDirEnd[DList->getDirMode] && DList->count>0) {
		qsort( (void*)FData, DList->count, sizeof(FData[0]), dirSort );
	}

	//----- TlC擾Xbh̋N -----

	DList->complete = 1;										// Xg擾
	startThumbThread( DList );

	sceKernelExitThread( 0 );
	return 0;
}


//==============================================================
// fBNg擾
//--------------------------------------------------------------
// file    F擾tH_iVtgJISj
// DListPtrFXg\
// mode    F0 TlC擾Ȃ
//           1 TlC擾
// archive F0 ێ
//           1 ktH_Ɉڍs
// ߂l  F0  I
//           -1 G[
//--------------------------------------------------------------
// w肳ꂽpX̃t@Cꗗ擾XbhN܂B
// w肳ꂽpXɃANZXoȂꍇ̓[gɃANZX݂܂A
// [gɂANZXoȂꍇ̓G[Ԃ܂B
//
// intraFontŕ\s֌WŁAVtgJISR[hx[XƃR[hϊɖł
// ȂԂ|Ă܂UTF8R[hx[XɕύXB
//
// TlCC[Wۑʒu̓[g THUMBFOLDER tH_
// ms0:/FVthumb/PICTURE/hoge.jpg.dat
//
// fBNg̎擾̓}`Xbhōs邽߁AXg̎擾ɂ͎Ԃ|܂B
// Xg擾o<DListPtr->complete>0ȊO̒lɂȂ܂B
//--------------------------------------------------------------

static int GetDir(char* file, DirList **DListPtr, int mode, int archive)
{
	SceUID	fd;
	DirList	*DList;
	char	*p, path[1024];
	int		err;

	//----- ֘AXbh̋~ -----

	if (sceKernelGetThreadExitStatus(gGetDirId[mode]) != 0) {
		gGetDirEnd[mode] = -1;									// fBNgꗗ擾̒~
		sceKernelWaitThreadEnd( gGetDirId[mode], NULL );
	}

	if (mode) {
		gGetThumbEnd = -1;										// TlCꗗ擾̒~
		sceKernelWaitThreadEnd( gThumbId, NULL );
	}

	//----- ݒ -----

	DList = *DListPtr;

	if (archive != 0) {											// ktH_ֈڍsꍇ
		strcpy( DList->archiveFile, file );
		if (checkExt(file) == EXT_TYPE_ZIP) {
			DList->archiveType = 1;								// zipktH_
		} else {
			DList->archiveType = 2;								// rarktH_
		}
		readArcPass( DList->archivePass, file );				// TlCt@CpX[h擾
	} else {													// ێ̏ꍇiktH_甲Hj
		if (DList->archiveType != 0) {
			if (memcmp(file,DList->archiveFile,strlen(DList->archiveFile)) != 0) {
				DList->archiveType = 0;							// ktH_甲
				DList->archiveFile[0] = '\0';
				DList->archivePass[0] = '\0';
			}
		}
	}

	strcpy( path, file );
	err = 0;
	switch (DList->archiveType) {								// tH_/A[JCuɃANZXo邩
	case 0:														// ʏtH_
		if (path[strlen(path)-1]=='\\') strcat( path,"\\" );
		if ((fd = sceIoDopen(path)) < 0) {						// path̍Ō'\'Ƃȓc?
			ErrorDialog( DIR_OPEN_ERR, file );
			err = 1;
		}
		sceIoDclose(fd);
		break;
	case 1:														// zipktH_
		if (unzipCheck(DList->archiveFile) != 0) {				// zipt@CJȂ
			DList->archiveType = 0;
			DList->archiveFile[0] = '\0';
			DList->archivePass[0] = '\0';
			ErrorDialog( ARC_OPEN_ERR, DList->archiveFile );
			err = 1;
		}
		break;
	case 2:														// rarktH_
		if (unrarCheck(DList->archiveFile) != 0) {				// rart@CJȂ
			DList->archiveType = 0;
			DList->archiveFile[0] = '\0';
			DList->archivePass[0] = '\0';
			ErrorDialog( ARC_OPEN_ERR, DList->archiveFile );
			err = 1;
		}
		break;
	}

	if (err != 0) {												// tH_/A[JCuɃANZXoȂȂ
		p = strchr( path, ':' );
		if (p) {
			*(p+1) = '\0';
		} else {												// 肦ȂnY
			strcpy( path, "ms0:" );
		}
		if ((fd = sceIoDopen(path)) < 0) {
			DList->complete = -1;
			return -1;											// [gɃANZXoȂȂI
		}
		strcpy( file, path );
	}

	//----- fBNgGg擾XbhN -----

	if (mode > 1) mode = 1;
	psp2chSjis2UTF8( (u8*)DList->path, (u8*)path );
	strcpy( DList->path2, path );
	DList->pos = 0;
	DList->complete = 0;
	DList->count = 0;
	DList->file = NULL;
	DList->getDirMode = mode;
	gGetDirEnd[mode] = 0;
	gGetThumbEnd = 0;
	sceKernelStartThread( gGetDirId[mode], sizeof(DirList**), (void*)&DList );

	return 0;
}


//==============================================================
// j[\
//--------------------------------------------------------------
// resetF0 ʏ퓮
//        1 J[\\ȂAJ[\ʒu
// x    Fj[̕\ʒu
//--------------------------------------------------------------
// gMenuɏ]j[̍ږƃJ[\̍sB
// wi̍ListDraw()ŏB
//--------------------------------------------------------------

static void menuDraw(int reset, int x)
{
	static int		blink, blFlg, posBak;
	static float	fx;
	float			rate;
	int				i, pos;

	if (reset) {
		if (gMenu.pos < 0) {
			fx = 5 + (gMenu.count1 - (-gMenu.pos)) * 18;
		} else {
			fx = STARTY + (gMenu.pos - gMenu.top) * 18;
		}
		posBak = -100;
	}
	if (posBak != gMenu.pos) {
		posBak = gMenu.pos;
		blink = 100;
		blFlg = 0;
	}

	if (gMenu.count1==0 && gMenu.count2==0) return;				// j[ڂ

	rate = (gMenuCount*gMenuCount) / 49.0f;
	if (gMenu.type == 0) {
		for (i = 0; i < gMenu.count1; i++) {					// tH_[n
			if_printSjis( x+5, 5+12 + i*18, gMenuItem[gMenu.item1[i]], 0.6f, 0xFFFFFF, 0x000000, rate );
		}
		for (i = 0; i < gMenu.count2; i++) {					// t@Cn
			if_printSjis( x+5, STARTY+14 + i*18, gMenuItem[gMenu.item2[i]], 0.6f, 0xFFFFFF, 0x000000, rate );
		}
	} else {
		for (i = 0; i < gMenu.count2; i++) {					// ݒ荀
			if_printSjis( x+5, STARTY+14 + (i-gMenu.top)*18, gMenu.item3[i], 0.6f, 0xFFFFFF, 0x000000, rate );
		}
	}

	if (gMenu.pos < 0) {										// J[\̖ڕWʒu
		pos = 5 + (gMenu.count1 - (-gMenu.pos)) * 18;
	} else {
		pos = STARTY + 2 + (gMenu.pos - gMenu.top) * 18;
	}
	fx += (pos - fx) / 2;										// J[\ʒüړ
	if (abs(pos-fx)==0) fx = pos;
	if (!reset) {
		DrawPicAlpha( x, fx, gCsrImg, blink/100.0f, 1.0f );
	}
	if (blFlg) {												// J[\_
		blink += 3;
		if (blink >= 100) {
			blink = 100;
			blFlg = 0;
		}
	} else {
		blink -= 3;
		if (blink < 0) {
			blink = 0;
			blFlg = 1;
		}
	}
}


//==============================================================
// BGMj[\
//--------------------------------------------------------------
// yF    j[̕\ʒu
// resetF0ȊO wiC[W
//--------------------------------------------------------------
// gMenuɏ]BGMj[̍sB
//--------------------------------------------------------------

static void bgmMenuDraw(int y, int reset)
{
	const char		*ch[4] = { "ڵ", "ޮĽڵ", "ޭ", "" };
	char			str[256], buf[128], *p;
	int				i, sec1, min1, sec2, min2, pos;
	float			rate;
	Color			cor[4] = { 0xFFA0A0, 0xFF8080, 0xFF6060, 0xC06060 };
	static int		bgmID;
	static float	x[4];

	//----- wi -----

	if (reset) {
		for (i = 0; i < 16; i++) {
			BoxFillImage( gEtcImg, 0, i, 480, 1, 0xFFD09090-(i<<26) );
		}
		BoxFillImage( gEtcImg, 0, i, 480, 32-i, 0xC0D09090 );	// j[wi}XN
	}
	DrawPicAlpha( 0, y, gEtcImg, MENUALPHA, 1.0f );
	DrawPicAlpha2( 0, y+32, gEtcImg, 0, 16, 480, 16, MENUALPHA, 1.0f );	// TCYȂ̂
	DrawPicAlpha2( 0, y+48, gEtcImg, 0, 16, 480, 16, MENUALPHA, 1.0f );	// TCYȂ̂
	DrawPicAlpha2( 0, y+64, gEtcImg, 0, 16, 480, 16, MENUALPHA, 1.0f );	// TCYȂ̂

	//----- e -----

	if (gBGM.bgmID != bgmID) {									// BGMς
		bgmID = gBGM.bgmID;
		x[0] = 53;
		x[1] = 53;
		x[2] = 53;
		x[3] = 53;
	}

	rate = (gMenuCount2*gMenuCount2) / 49.0f;
	if_printSjis( 5, y+14*1, "^Cg:", 0.6f, 0xFFFFFF, 0x000000, rate );
	sprintf( str, "%s ", gBGM.title );
	intraFontSetStyle( gJpn0, 0.6f, 0xFFFFFFFF, 0x000000, INTRAFONT_SCROLL_LEFT );
	x[0] = intraFontPrintColumn( gJpn0, x[0], y+14*1, 280-53, str );
	str[0] = '\0';
	if (gBGM.year[0]) {											// <N>񂪗LȂ
		sprintf( str, "N:%s  ", gBGM.year );
	}
	if (gBGM.SamplingRate) {
		sprintf( buf, "%dHz %dkbps", gBGM.SamplingRate, gBGM.bitRate );
		strcat( str, buf );
		if_printSjis( 290, y+14*1, str, 0.6f, 0xFFFFFF, 0x000000, rate );
	}

	if_printSjis( 5, y+14*2, "è:", 0.6f, 0xFFFFFF, 0x000000, rate );
	sprintf( str, "%s ", gBGM.artist );
	intraFontSetStyle( gJpn0, 0.6f, 0xFFFFFFFF, 0x000000, INTRAFONT_SCROLL_LEFT );
	x[1] = intraFontPrintColumn( gJpn0, x[1], y+14*2, 470-53, str );

	if_printSjis( 5, y+14*3, "Ao:", 0.6f, 0xFFFFFF, 0x000000, rate );
	sprintf( str, "%s ", gBGM.album );
	intraFontSetStyle( gJpn0, 0.6f, 0xFFFFFFFF, 0x000000, INTRAFONT_SCROLL_LEFT );
	x[2] = intraFontPrintColumn( gJpn0, x[2], y+14*3, 470-53, str );

	if_printSjis( 5, y+14*4, "Rg:", 0.6f, 0xFFFFFF, 0x000000, rate );
	sprintf( str, "%s ", gBGM.comment );
	intraFontSetStyle( gJpn0, 0.6f, 0xFFFFFFFF, 0x000000, INTRAFONT_SCROLL_LEFT );
	x[3] = intraFontPrintColumn( gJpn0, x[3], y+14*4, 400-53, str );

	if (gBGM.SamplingRate == 0) {
		sec1 = 0;
		min1 = 0;
		sec2 = 0;
		min2 = 0;
	} else {
		sec1 = (gBGM.pos / gBGM.SamplingRate) % 60;
		min1 = (gBGM.pos / gBGM.SamplingRate) / 60;
		sec2 = (gBGM.time / 100) % 60;
		min2 = (gBGM.time / 100) / 60;
	}
	sprintf( str, "%d:%02d / %d:%02d", min1, sec1, min2, sec2 );
	pos = intraFontMeasureText( gJpn0, str );
	if_printSjis( 475 - pos, y+58, str, 0.6f, 0xFFFFFF, 0x000000, rate );

	DrawBoxfillGu( 5, y+61, 470, 4, 0xFFFFFF, rate );
	if (gBGM.time) {											// Ȃ̒擾ĂȂ
		pos = (gBGM.pos / (gBGM.SamplingRate/100) ) * 470 / gBGM.time;
		if (pos) {
			for (i = 0; i < 4; i++) {
				DrawLineGu( 5, y+61 + i, 5+pos, y+61 + i, cor[i], rate );
			}
		}
	}

	//----- KC_X -----

	switch (audioGetPlayMode()) {
	case 0:														// Đ
		p = ":PAUSE";
		break;
	case 1:														// ~
		p = ":Đ";
		break;
	case 2:														// ꎞ~
		p = ":ĊJ";
		break;
	default:													// ̑
		p = ":Đ";
	}
	if_printSjis( 5, y+76, p, 0.6f, 0xFFFFFF, 0x000000, rate );
	if_printSjis( 70, y+76, ":~  :Ȃ̎n  k:Ő  q:̋  ~:߂", 0.6f, 0xFFFFFF, 0x000000, rate );

	//----- ڍ׏ -----

	if (gBGM.infoFlag) {
		str[0] = '\0';
		if (gBGM.info) {										// 
			strcat( str, gBGM.info );
		}
		if (gBGM.pvFlag) {										// 摜
			const char	imgType[3][5] = { "none", "jpeg", "png" };
			sprintf( buf, "ImageType : %s\nDataSize : %d\nXYSize : %d x %d", 
			               imgType[gBGM.imageType], gBGM.dataSize, gBGM.pv.orgTex->width, gBGM.pv.orgTex->height );
			if (str[0]) strcat( str, "\n\n" );
			strcat( str, buf );
		}
		if_print( 10, 40, str, 0.6f, 0xFFFFFF, 0x101010, rate );
	}
}


//==============================================================
// BGMj[ł̃L[
//--------------------------------------------------------------

static void doBgmMenu(SceCtrlData pad)
{
	if (pad.Buttons & PSP_CTRL_CIRCLE) {						//  
		audioPlay( NULL, NULL );								// ꎞ~/ĊJ
	} else if (pad.Buttons & PSP_CTRL_RTRIGGER) {				// [q]
		audioNext();											// ̋
	} else if (pad.Buttons & PSP_CTRL_LTRIGGER) {				// [k]
		audioBack();											// Ő
	} else if (pad.Buttons & PSP_CTRL_UP) {						// []
		audioStop();
	} else if (pad.Buttons & PSP_CTRL_DOWN) {					// []
		audioReplay();											// Ȃ̎n
	} else if (pad.Buttons & PSP_CTRL_SELECT) {					// [SELECT]
		gBGM.infoFlag ^= 1;
	}
}


//==============================================================
// BGMWPbg摜Xbh
//--------------------------------------------------------------
// gBGM.modeFw
//   0 w
//   1 WPbg摜WJ
//   2 WPbg摜
//  -1 XbhI
//--------------------------------------------------------------
// gBGM.mode̎wɏ]BGMWPbg摜̓WJ/wsB
// ̃Xbh͏ɋNĂB
//--------------------------------------------------------------

static int bgmImageThread(SceSize args, void *argp)
{
	int		mode;

	mode = 0;
	while (gBGM.mode >= 0) {
		switch (gBGM.mode) {
		case 1:													// WJ
			gBGM.mode = 0;
			if (sceKernelGetThreadExitStatus(gBgmImageSubId) != 0) {
				sceKernelWaitThreadEnd( gBgmImageSubId, NULL );
			}
			if (gBGM.mode == 0) {
				mode = 1;
				sceKernelStartThread( gBgmImageSubId, sizeof(void*), (void*)&mode );
			}
			break;
		case 2:													// 
			gBGM.mode = 0;
			if (sceKernelGetThreadExitStatus(gBgmImageSubId) != 0) {
				sceKernelWaitThreadEnd( gBgmImageSubId, NULL );
			}
			if (gBGM.mode == 0) {
				mode = 2;
				sceKernelStartThread( gBgmImageSubId, sizeof(void*), (void*)&mode );
			}
			break;
		default:
			gBGM.mode = 0;
			break;
		}
		sceDisplayWaitVblankStart();							// VuN҂
	}

	sceKernelExitThread(0);
	return 0;
}


//==============================================================
// BGMWPbg摜̓WJ/
//--------------------------------------------------------------
// bgmImageThreadwꂽsB
//--------------------------------------------------------------

static int bgmImageSubThread(SceSize args, void *argp)
{
	int		*mode;

	mode = (int*)argp;

	if (*mode == 1) {											// WJ
		gBGM.pvFlag = 0;
		freeTexMem( &gBGM.pv );									// BGMWPbg摜
		imageDecode( &gBGM.pv, gBGM.imageType, gBGM.data, gBGM.dataSize, 480, 272-80 );
		gBGM.pvFlag = 1;										// 摜f[^gp
	} else if (*mode == 2) {									// 
		gBGM.pvFlag = 0;
		freeTexMem( &gBGM.pv );									// BGMWPbg摜
	}
	sceKernelExitThread(0);
	return 0;
}


//==============================================================
// BGMWPbg摜̕\
//--------------------------------------------------------------

static void bgmImageDraw(int reset)
{
	float		alpha, range;
	static int	mode, count, bgmID;

	if (reset) {
		mode = 0;
		count = 0;
	}

	switch (mode) {
	case 0:														// 摜\ĂȂ
		if (gBGM.imageType) {									// WPbg摜LȂ
			mode = 1;
			bgmID = gBGM.bgmID;
			gBGM.mode = 1;										// 摜WJ
		}
		break;
	case 1:														// 摜WJ
		if (gBGM.pvFlag) {										// WJ
			mode = 2;
			count = 0;
		}
		break;
	case 2:														// 摜tF[hC
		count++;
		if (count >= 7) mode = 3;
		if (bgmID != gBGM.bgmID) mode = 4;						// LZ
		break;
	case 3:														// 摜\
		if (bgmID != gBGM.bgmID) mode = 4;
		break;
	case 4:														// 摜tF[hAEg
		count--;
		if (count <= 0) {
			count = 0;
			mode = 5;
			gBGM.mode = 2;
		}
		break;
	case 5:														// 摜mF
		if (!gBGM.pvFlag) mode = 0;
		break;
	}

	if (gBGM.pvFlag) {											// WPbg摜LȂ
		alpha = ((gMenuCount2*gMenuCount2) / 49.0f) * ((count*count) / 49.0f);
		range = 0.85 + 0.05 * (count / 7);
		texImageDraw( &gBGM.pv, 480/2, (272-80)/2, 240*range, (272-80)*range, alpha );
	}
}


//==============================================================
// Xg\
//--------------------------------------------------------------
// DList[4]FXg
//             [0]     J[\ʒu
//             [1]     TlĈ
//             [2]-[3] ړp
// mode    FJڎw
//             0 wȂ
//             1 \Zbg
//             2 \ZbgiBGM\͂̂܂܁j
//             3 ̃fBNgֈړ
//             4 ÕfBNgֈړ
//             5 j[J
//             6 j[
//             7 BGMj[J
//             8 BGMj[
// status  FXe[^X\s
//             0    No
//             ȊO Yes
// ߂l  F0 ԑJOK
//           1 ԑJڋ֎~
//--------------------------------------------------------------
// DList[1]͈̃fBNgB
//--------------------------------------------------------------

int ListDraw(DirList *DList[], int mode, int status)
{
	static int		smode, count;
	static float	fx, fx2;
	int				i, x, y, reset, ret, complete, dlistNo;

	gListDrawFlag = 1;											// _CAO֘AtO

	//----- ԑJ -----

	reset = 0;
	ret = 0;
	dlistNo = 0;
	switch (mode) {
	case 1:														// \Zbg
		smode = 0;
		count = 0;
		gMenuCount = 0;
		ListDrawSub( DList[0], DList[1], STARTX, STARTY, 100, 100, 1 );
		goto ListDrawEnd;
		break;
	case 2:														// \ZbgiBGM\͂̂܂܁j
		smode = 0;
		count = 0;
		gMenuCount = 0;
		ListDrawSub( DList[0], DList[1], STARTX, STARTY, 100, 100, 2 );
		goto ListDrawEnd;
		break;
	case 3:														// ̃fBNgֈړ
		reset = (smode==0 ? 0 : 2);								// ړɊ荞܂ꂽ
		smode = 2;
		count = 0;
		gMenuCount = 0;
		fx = 0;
		break;
	case 4:														// ÕfBNgֈړ
		reset = (smode==0 ? 0 : 2);								// ړɊ荞܂ꂽ
		smode = 3;
		count = 0;
		gMenuCount = 0;
		fx = 0;
		break;
	case 5:														// j[J
		if (smode==0 || smode==6) {
			if (smode == 6) {									// rJiLZj
				count = 6 - count;
				fx = MENUSHIFT0 - fx;
				fx2 = gMenu.size - fx2;
			} else {											// ŏJ
				count = 0;
				fx = 0;
				fx2 = 0;
			}
			smode = 4;
		}
		break;
	case 6:														// j[
		if (smode==4 || smode==5) {
			if (smode == 4) {									// riJLZj
				count = 6 - count;
				fx = MENUSHIFT0 - fx;
				fx2 = gMenu.size - fx2;
			} else {											// ŏ
				count = 0;
				fx = 0;
				fx2 = 0;
			}
			smode = 6;
		}
		break;
	case 7:														// BGMj[J
		if (smode==0 || smode==4 || smode==6 || smode==9) {		// j[̑Jڎ͑Jڂȗ
			if (smode == 9) {									// rJiLZj
				count = 6 - count;
				fx = 0;
				fx2 = 32 - fx2;
			} else {											// ŏJ
				count = 0;
				fx = 0;
				fx2 = 0;
			}
			smode = 7;
		}
		break;
	case 8:														// BGMj[
		if (smode==7 || smode==8) {
			if (smode == 7) {									// riJLZj
				count = 6 - count;
				fx = 0;
				fx2 = 32 - fx2;
			} else {											// ŏ
				count = 0;
				fx = 0;
				fx2 = 0;
			}
			smode = 9;
		}
		break;
	}

	//----- eԂł̍揈 -----

	if (smode>=4 && smode<=6) {									// j[C[W
		for (i = 0; i < 16; i++) {
			BoxFillImage( gScrMask, i*2, 0, 2, 272, 0xFFD09090-(i<<26) );
		}
		BoxFillImage( gScrMask, 32, 0, gMenu.size-32, 272, 0xC0D09090 );	// j[wi}XN
		for (i = 0; i < 6; i++) {											// j[J[\
			BoxFillImage( gCsrImg, i, i, gMenu.size-i*2, 16-i*2, 0xFFC0C0C0-(i<<29) );
		}
	}/* else if (smode>=7 && smode<=9) {							// BGMj[C[W
		for (i = 0; i < 16; i++) {
			BoxFillImage( gEtcImg, 0, i, 480, 1, 0xFFD09090-(i<<26) );
		}
		BoxFillImage( gEtcImg, 0, i, 480, 32-i, 0xC0D09090 );	// j[wi}XN
	}
*/
	switch (smode) {
	case 0:
		ListDrawSub( DList[0], DList[1], STARTX, STARTY, 100, 100, 0 );
		break;

	case 2:														// fBNgړ(̃fBNg)
		fx += (LISTSHIFT - fx) / 4;
		complete = DList[0]->complete;
		if (complete != 0) {									// ꗗ̎擾܂őҋ@
			rollbar( DList[0] );								// XN[o[쐬
		}
		if (count < 6) {
			ListDrawSub( DList[1], DList[2], STARTX-fx, STARTY, (5-count)*20, 50+(5-count)*10, reset );
			dlistNo = 1;
			count++;
		} else if (count < 10) {
			ListDrawSub( DList[0], DList[1], STARTX+LISTSHIFT-fx, STARTY, (count-5)*30, (count-5)*30, (count==6 ? 2 : 0) );
			count++;
		} else if (count == 10) {
			ListDrawSub( DList[0], DList[1], STARTX, STARTY, 100, 100, 0 );
			deleteDirList(&DList[2]);
			count++;
		} else {
			ListDrawSub( DList[0], DList[1], STARTX, STARTY, 100, 100, 0 );
			if (complete != 0) {
				smode = 0;
			}
		}
		break;

	case 3:														// fBNgړ(ÕfBNg)
		fx += (LISTSHIFT - fx) / 4;
		complete = DList[0]->complete;
		if (complete != 0) {									// ꗗ̎擾܂őҋ@
			rollbar( DList[0] );								// XN[o[쐬
		}
		if (count < 6) {
			ListDrawSub( DList[1], DList[2], STARTX+fx, STARTY, (5-count)*20, (5-count)*20, reset );
			dlistNo = 1;
			count++;
			ret = 1;											// ԑJڋ֎~
		} else if (count == 6) {								// ꗗ̎擾܂őҋ@
			if (complete != 0 && DList[3]->complete != 0) {
				for (i=0; i<DList[0]->count ;i++){				// ܂ŋtH_̏ɃJ[\Zbg
					if (!strcmp(DList[0]->dirName,DList[0]->file[i].name2)) {
						DList[0]->pos = i;
						break;
					}
				}
				count++;
				deleteDirList( &DList[1] );
				DList[2]->file = NULL;							// [2]̃fBNg[0]ɃRs[Ă̂
				if (DList[3]->file != NULL) {
					gFileList[1] = gFileList[3];
					DList[3]->file = NULL;
					for (i = 0; i < DList[1]->count ;i++){		// tH_ʒuɃJ[\Zbg
						if (!strcmp(DList[1]->dirName,DList[1]->file[i].name2)) {
							DList[1]->pos = i;
							break;
						}
					}
				}
				ListDrawSub( DList[0], DList[1], STARTX-LISTSHIFT+fx, STARTY, 0, 100, 2 );
			} else {
				ListDrawSub( DList[1], DList[2], STARTX+fx, STARTY, 0, 0, 2 );
				dlistNo = 1;
				ret = 1;										// ԑJڋ֎~
			}
		} else if (count < 10) {
			ListDrawSub( DList[0], DList[1], STARTX-LISTSHIFT+fx, STARTY, (count-7)*20, 100, 0 );
			count++;
		} else {
			ListDrawSub( DList[0], DList[1], STARTX, STARTY, 100, 100, 0 );
			smode = 0;
			rollbar( DList[0] );								// XN[o[쐬
		}
		break;

	case 4:														// j[Jr
		fx += (MENUSHIFT0 - fx) / 4;							// Xg\ʒu␳l
		gMenuCount++;
		ListDrawSub( DList[0], DList[1], STARTX-fx, STARTY, 100*(6-count)/7, 100, 3 );
		fx2 += (gMenu.size - fx2) / 2;							// j[\ʒu␳l
		x = 480 - fx2;
		DrawPicAlpha( x, 0, gScrMask, MENUALPHA, 1.0f );
		menuDraw( 1, x );										// J[\Ńj[\
		if (count >= 6) {										// ʃVtgI
			smode = 5;
			gMenuCount = 7;
		}
		count++;
		break;

	case 5:														// j[J
		x = 480 - gMenu.size;
		ListDrawSub( DList[0], NULL, STARTX-MENUSHIFT0, STARTY, 0, 100, 3 );
		DrawPicAlpha( x, 0, gScrMask, MENUALPHA, 1.0f );
		menuDraw( 0, x );
		break;

	case 6:														// j[r
		fx += (MENUSHIFT0 - fx) / 4;							// Xg\ʒu␳l
		gMenuCount--;
		if (gMenuCount < 0) gMenuCount = 0;
		ListDrawSub( DList[0], DList[1], STARTX-MENUSHIFT0+fx, STARTY, 100*count/7, 100, 3 );
		if (count >= 6) {
			smode = 0;
			gMenuCount = 0;
		}
		fx2 += (gMenu.size - fx2) / 2;							// j[\ʒu␳l
		x = 480 - (gMenu.size - fx2);
		DrawPicAlpha( x, 0, gScrMask, MENUALPHA, 1.0f );
		menuDraw( 1, x );										// J[\Ńj[\
		count++;
		break;

	case 7:														// BGMj[Jr
		gMenuCount2++;
		if (count >= 6) {
			smode = 8;
			gMenuCount2 = 7;
		}
		ListDrawSub( DList[0], DList[1], STARTX, STARTY, 100, 100, 0 );
		fx2 += (80 - fx2) / 2;									// j[\ʒu␳l
		y = 272 - fx2;
		if (!count) {
			bgmImageDraw( 1 );									// BGMWPbg摜̕\iݒj
			bgmMenuDraw( y, 1 );								// BGMj[eiݒj
		} else {
			bgmImageDraw( 0 );									// BGMWPbg摜̕\
			bgmMenuDraw( y, 0 );								// BGMj[e
		}
		count++;
		break;

	case 8:														// BGMj[J
		ListDrawSub( DList[0], DList[1], STARTX, STARTY, 100, 100, 0 );
		bgmImageDraw( 0 );										// BGMWPbg摜̕\
		y = 272 - 80;
		bgmMenuDraw( y, 0 );									// BGMj[e
		break;

	case 9:														// BGMj[r
		gMenuCount2--;
		if (gMenuCount2 < 0) gMenuCount2 = 0;
		ListDrawSub( DList[0], DList[1], STARTX, STARTY, 100, 100, 0 );
		bgmImageDraw( 0 );										// BGMWPbg摜̕\
		fx2 += (80 - fx2) / 2;									// j[\ʒu␳l
		y = 272 - (80 - fx2);
		bgmMenuDraw( y, 0 );									// BGMj[e
		count++;
		if (count >= 7) {
			smode = 0;
			gMenuCount2 = 0;
			gBGM.mode = 2;										// WPbg摜̉
		}
		break;

	}

ListDrawEnd:
	if (status) {												// pXBGM
		statusDraw1( DList[dlistNo], 0 );
		statusDraw2( 0 );										// ƃobe[c
	}
	sceGuFinish();
	gListDrawFlag = 0;

	return ret;
}


//==============================================================
// fBNg폜
//--------------------------------------------------------------
// w肳ꂽfBNgt@C܂߂č폜B
// ɂTufBNg폜܂B
//  fileControlThread() s܂B
//--------------------------------------------------------------

//===== fBNg폜 =====

static void removeDir(char *path)
{
	SceIoDirent	dir;
	SceUID		fd;
	char		file[1024];

	if ((fd = sceIoDopen(path)) < 0) return;					// wfBNgJȂ̂ŏI
	memset( &dir, 0, sizeof(dir) );								// ȂreadɎs
	while (sceIoDread(fd, &dir) > 0) {
		if (gFileCtrlEnd) break;								// f
		DoEvent();												// ̃Xbh𓮂
		if (strcmp(dir.d_name, ".") == 0) continue;
		if (strcmp(dir.d_name, "..") == 0) continue;
		strcpy( file, path );
		strcat( file, "/" );
		strcat( file, dir.d_name );
		if (dir.d_stat.st_attr & FIO_SO_IFDIR) {				// fBNgHt@CH
			removeDir( file );									// fBNgiċAŃTufBNgj
		} else {
			sceIoRemove( file );								// t@C
			gFCdata.progPos++;
		}
	}
	sceIoDclose( fd );
	sceIoRmdir( path );
}

//===== ƗʃJEg =====
// gFCdata.progMax ɍ폜t@C̐ԂB

static void removeDirCount(char *path)
{
	SceIoDirent	dir;
	SceUID		fd;
	char		file[1024];

	if ((fd = sceIoDopen(path)) < 0) return;					// wfBNgJȂ̂ŏI
	memset( &dir, 0, sizeof(dir) );								// ȂreadɎs
	while (sceIoDread(fd, &dir) > 0) {
		if (gFileCtrlEnd) break;								// f
		DoEvent();												// ̃Xbh𓮂
		if (strcmp(dir.d_name, ".") == 0) continue;
		if (strcmp(dir.d_name, "..") == 0) continue;
		strcpy( file, path );
		strcat( file, "/" );
		strcat( file, dir.d_name );
		if (dir.d_stat.st_attr & FIO_SO_IFDIR) {				// fBNgHt@CH
			removeDirCount( file );								// fBNgiċAŃTufBNgj
		} else {
			gFCdata.progMax++;									// t@C
		}
	}
	sceIoDclose( fd );
}


//==============================================================
// t@CXbh
//--------------------------------------------------------------
// doMenu()N܂B
// ł͋̓Iȃt@CsĂ܂B
//--------------------------------------------------------------

//===== ʏtH_t@CʏtH_փRs[ =====
// ߂lF1:I
//         2:fvŒ~

static int FCTsceCopy()
{
	SceUID			fd1, fd2;
	SceIoStat		st;
	char			*buf;
	int				i, size, max;

	sceIoGetstat( gCopyFile, &st );								// Rs[t@C擾Ă
	gFCdata.progMax = st.st_size;
	gFCdata.progPos = 0;
	if ((fd1 = sceIoOpen(gCopyFile, PSP_O_RDONLY, FILE_PARMISSION)) < 0) {
		gFCdata.result = -1;
		return 1;
	}
	DoEvent();													// ̃Xbh𓮂
	if ((fd2 = sceIoOpen(gFCdata.dfile, PSP_O_WRONLY | PSP_O_CREAT, FILE_PARMISSION)) < 0) {
		sceIoClose( fd1 );
		gFCdata.result = -2;
		return 1;
	}
	max = 32 * 1024;
	for (i=0; i<4; i++) {										// 32KB`2KB͈̔͂ŏo邾傫ȍƈmۂ
		buf = (char*)malloc( max );
		if (buf != NULL) break;									// mۂł烋[vI
		max = max >> 1;
	}
	while ((size = psp2chFileRead(fd1, buf, max)) > 0) {
		DoEvent();												// ̃Xbh𓮂
		psp2chFileWrite( fd2, buf, size, "file copy" );
		gFCdata.progPos += size;
		if (gFileCtrlEnd) {
			return 2;											// fvɂ蒆f
		}
		DoEvent();												// ̃Xbh𓮂
	}
	free( buf );
	sceIoClose( fd1 );
	sceIoClose( fd2 );
	sceIoChstat( gFCdata.dfile, &st, FIO_S_IRWXU | FIO_S_IRWXG | FIO_S_IRWXO );	// t@C𕜌
	if (gCopyFileMode == 1) {
		sceIoRemove( gCopyFile );
		gCopyFile[0] = '\0';
		gCopyName[0] = '\0';
		gCopyArchive[0] = '\0';
	}
	gFCdata.result = 0;
	return 1;
}

//===== t@CXbh =====

static int fileControlThread(SceSize args, void *argp)
{
	char	*p, inpath[1024];
	int		ret, pos;

	ret = 1;													// IȂ
	gFCdata.result = 0;
	switch (gFCdata.mode) {
	case PASTE:													// t@CRs[
		switch (gFCdata.type) {
		case 0:													// ʏtH_t@C
			ret = FCTsceCopy();
			break;
		case 1:													// zipA[JCut@C
			gFCdata.progMax = 1;
			gFCdata.progPos = 0;
			p = strrchr( gFCdata.dfile, '/' );					// Ȃ͖A͂
			*p = '\0';											// fBNgpX݂̂ɂ
			strcpy( inpath, &gCopyFile[strlen(gFCdata.arcfile)+1] );
			gFCdata.result = unzipToFile( gFCdata.arcfile, inpath, gFCdata.dfile, &p[1], gFCdata.etc, gFCdata.info );
			break;
		case 2:													// rarA[JCut@C
			gFCdata.progMax = 1;
			gFCdata.progPos = 0;
			p = strrchr( gFCdata.dfile, '/' );					// Ȃ͖A͂
			*p = '\0';											// fBNgpX݂̂ɂ
			strcpy( inpath, &gCopyFile[strlen(gFCdata.arcfile)+1] );
			gFCdata.result = unrarToFile( gFCdata.arcfile, inpath, gFCdata.dfile, &p[1], gFCdata.etc, gFCdata.info );
			break;
		}
		break;

	case EXPAND:												// A[JCuWJ
		if (gFCdata.type == 0) {								// zipA[JCuȂ
			gFCdata.result = unzipToDir( gArchiveFile, gFCdata.dfile, gFCdata.etc, gFCdata.info );
		} else {												// rarA[JCuȂ
			gFCdata.result = unrarToDir( gArchiveFile, gFCdata.dfile, gFCdata.info );
		}
		break;

	case DELETEFOLDER:											// tH_폜
		gFCdata.progMax = 0;
		gFCdata.progPos = 0;
		p = strchr( gFCdata.dfile, ':' );
		if (p) {												// hCu^[Ȃ
			pos = p - gFCdata.dfile + 1;
			strncpy( inpath, gFCdata.dfile, pos );
			inpath[pos] = '/';
			inpath[pos+1] = '\0';
			strcat( inpath, THUMBFOLDER );						// TlCtH_
			strcat( inpath, &gFCdata.dfile[pos] );				// TlCۑĂnỸtH_
		}
		removeDirCount( gFCdata.dfile );
		removeDirCount( inpath );
		removeDir( gFCdata.dfile );
		removeDir( inpath );
		gFCdata.result = 0;
		break;
	}

	gFCdata.complete = ret;
	sceKernelExitThread(0);
	return 0;
}


//==============================================================
// j[s
//--------------------------------------------------------------
// ߂lF0:j[ێ
//         1:j[I
//         2:j[I(XgĎ擾)
//--------------------------------------------------------------

static int doMenu(DirList *DList)
{
	SceIoStat		st;
	enum menuTyp	typ;
	char			file[1024], file2[1024], ext[256], msg[1024], *p, *work;
	int				i, ret, count, size;

	//----- ݒ -----

	gGetThumbEnd = 1;											// TlC擾Xbhꎞ~

	if (DList->count != 0) {									// Xg񂪂Ȃ
		strcpy( file, DList->path2 );
		strcat( file, "/" );
		strcat( file, DList->file[DList->pos].name2 );			// J[\ʒut@C̃tpX
	}
	if (gMenu.pos < 0) {										// ʍ
		typ = gMenu.item1[gMenu.count1 - (-gMenu.pos)];
	} else {													// t@CŗL
		typ = gMenu.item2[gMenu.pos];
	}

	//----- t@C -----

	ret = 0;
	gFCdata.complete = 1;										// {Iɂ̓t@CXbh͓ĂȂ
	gFCdata.mode = -1;
	gFCdata.info[0] = '\0';
	switch (typ) {
	case PASTE:													// u\tv
		strcpy( file2, DList->path2 );
		strcat( file2, "/" );
		strcat( file2, gCopyName );
		if (MessageDialogYesNo("%s\n\n%s\n\n%s܂", gCopyFile, DList->path2,
		        (gCopyFileMode == 0 ? "Rs[" : "ړ")) != 1) {
			break;
		}
		if (sceIoGetstat(file2,&st) >= 0) {						// t@C݂ĂȂt@CC
			p = strrchr( file2, '.' );
			if (p) {
				strcpy( ext, p );								// gqۑ
			} else {
				ext[0] = '\0';
				p = file2 + strlen( file2 );
			}
			count = 0;
			do {												// dȂt@CT
				count++;
				sprintf( msg, " - Rs[%d%s", count, ext );
				strcpy( p, msg );
			} while (sceIoGetstat(file2,&st)>=0);
		}
		strcpy( gFCdata.dfile, file2 );
		strcpy( gFCdata.etc, gCopyArchivePass );				// pX[h
		if (gCopyArchiveType == 1) {							// zipA[JCu
			ret = unzipPass( gCopyArchive, gFCdata.etc );
			if (ret == -1) {
				MessageDialogText( "%s\n\nzipt@CJ܂iĂHj", gCopyArchive );
				gCopyFile[0] = '\0';
				gCopyArchiveType = 0;
				gCopyArchive[0] = '\0';
				ret = 1;
				break;
			} else if (ret == 1) {								// pX[hKvȂ̂
				if (pspOSKDialog("zipt@C̃pX[h", gFCdata.etc, 256, 1)!=2) {
					ret = 1;
					break;										// LZ
				}
				if (unzipPass( gCopyArchive, gFCdata.etc ) != 0) {
					MessageDialogText( "%s\n\npX[hv܂", gCopyArchive );
					ret = 1;
					break;
				}
				strcpy( gCopyArchivePass, gFCdata.etc );
				writeArcPass( gCopyArchive, gFCdata.etc );		// pX[hۑ
			}
		} else if (gCopyArchiveType == 2) {						// rarA[JCu
			ret = unrarPass( gCopyArchive, &gCopyFile[strlen(gCopyArchive)+1] );
			if (ret == -1) {
				MessageDialogText( "%s\n\nrart@CJ܂iĂHj", gCopyArchive );
				gCopyFile[0] = '\0';
				gCopyArchiveType = 0;
				gCopyArchive[0] = '\0';
				ret = 1;
				break;
			} else if (ret == 1) {								// pX[hKvȂ̂
				MessageDialogText( "%s\n\npX[hݒ肳Ă邽߃ANZXł܂", gCopyFile );
				gCopyFile[0] = '\0';
				gCopyArchiveType = 0;
				gCopyArchive[0] = '\0';
				ret = 1;
				break;
			}
		}
		gFCdata.mode = PASTE;
		gFCdata.type = gCopyArchiveType;
		strcpy( gFCdata.arcfile, gCopyArchive );
		gFCdata.complete = 0;									// t@CXbh
		gFileCtrlEnd = 0;
		sceKernelStartThread( gFileCtrlId, 0, NULL );
		p = strrchr( file2, '/' );
		strcpy( gSrchName, &p[1] );
		sprintf( msg, "t@C%sĂ܂", (gCopyFileMode == 0 ? "Rs[" : "ړ") );
		ret = 3;
		break;

	case EXPAND:												// uɓWJv
		if (MessageDialogYesNo("%s\n\n%s\n\nɓWJ܂", gArchiveFile, DList->path2) != 1) {
			break;
		}
		readArcPass( gFCdata.etc, gArchiveFile );				// TlCt@CpX[h擾
		if (checkExt(gArchiveFile) == EXT_TYPE_ZIP) {			// zipt@C̏ꍇ
			strcpy( file2, DList->path2 );
			ret = unzipPass( gArchiveFile, gFCdata.etc );
			if (ret == -1) {
				MessageDialogText( "%s\n\nzipt@CJ܂iĂHj", gArchiveFile );
				gArchiveFile[0] = '\0';
				ret = 1;
				break;
			} else if (ret == 1) {								// pX[hKvȂ̂
				if (pspOSKDialog("zipt@C̃pX[h", gFCdata.etc, 256, 1)!=2) {
					ret = 1;
					break;										// LZ
				}
				if (unzipPass( gArchiveFile, gFCdata.etc ) != 0) {
					MessageDialogText( "%s\n\npX[hv܂", gArchiveFile );
					ret = 1;
					break;
				}
				writeArcPass( gArchiveFile, gFCdata.etc );		// pX[hۑ
			}
			strcpy( gFCdata.dfile, file2 );
			gFCdata.mode = EXPAND;
			gFCdata.type = 0;									// ΏۂzipA[JCu
			gFCdata.complete = 0;								// t@CXbh
			gFileCtrlEnd = 0;
			sceKernelStartThread( gFileCtrlId, 0, NULL );
			strcpy( msg, "A[JCuWJĂ܂" );
			ret = 2;
		} else {												// rart@C̏ꍇ
			strcpy( gFCdata.dfile, DList->path2 );
			gFCdata.mode = EXPAND;
			gFCdata.type = 1;									// ΏۂrarA[JCu
			gFCdata.complete = 0;								// t@CXbh
			gFileCtrlEnd = 0;
			sceKernelStartThread( gFileCtrlId, 0, NULL );
			strcpy( msg, "A[JCuWJĂ܂" );
			ret = 2;
		}
		break;

	case MAKEFOLDER:											// uVKtH_쐬v
		strcpy( ext, "VKtH_" );
		if (pspOSKDialog("VKtH_̖", ext, 256, 1)==2) {
			strcpy( file2, DList->path2 );
			strcat( file2, "/" );
			strcat( file2, ext );
			if (sceIoMkdir( file2, FIO_SO_IFDIR ) < 0) {
				MessageDialogText( "VKtH_̍쐬Ɏs܂" );
				ret = 0;
			} else {
				strcpy( gSrchName, ext );
				ret = 3;
			}
		}
		break;

	case MEMOOPEN:												// uŊJv
		SMEMOfile( file );										// wt@CPSPŊJ
		ret = 1;
		break;

	case COPY:													// uRs[v
		strcpy( gCopyFile, file );
		strcpy( gCopyName, DList->file[DList->pos].name2 );
		strcpy( gCopyArchive, DList->archiveFile );
		gCopyArchiveType = DList->archiveType;
		strcpy( gCopyArchivePass, DList->archivePass );
		gCopyFileMode = 0;
		ret = 1;
		break;

	case CUT:													// u؂v
		strcpy( gCopyFile, file );
		strcpy( gCopyName, DList->file[DList->pos].name2 );
		gCopyArchive[0] = '\0';
		gCopyArchiveType = 0;									// ؂͈ktH_t@Cɑ΂ĎsłȂ
		gCopyFileMode = 1;
		ret = 1;
		break;

	case RENAME:												// uO̕ύXv
		strcpy( ext, DList->file[DList->pos].name2 );
		if (pspOSKDialog("O̕ύX", ext, 256, 1)==2) {
			if (sceIoRename( file, ext ) < 0) {
				MessageDialogText( "O̕ύXɎs܂" );
				ret = 0;
			} else {
				strcpy( gSrchName, ext );
				ret = 3;
			}
		}
		break;

	case DELETEFILE:											// t@Ću폜v
		if (MessageDialogYesNo("%s\n\ñt@C폜܂",file) == 1) {
			sceIoRemove( file );
			if (getThumbName(file2,file) == 0) {
				sceIoRemove( file2 );							// TlCt@C폜
			}
			if (strcmp(file,gCopyFile) == 0) {					// Rs[\̃t@C폜
				gCopyFile[0] = '\0';
				gCopyName[0] = '\0';
				gCopyArchive[0] = '\0';
			}
			if (strcmp(file,gArchiveFile) == 0) {				// uWJt@Cv폜
				gArchiveFile[0] = '\0';
			}
			ret = 2;
		}
		break;

	case DELETEFOLDER:											// tH_́u폜v
		if (MessageDialogYesNo("%s\n\ñtH_폜܂\nt@CiTutH_܂ށj܂߂č폜܂",file)==1) {
			strcpy( gFCdata.dfile, file );
			gFCdata.mode = DELETEFOLDER;
			gFCdata.type = 0;									// ΏۂzipA[JCu
			gFCdata.complete = 0;								// t@CXbh
			gFileCtrlEnd = 0;
			sceKernelStartThread( gFileCtrlId, 0, NULL );
			strcpy( msg, "tH_폜Ă܂" );
			ret = 2;
		}
		break;

	case EXPANDFILE:											// uWJt@Cv
		strcpy( gArchiveFile, file );
		ret = 1;
		break;

	case ARCMEMO:												// ktH_uŊJv
		work = expandToMem( file, DList, &size );				// A[JCuWJ
		if (work == NULL) {
			ret = 1;
			break;
		}
		work[size] = '\0';										// '\0'p̃͊mۂĂ
		p = strrchr( file, '/' );
		SMEMOtext( work, &p[1] );								// WJꂽf[^PSPŊJ
		free( work );
		ret = 1;
		break;
	}

	//----- t@CXbhI҂ -----
	// msgF^Cg

	if (gFCdata.complete == 0) {
		DrawImg		mask;
		DirList		*DL[4];
		float		fy, alp;
		char		utf8[512];
		int			x, y, maxLen, count, line;

		//----- bZ[W -----

		psp2chSjis2UTF8( (u8*)utf8, (u8*)msg );
		intraFontSetStyle( gJpn0, 0.7f, 0, 0, 0 );
		maxLen = intraFontMeasureText( gJpn0, utf8 );
		line = 2;

		//----- C[W -----

		mask.wx = 32;
		mask.wy = 272;
		mask.width = 512;
		mask.height = 272;
		mask.data = (Color*)&VRAM[0][480];
		BoxFillImage( &mask, 0, 0, 32, 272, 0xFF808080 );		// ʊOE̖\}XNp̈ƂĎgp
		BoxFillImage( gEtcImg, 0, 0, 480, 32, 0 );
		BoxFillImage( gEtcImg, 0, 0, 320, 1, 0xFFFFFFFF );		// ㉺̐
		for (i = 0; i < 4; i++) {
			DL[i] = &gFileList[i];								// fBNgXg
		}
		ListDraw( DL, 0, 0 );									// wiĕ`
		sceGuSync( 0, 0 );
		guStart();
		sceGuClear( GU_DEPTH_BUFFER_BIT );
		for (i = 0; i < 480/32; i++) {							// ʂÂ
			DrawPicAlpha2( i*32, 40, &mask, 0, 0, 32, 232, 0.75f, 1.0f );
		}
		sceGuFinish();
		sceGuSync( 0, 0 );
		ScreenCopy2( 1 );										// ʎ荞
		gScrBufFlg = 1;											// wiꎞobt@ω

		//----- vOXo[ -----

		count = 0;
		fy = 0;
		while (gFCdata.complete==0 && !gExitRequest) {
			sceCtrlPeekBufferPositive( &s2ch.pad, 1 );
			if (s2ch.pad.Buttons != s2ch.oldPad.Buttons) {
				s2ch.oldPad = s2ch.pad;
				if (s2ch.pad.Buttons & PSP_CTRL_CROSS) {		// ~
					gFileCtrlEnd = 1;							// fv
				}
			}

			ScreenPaste2();										// ޔĂʂWJ
			guStart();
			sceGuClear( GU_DEPTH_BUFFER_BIT );
			if (count < 7) {									// _CAOJĂ
				alp = 0.25f + (count/6.0f) * 0.5f;
				count++;
				if (count != 7) {
					fy += ((line+1) * 20/2 - fy) / 3;
				} else {
					fy = (line+1) * 20/2;
				}
				DrawPicAlpha( 240-(320/2), 272/2-fy, gEtcImg, alp, 1.0f );
				DrawPicAlpha( 240-(320/2), 272/2+fy, gEtcImg, alp, 1.0f );
				if (count == 7) {
					sceGuFinish();
					sceGuSync( 0, 0 );
					for (i = 0; i < 6; i++) {					// vOXo[C[W
						BoxFillImage( gEtcImg, 0  , i, 240, 1, (i*48<<16) + (i*48) + 0xFF00F000 );
					}
					BoxFillImage( gEtcImg, 240, 0, 240, 4, 0xFFFFFFFF );
					ScreenCopy2( 1 );							// ʎ荞
					guStart();
				}
				statusDraw1( DList, 0 );
				for (i = 0; i < 480/32; i++) {
					DrawPicAlpha2( i*32, 0, &mask, 0, 0, 32, 40, 0.75f, 1.0f );
				}

			} else {											// _CAOJꂽ
				statusDraw1( DList, 0 );
				for (i = 0; i < 480/32; i++) {
					DrawPicAlpha2( i*32, 0, &mask, 0, 0, 32, 40, 0.75f, 1.0f );
				}
				y = 272 / 2 - fy + 26;
				if_print( 240-maxLen/2, y, utf8, 0.7f, 0xFFFFFF, 0x202020, 1.0f );
				if_printSjis( 240-56, 272-8, "        ~߂", 0.7f, 0xFFFFFF, 0x202020, 1.0f );
				y = 272 / 2 + (line+1) * 20 / 2 - 18;
				if (gFCdata.progMax == 0) {
					x = 240;
				} else {
					x = 240 - 240 * gFCdata.progPos / gFCdata.progMax;
				}
				if (x > 240) x = 240;
				if (x < 0) x = 0;
				DrawPicAlpha2( 120, y, gEtcImg, x, 0, 240, 4, 0.75f, 1.0f );
			}
			statusDraw2( 0 );									// ƃobe[c
			sceGuFinish();
			sceGuSync( 0, 0 );
			sceDisplayWaitVblankStart();
			flipScreen( 0 );
		}
	}

	//-----  -----

	if (gFCdata.complete == 2) {								// 𒆒f
		switch (gFCdata.mode) {
		case PASTE:
			sceIoRemove( gFCdata.dfile );						// Rs[t@C폜
			break;
		}
	} else {
		switch (gFCdata.mode) {
		case PASTE:
			switch (gFCdata.result) {
			case -1:
				if (strlen(gFCdata.info) == 0) {
					MessageDialogText( "%s\n\nɃANZXo܂", gCopyFile );
				} else {
					MessageDialogText( "%s", gFCdata.info );
				}
				gCopyFile[0] = '\0';
				gCopyName[0] = '\0';
				gCopyArchive[0] = '\0';
				break;
			case -2:
				MessageDialogText( "%s\n\n쐬ł܂ł", gFCdata.dfile );
				break;
			}
			break;

		case EXPAND:
			if (gFCdata.result < 0) {
				MessageDialogText( gFCdata.info );
			} else {
				gArchiveFile[0] = '\0';
			}
			break;
		}
	}
	gGetThumbEnd = 0;											// TlC擾XbhĊJ
	return ret;
}


//==============================================================
// [gXg̐ݒ
//--------------------------------------------------------------
// ߂lF 0 
//         -1 Gg̎擾Ɏs
//--------------------------------------------------------------

//----- hCũZbg -----

static int GetRootSub(FileData *FData, int type, char *name, char *name2)
{
	DiskInfo	*pInfo, info;
	char		buf[128], *p;

	pInfo = &info;
	psp2chSjis2UTF8( (u8*)buf, (u8*)name );
	p = (char*)malloc( strlen(buf) + 1 );
	if (p) {
		strcpy( p, buf );
	}
	FData->name = p;
	strcpy( buf, name2 );
	p = (char*)malloc( strlen(buf) + 1 );
	if (p) {
		strcpy( p, buf );
	}
	FData->name2 = p;
	FData->type = type;
	FData->size = 0;
	if (sceIoDevctl(name2, 0x02425818, &pInfo, 4, NULL, 0) >= 0){
		FData->size = (info.cluster_free * info.sector_count) * info.sector_size;
		FData->diskSize = (info.cluster_max  * info.sector_count / 1024) * info.sector_size / 1024;
		return 0;
	} else {
		return -1;
	}
}

//----- [gXg̐ݒ -----

static int GetRoot(DirList **DListPtr)
{
	DirList		*DList;
	FileData	*FData;
	int			i, count;
	char		buf[128], *p;

	DList = *DListPtr;

	DList->path[0] = '\0';
	DList->path2[0] = '\0';
	DList->pos = 0;
	DList->count = 0;
	DList->complete = -1;
	DList->getDirMode = 0;
	FData = (FileData*)malloc( sizeof(FileData) * 3 );			// GgXgpӂĂ
	DList->file = FData;
	if (FData == NULL) {										// mۂłȂ
		return -1;
	}

	for (i = 0; i < 3; i++) {
		FData[i].name = NULL;
		FData[i].name2 = NULL;
		FData[i].thumb = NULL;
		FData[i].xSize = 0;
		FData[i].msg = NULL;
		FData[i].settingMsg = NULL;
	}

	count = 0;
	GetRootSub( &FData[count], 3, "[XeBbN", "ms0:" );

	count++;
	if (GetRootSub( &FData[count], 4, "{̃[", "ef0:" )) {
		free( FData[count].name );
		free( FData[count].name2 );
	} else {
		count++;												// ̎擾ɐĂLɂ
	}

	psp2chSjis2UTF8( (u8*)buf, "ݒ" );
	p = (char*)malloc( strlen(buf) + 1 );
	if (p) {
		strcpy( p, buf );
	}
	FData[count].name = p;
	strcpy( buf, "ݒ" );
	p = (char*)malloc( strlen(buf) + 1 );
	if (p) {
		strcpy( p, buf );
	}
	FData[count].name2 = p;
	FData[count].type = 5;
	psp2chSjis2UTF8( (u8*)buf, "e̐ݒ荀ڂύX܂" );
	p = (char*)malloc( strlen(buf) + 1 );
	if (p) {
		strcpy( p, buf );
	}
	FData[count].msg = p;
	count++;

	DList->count = count;
	return 0;
}


//==============================================================
// ݒ菈
//--------------------------------------------------------------

void setting(DirList *DList[])
{
	FileData	*FData;
	int			i, j, mode, menu, kmode, type, saveFlag;
	char		buf[128], *p;
	const int	itemCnt = 8;									// ݒ荀ڐ
	const char	*settingItem[][5] = {							// IP
		{ "Ώۂړ", "_ړ", "", "", "" },
		{ "Ȃ", "", "", "", "" },
		{ "HBLł͂Ȃ", "HBLł", "", "", "" },
		{ "", "t", "", "", "" },
		{ "PȍĐ([vȂ)", "Pȃ[v", "tH_Ŏ̋", "TutH_܂ݎ̋", "wtH_ȉŎ̋" }
	};
	const int	valList[][8] = {								/* IQ̐lZ\ */
		{ 0, 1, 3, 5, 10, 15, 20, 30 },
		{ 15, 20, 25, 30, 35, 40, 45, 50 }
	};
	const char	*settingItem2[][8] = {							// IQ
		{ "Ȃ", "P", "R", "T", "PO", "PT", "QO", "RO" },
		{ "PT", "QO", "QT", "RO", "RT", "SO", "ST", "TO" }
	};
	strSettingList	setList[] = {								// ݒ荀ڃXg
		{ "pbḧړ", "摜\\̑", &s2ch.cfg.padReverse, 0, 0, 2 },
		{ "t@Cz\\[g", "Xg\\̃t@Cꗗt@Cŕёւ邩", &s2ch.cfg.fileSort, 1, 2, 2 },
		{ "HBLœ", "", &s2ch.cfg.hbl, 2, 0, 2 },
		{ "摜kq̕", "", &s2ch.cfg.keySwap, 3, 2, 2 },
		{ "BGM[v", "BGMĐ̃[vݒ", &s2ch.cfg.bgmLoop, 4, 1, 5 },
		{ "A[JCupX[h", "߽ܰނ|̫ނJ߽ܰނۑ邩", &s2ch.cfg.arcPass, 1, 2, 2 },
		{ "TXyh", "w肳ꂽԑ삪TXyh", &s2ch.cfg.sleep, -1, 2, 8 },
		{ "pbh̗V", "pbḧ̖̑傫", &s2ch.cfg.padCutoff, -2, 2, 8 }
	};

	DList[0]->path[0] = '\0';
	DList[0]->path2[0] = '\0';
	DList[0]->pos = 0;
	DList[0]->count = 0;
	DList[0]->complete = -1;
	DList[0]->getDirMode = 0;
	FData = (FileData*) malloc(sizeof(FileData) * itemCnt);		// GgXgpӂĂ
	DList[0]->file = FData;
	if (FData == NULL) {										// mۂłȂ
		return ;
	}

	for (i = 0; i < itemCnt; i++) {
		FData[i].thumb = NULL;
		FData[i].xSize = 0;
		FData[i].msg = NULL;									// ڐ
		FData[i].settingMsg = NULL;								// [U[ݒleLXg
		FData[i].setting = 0;									// Ǘp̐l

		psp2chSjis2UTF8( (u8*)buf, (u8*)setList[i].msg );
		p = (char*)malloc( strlen(buf) + 1 );
		if (p) {
			strcpy( p, buf );
		}
		FData[i].name = p;
		strcpy( buf, setList[i].msg );
		p = (char*)malloc( strlen(buf) + 1 );
		if (p) {
			strcpy( p, buf );
		}
		FData[i].name2 = p;
		FData[i].type = 6;
		psp2chSjis2UTF8( (u8*)buf, (u8*)setList[i].info );
		p = (char*)malloc( strlen(buf) + 1 );
		if (p) {
			strcpy( p, buf );
		}
		FData[i].msg = p;
		type = setList[i].type;
		if (type >= 0) {										// In
			FData[i].setting = *setList[i].val;
			if (FData[i].setting < 0 || FData[i].setting > 4) {
				FData[i].setting = 0;
			}
			psp2chSjis2UTF8( (u8*)buf, (u8*)settingItem[type][FData[i].setting] );
		} else {												// ln
			type = -type - 1;
			FData[i].setting = 7;
			for (j = 0; j < 8; j++) {
				if (valList[type][j] >= *setList[i].val) {
					FData[i].setting = j;
					break;
				}
			}
			psp2chSjis2UTF8( (u8*)buf, (u8*)settingItem2[type][FData[i].setting] );
		}
		p = (char*)malloc( strlen(buf) + 1 );
		if (p) {
			strcpy( p, buf );
		}
		FData[i].settingMsg = p;
	}

	DList[0]->count = itemCnt;


	DList[0]->pos = 0;
	menu = 0;													// 0:Xg\ 1:j[\

	//----- ݒ菈C -----

	saveFlag = 0;
	kmode = ListDraw( DList, 3, 1 );
	while (!gExitRequest) {
		if (gDialogFlag) {										// obNXbhŃ_CAO\
			DoEvent();
			continue;
		}
		mode = 0;
		sceCtrlPeekBufferPositive( &s2ch.pad, 1 );
		if (menu == 2) {										// BGMj[\̃L[
			
		} else if (menu == 1) {									// j[\̃L[
			cursorMove( &gMenu.pos, gMenu.count2, -gMenu.count1 );
		} else {												// Xg\̃L[
			cursorMove( &DList[0]->pos, DList[0]->count, 0 );
		}
		if (DList[0]->complete && !kmode &&						// Xg̎擾I܂œ͕s
		        s2ch.pad.Buttons != s2ch.oldPad.Buttons) {
			s2ch.oldPad = s2ch.pad;

			//--- ʏ탂[h̑ ---

			if (menu == 0) {
				if (s2ch.pad.Buttons & (PSP_CTRL_CIRCLE | PSP_CTRL_RIGHT)) {	//  []
					gMenu.type = 1;								// ݒpj[
					gMenu.count1 = 0;
					gMenu.count2 = setList[ DList[0]->pos ].itemCnt;
					if (setList[DList[0]->pos].type >= 0) {
						gMenu.item3 = settingItem[ setList[DList[0]->pos].type ];
					} else {
						gMenu.item3 = settingItem2[ -setList[DList[0]->pos].type - 1 ];
					}
					gMenu.pos = FData[ DList[0]->pos ].setting;
					gMenu.top = gMenu.pos;
					switch (setList[DList[0]->pos].size) {		// j[TCY
					case 0:
						gMenu.size = MENUSHIFT1;
						break;
					case 1:
						gMenu.size = MENUSHIFT2;
						break;
					case 2:
						gMenu.size = MENUSHIFT3;
						break;
					}
					if (gMenu.count2!=0) {						// j[ڂȂ烁j[J
						menu = 1;
						mode = 5;
						sound_play( eSE_MOVE );
					}
				}

				else if (s2ch.pad.Buttons & (PSP_CTRL_LEFT | PSP_CTRL_CROSS)) {		// [][X]
					break;										// ݒ菈I
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_SQUARE) {	// 
					menu = 2;
					mode = 7;									// BGMj[J
					sound_play( eSE_MOVE );
				}
			}

			//--- j[[h̑ ---

			else if (menu == 1) {								// j[
				if (s2ch.pad.Buttons & PSP_CTRL_CIRCLE) {		// j[ڂ
					if (FData[ DList[0]->pos ].setting != gMenu.pos) {
						saveFlag = 1;
						FData[ DList[0]->pos ].setting = gMenu.pos;
						if (setList[DList[0]->pos].type >= 0) {	// wlϐɔf
							*setList[DList[0]->pos].val = gMenu.pos;
						} else {
							*setList[DList[0]->pos].val = valList[-setList[DList[0]->pos].type-1][gMenu.pos];
						}
						type = setList[ DList[0]->pos ].type;
						if (type >= 0) {						// In
							psp2chSjis2UTF8( (u8*)buf, (u8*)settingItem[type][gMenu.pos] );
						} else {								// ln
							type = -type - 1;
							psp2chSjis2UTF8( (u8*)buf, (u8*)settingItem2[type][gMenu.pos] );
						}
						p = (char*)malloc( strlen(buf) + 1 );
						if (p) {
							strcpy( p, buf );
						}
						free( FData[ DList[0]->pos ].settingMsg );
						FData[ DList[0]->pos ].settingMsg = p;
					}
					menu = 0;
					mode = 6;									// j[
					sound_play( eSE_BACK );
				}

				else if (s2ch.pad.Buttons & (PSP_CTRL_LEFT | PSP_CTRL_CROSS)) {		// [][X]
					menu = 0;
					mode = 6;									// BGMj[
					sound_play( eSE_BACK );
				}
			}

			//--- BGMj[[h̑ ---

			else if (menu == 2) {
				doBgmMenu( s2ch.pad );							// BGMj[
				if (s2ch.pad.Buttons & (PSP_CTRL_SQUARE | PSP_CTRL_CROSS)) {	// [X]
					menu = 0;
					mode = 8;									// BGMj[
					sound_play( eSE_BACK );
				}
			}
		}

		kmode = ListDraw( DList, mode, 1 );
		sceDisplayWaitVblankStart();
		sceGuSync( 0, 0 );
		flipScreen(0);
	}

	//----- RtBOt@CXV -----

	if (saveFlag) {												// ݒlύXĂ
		sceKernelStartThread( gConfigSaveId, 0, NULL );
	}
}


//==============================================================
// RtBOt@C̍XVXbh
//--------------------------------------------------------------

static int configSaveThread(SceSize args, void *argp)
{
	psp2chIniSaveConfig();
	sceKernelExitThread(0);
	return 0;
}


//==============================================================
// t@CXgꗗ
//--------------------------------------------------------------

void fileList(char* base)
{
	enum menuTyp	menuItem0[1]  = { 0 },
					menuItem1[5]  = { MEMOOPEN, COPY, CUT, RENAME, DELETEFILE },
					menuItem2[5]  = { COPY, CUT, RENAME, DELETEFILE, MEMOOPEN },
					menuItem3[2]  = { RENAME, DELETEFOLDER },
					menuItem4[5]  = { COPY, CUT, RENAME, DELETEFILE, EXPANDFILE },
					menuItem5[7]  = { COPY, CUT, RENAME, DELETEFILE, MEMOOPEN, IMAGEVIEW, IMAGESAVE },
					menuItemA1[2] = { ARCMEMO, COPY },
					menuItemA2[2] = { COPY, ARCMEMO };
	char			*p, path[1024], file[1024], buf[1024];
	DirList			*DList[4];
	int				i, ret, mode, menu, kmode;

	//----- ݒ -----

	if (base) {
		strcpy( path, base );
	} else {
		strcpy( path, s2ch.cwDir );
	}

	gGetDirId[0] = sceKernelCreateThread( "getDir_thread1", (SceKernelThreadEntry)&getDirThread, 0x30, 0x8000, 0, NULL );
	gGetDirId[1] = sceKernelCreateThread( "getDir_thread2", (SceKernelThreadEntry)&getDirThread, 0x30, 0x8000, 0, NULL );
	gThumbId = sceKernelCreateThread( "getThumbnail_thread", (SceKernelThreadEntry)&getThumbnailThread, 0x30, 0x2000, 0, NULL );
	gFileCtrlId = sceKernelCreateThread( "fileControl_thread", (SceKernelThreadEntry)&fileControlThread, 0x2F, 0x8000, 0, NULL );
	gConfigSaveId = sceKernelCreateThread( "configSave_thread", (SceKernelThreadEntry)&configSaveThread, 0x30, 0x1000, 0, NULL );
	gBgmImageId = sceKernelCreateThread( "bgmImage_thread", (SceKernelThreadEntry)&bgmImageThread, 0x30, 0x1000, 0, NULL );
	gBgmImageSubId = sceKernelCreateThread( "bgmImageSub_thread", (SceKernelThreadEntry)&bgmImageSubThread, 0x30, 0xF000, 0, NULL );
	sceKernelStartThread( gBgmImageId, 0, NULL );				// BGMWPbg摜XbhN

	for (i = 0; i < 4; i++) {
		gFileList[i].file = NULL;
		gFileList[i].archiveType = 0;
		gFileList[i].archiveFile[0] = '\0';
		gFileList[i].archivePass[0] = '\0';
		gFileList[i].complete = 1;
		DList[i] = &gFileList[i];								// fBNgXg
	}

	GetRoot( &DList[0] );										// hCȕ擾ɎԂ|̂
	deleteDirList( &DList[0] );
	if (GetDir(path, &DList[0], 1, 0)) goto endFunc;
	strcpy( buf, path );
	p = strrchr( buf, '/' );
	if (p) {
		strcpy( DList[1]->dirName, p+1 );
		*p = '\0';
		GetDir( buf, &DList[1], 0, 0 );
	}
	while (!DList[0]->complete || !DList[1]->complete) {		// ꗗ̎擾܂őҋ@
		sceDisplayWaitVblankStart();
	}
	for (i = 0; i < DList[1]->count ;i++){						// tH_ʒuɃJ[\Zbg
		if (!strcmp(DList[1]->dirName,DList[1]->file[i].name2)) {
			DList[1]->pos = i;
			break;
		}
	}
	strcpy( file, path );
	rollbar( DList[0] );										// XN[o[̍쐬

	gCopyFile[0] = '\0';										// Rs[t@C
	gCopyArchive[0] = '\0';										// Rs[A[JCut@C
	gArchiveFile[0] = '\0';										// WJt@C
	DList[0]->pos = 0;
	menu = 0;													// 0:Xg\ 1:j[\
	gScrBufFlg = 0;												// wiꎞobt@XVv 1:vXV
	gMenuCount = 0;
	gBGM.pv.reset = 0;

	//----- Xg\C -----

	kmode = ListDraw( DList, 1, 1 );
	while (!gExitRequest) {
		if (gDialogFlag) {										// obNXbhŃ_CAO\
			DoEvent();
			continue;
		}
		mode = 0;
		sceCtrlPeekBufferPositive( &s2ch.pad, 1 );
		if (menu == 2) {										// BGMj[\̃L[
			
		} else if (menu == 1) {									// j[\̃L[
			cursorMove( &gMenu.pos, gMenu.count2, -gMenu.count1 );
		} else {												// Xg\̃L[
			cursorMove( &DList[0]->pos, DList[0]->count, 0 );
		}
		if (DList[0]->complete && !kmode &&						// Xg̎擾I܂œ͕s
		        s2ch.pad.Buttons != s2ch.oldPad.Buttons) {
			s2ch.oldPad = s2ch.pad;

			//--- ʏ탂[h̑ ---

			if (menu == 0) {
				if (s2ch.pad.Buttons & (PSP_CTRL_CIRCLE | PSP_CTRL_RIGHT)) {	//  []
					if (DList[0]->count!=0 && DList[0]->file) {	// XgȂ
						strcpy( file, path );
						strcat( file, "/" );
						strcat( file, DList[0]->file[DList[0]->pos].name2 );
						ret = DList[0]->file[DList[0]->pos].type;
						if (ret == 1) {							// ΏۂtH_Ȃ
							if (DList[2]->file) {
								deleteDirList( &DList[2] );
							}
							gFileList[2] = gFileList[1];		// fBNgXgꎞޔ
							gFileList[1] = gFileList[0];		// fBNgXgꎞޔ
							strcpy( path, file );
							if (GetDir(path,&DList[0],1,0)) {
								if (GetRoot( &DList[0] )) {		// fBNg擾łȂȂ烋[gXg擾
									break;						// [gXg擾łȂȂI
								}
								deleteDirList( &DList[2] );
								deleteDirList( &DList[1] );
								path[0] = '\0';
							}
							mode = 3;							// fBNgړJ(̃fBNg)
							sound_play( eSE_MOVE );
						} else if (ret == 2) {					// ΏۂA[JCuȂ
							if (DList[2]->file) {
								deleteDirList( &DList[2] );
							}
							gFileList[2] = gFileList[1];		// fBNgXgꎞޔ
							gFileList[1] = gFileList[0];		// fBNgXgꎞޔ
							strcpy(path, file);
							if (GetDir(path,&DList[0],1,1)) {
								if (GetRoot( &DList[0] )) {		// fBNg擾łȂȂ烋[gXg擾
									break;						// [gXg擾łȂȂI
								}
								deleteDirList( &DList[2] );
								deleteDirList( &DList[1] );
								path[0] = '\0';
							}
							mode = 3;							// fBNgړJ(̃fBNg)
							sound_play( eSE_MOVE );
						} else if (ret==3 || ret==4) {			// Xe,{̃[
							strcpy( file, DList[0]->file[DList[0]->pos].name2 );
							if (DList[2]->file) {
								deleteDirList( &DList[2] );
							}
							if (DList[1]->file) {
								deleteDirList( &DList[1] );
							}
							gFileList[1] = gFileList[0];		// fBNgXgꎞޔ
							strcpy(path, file);
							if (GetDir(path,&DList[0],1,0)) {
								if (GetRoot(&DList[0])) {		// fBNg擾łȂȂ烋[gXg擾
									break;						// [gXg擾łȂȂI
								}
								deleteDirList( &DList[1] );
								path[0] = '\0';
								mode = 1;
							} else {
								mode = 3;						// fBNgړJ(̃fBNg)
								sound_play( eSE_MOVE );
							}
						} else if (ret == 5) {					// ݒ
							if (DList[2]->file) {
								deleteDirList( &DList[2] );
							}
							if (DList[1]->file) {
								deleteDirList( &DList[1] );
							}
							gFileList[1] = gFileList[0];		// fBNgXgꎞޔ
							gGetThumbEnd = -1;					// TlC擾Xbh̒~
							sceKernelWaitThreadEnd( gThumbId, NULL );
							sound_play( eSE_MOVE );
							setting( DList );					// ݒ菈
							gFileList[2] = gFileList[1];		// fBNgXgꎞޔ
							gFileList[1] = gFileList[0];		// fBNgXgꎞޔ
							if (gFileList[2].file != NULL) {	// 擾ς݃fBNg񂪗LȂėp
								gGetThumbEnd = -1;				// TlC擾Xbh̒~
								sceKernelWaitThreadEnd( gThumbId, NULL );
								gFileList[0] = gFileList[2];
							} else {
								if (GetRoot(&DList[0])) {		// [gXg擾
									break;
								}
							}
							path[0] = '\0';
							deleteDirList( &DList[3] );
							mode = 4;							// fBNgړJ(ÕfBNg)
							sound_play( eSE_BACK );
						} else if (ret == 6) {					// ڑI
							mode = 1;
							sound_play( eSE_MOVE );
						} else if (s2ch.pad.Buttons & PSP_CTRL_CIRCLE) {	// t@CʂƂ̓
							ret = checkExt( file );
							if (ret < EXT_TYPE_TEXT) {			// t@CȂ
								if (ret < EXT_TYPE_IMAGE) {		// 摜t@CȂ
									ListDraw( DList, 1, 1 );
								}
								gScrBufFlg = 1;
								doFile( path, file, DList[0] );
								gScrBufFlg = 1;
								mode = 1;
							}
						}
					}
				}

				else if (s2ch.pad.Buttons & (PSP_CTRL_LEFT | PSP_CTRL_CROSS)) {		// [][X]
					p = strrchr( path, '/' );
					if (p) {									// ݈ʒu[gȊȌꍇ
						if (DList[2]->file) {
							deleteDirList( &DList[2] );
						}
						gFileList[2] = gFileList[1];			// fBNgXgꎞޔ
						gFileList[1] = gFileList[0];			// fBNgXgꎞޔ
						if (strcmp(DList[2]->archiveFile,DList[1]->archiveFile) == 0) {
							strcpy( DList[2]->archivePass, DList[1]->archivePass );	// A[JCũpX[hRs[
						}
						if (gFileList[2].file != NULL) {		// 擾ς݃fBNg񂪗LȂėp
							gGetThumbEnd = -1;					// TlC擾Xbh̒~
							sceKernelWaitThreadEnd( gThumbId, NULL );
							gFileList[0] = gFileList[2];
							strcpy( DList[0]->dirName, p+1 );
							DList[0]->getDirMode = 1;
							startThumbThread( DList[0] );		// TlC擾XbhN
							*p = '\0';							// Ԍɂ'/'̈ʒuȌ폜
						} else {
							strcpy( DList[0]->dirName, p+1 );	// ܂ŋtH_ۑ
							*p = '\0';							// Ԍɂ'/'̈ʒuȌ폜
							if (GetDir(path,&DList[0],1,0)) {	// fBNgꗗ̎擾
								if (GetRoot( &DList[0] )) {		// fBNg擾łȂȂ烋[gXg擾
									break;						// [gXg擾łȂȂI
								}
								deleteDirList( &DList[2] );
								deleteDirList( &DList[1] );
								path[0] = '\0';
							}
						}
						strcpy( buf, path );
						p = strrchr( buf, '/' );
						if (p) {
							strcpy( DList[3]->archiveFile, DList[0]->archiveFile );
							DList[3]->archiveType = DList[0]->archiveType;
							strcpy( DList[3]->archivePass, DList[0]->archivePass );
							strcpy( DList[3]->dirName, p+1 );
							*p = '\0';
							if (GetDir(buf,&DList[3],0,0)) {;	// ̃fBNg擾
								if (GetRoot(&DList[0])) {		// fBNg擾łȂȂ烋[gXg擾
									break;						// [gXg擾łȂȂI
								}
								deleteDirList( &DList[1] );
								deleteDirList( &DList[2] );
								path[0] = '\0';
							}
						} else {
							if (GetRoot(&DList[3])) {			// [gXg擾
								break;
							}
							for (i = 0; i < DList[3]->count; i++) {
								if (strcmp(buf,DList[3]->file[i].name2) == 0) {
									DList[3]->pos = i;
									break;
								}
							}
						}
						mode = 4;								// fBNgړJ(ÕfBNg)
						sound_play( eSE_BACK );
					} else if (path[0] != '\0') {				// [gXgł͂ȂȂ
						if (DList[2]->file) {
							deleteDirList( &DList[2] );
						}
						gFileList[2] = gFileList[1];			// fBNgXgꎞޔ
						gFileList[1] = gFileList[0];			// fBNgXgꎞޔ
						if (gFileList[2].file != NULL) {		// 擾ς݃fBNg񂪗LȂėp
							gGetThumbEnd = -1;					// TlC擾Xbh̒~
							sceKernelWaitThreadEnd( gThumbId, NULL );
							gFileList[0] = gFileList[2];
						} else {
							if (GetRoot(&DList[0])) {			// [gXg擾
								break;
							}
						}
						path[0] = '\0';
						deleteDirList( &DList[3] );
						mode = 4;								// fBNgړJ(ÕfBNg)
						sound_play( eSE_BACK );
					} else if (s2ch.pad.Buttons & PSP_CTRL_CROSS) {	// ~
						if (MessageDialogYesNo(FV_MESSAGE_END) == PSP_UTILITY_MSGDIALOG_RESULT_YES){
							break;
						}
					}
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_TRIANGLE) {	// 
					gMenu.type = 0;								// t@Cpj[
					gMenu.size = MENUSHIFT1;
					gMenu.top = 0;								// ڊJnʒu
					gMenu.count1 = 0;
					gMenu.count2 = 0;
					if (strlen(path) != 0) {					// [gXgł͂ȂȂ
						if (DList[0]->archiveType == 0) {		// ʏtH_̃tH_
							gMenu.item1[gMenu.count1++] = MAKEFOLDER;
							if (gArchiveFile[0] != '\0') {
								gMenu.item1[gMenu.count1++] = EXPAND;
							}
							if (gCopyFile[0] != '\0') {
								gMenu.item1[gMenu.count1++] = PASTE;
							}
						}
					}
					if (DList[0]->count == 0 || strlen(path) == 0) {	// Xg/[gXgȂ
						gMenu.count2 = 0;
						gMenu.item2 = menuItem0;
						gMenu.pos = -1;
					} else if (DList[0]->archiveType == 0) {	// ʏtH_̃t@C
						int		extType;
						switch (DList[0]->file[DList[0]->pos].type) {
						case 0:									// t@C̏ꍇ
							extType = checkExt( DList[0]->file[DList[0]->pos].name );
							if (extType >= EXT_TYPE_MOVIE && extType < EXT_TYPE_TEXT) {
								gMenu.count2 = 5;
								gMenu.item2 = menuItem1;		// eLXgt@C
/*							} else if (extType == EXT_TYPE_MP3) {	// mp3t@C
								SceUID	fd;
								strBgm	bgm;
								int		start, end;
								bgm.data = NULL;
								bgm.info = NULL;
								strcpy( file, path );
								strcat( file, "/" );
								strcat( file, DList[0]->file[DList[0]->pos].name2 );
								fd = sceIoOpen( file, PSP_O_RDONLY, FILE_PARMISSION );
								if (fd >= 0) {
									getMP3FileTag( fd, &bgm, &start, &end );
									if (bgm.dataSize) {			// WPbg摜Ȃ
										gMenu.count2 = 7;
										gMenu.item2 = menuItem5;	// mp3WPbg摜
									} else {
										gMenu.count2 = 5;
										gMenu.item2 = menuItem2;	// ̑̃t@C
									}
									bgmPropertyClear( &bgm );
									sceIoClose( fd );
								} else {
									gMenu.count2 = 5;
									gMenu.item2 = menuItem2;		// ̑̃t@C
								}
*/							} else {
								gMenu.count2 = 5;
								gMenu.item2 = menuItem2;		// ̑̃t@C
							}
							break;
						case 1:									// tH_̏ꍇ
							gMenu.count2 = 2;
							gMenu.item2 = menuItem3;
							break;
						case 2:									// A[JCȕꍇ
							gMenu.count2 = 5;
							gMenu.item2 = menuItem4;
							break;
						}
						gMenu.pos = 0;
					} else {									// ktH_̃t@C
						int		extType;
						switch (DList[0]->file[DList[0]->pos].type) {
						case 0:									// t@C̏ꍇ
						case 2:									// A[JCȕꍇiktH_̃A[JCu͒ʏt@CƌȂj
							extType = checkExt( DList[0]->file[DList[0]->pos].name );
							if (extType >= EXT_TYPE_MOVIE && extType < EXT_TYPE_TEXT) {
								gMenu.count2 = 2;
								gMenu.item2 = menuItemA1;		// eLXgt@C
							} else {
								gMenu.count2 = 2;
								gMenu.item2 = menuItemA2;		// ̑̃t@C
							}
							gMenu.pos = 0;
							break;
						case 1:									// tH_̏ꍇ
							gMenu.count2 = 0;
							gMenu.item2 = menuItem0;
							gMenu.pos = -1;
							break;
						}
					}
					if (gMenu.count1!=0 || gMenu.count2!=0) {	// j[ڂȂ烁j[J
						menu = 1;
						mode = 5;
						sound_play( eSE_MOVE );
					}
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_SQUARE) {	// 
					menu = 2;
					mode = 7;									// BGMj[J
					sound_play( eSE_MOVE );
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_RTRIGGER) {
					audioNext();								// ̋
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_LTRIGGER) {
					audioBack();								// Ő
				}
			}

			//--- j[[h̑ ---

			else if (menu == 1) {
				if (s2ch.pad.Buttons & PSP_CTRL_CIRCLE) {		// j[ڂ
					ret = doMenu( DList[0] );
					if (ret > 0) {
						menu = 0;
						mode = 6;
						if (ret >= 2 && ret <= 3) {
							int		posBak;
							posBak = DList[0]->pos;
							if (DList[3]->file) {
								deleteDirList( &DList[3] );
							}
							gFileList[3] = gFileList[0];
							gFileList[0].file = NULL;
							if (GetDir(path,&DList[0],1,0)) {
								break;							// Xg̎擾ɎsI
							}
							DList[3] = &gFileList[0];
							DList[0] = &gFileList[3];
							while (!gExitRequest) {				// Xg̍Ď擾I܂őҋ@
								if (DList[3]->complete) break;
								ListDraw( DList, mode, 1 );
								mode = 0;
								sceDisplayWaitVblankStart();
								sceGuSync( 0, 0 );
								flipScreen( 0 );
							}
							deleteDirList( &DList[0] );
							DList[3] = &gFileList[3];
							DList[0] = &gFileList[0];
							if (DList[0]->count <= posBak) posBak = DList[0]->count - 1;
							DList[0]->pos = posBak;				// ÕJ[\ʒu𕜌
							if (ret == 3) {						// Ώۃt@C̈ʒuT
								for (i = 0; i < DList[0]->count; i++) {
									if (strcmp(DList[0]->file[i].name2,gSrchName) == 0) {
										DList[0]->pos = i;
										break;
									}
								}
							}
							mode = 2;
						}
					}
				}

				else if (s2ch.pad.Buttons & (PSP_CTRL_CROSS | PSP_CTRL_TRIANGLE)) {	// [X]
					menu = 0;
					mode = 6;									// j[
					sound_play( eSE_BACK );
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_RTRIGGER) {
					audioNext();								// ̋
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_LTRIGGER) {
					audioBack();								// Ő
				}
			}

			//--- BGMj[[h̑ ---

			else if (menu == 2) {
				doBgmMenu( s2ch.pad );							// BGMj[
				if (s2ch.pad.Buttons & (PSP_CTRL_SQUARE | PSP_CTRL_CROSS)) {	// [X]
					menu = 0;
					mode = 8;									// BGMj[
					sound_play( eSE_BACK );
				}
			}
		}

		if (gDialogFlag) {										// obNXbhŃ_CAO\
			DoEvent();
			continue;
		}

		kmode = ListDraw( DList, mode, 1 );
		sceDisplayWaitVblankStart();
		sceGuSync( 0, 0 );
		flipScreen( 0 );
	}

	//----- I -----

	sceKernelWaitThreadEnd( gBgmImageSubId, NULL );				// 摜WJƂ̎Ŗ肪N̂
	freeTexMem( &gBGM.pv );										// BGMWPbg摜
	gGetThumbEnd = -1;
	sceKernelWaitThreadEnd( gThumbId, NULL );
	for (i = 0; i < 4; i++) {
		deleteDirList( &DList[i] );
	}
endFunc:
	gBGM.mode = -1;												// BGMWPbg摜Xbh~w
	sceKernelWaitThreadEnd( gBgmImageId, NULL );
	sceKernelDeleteThread( gBgmImageSubId );
	sceKernelDeleteThread( gBgmImageId );
	sceKernelDeleteThread( gConfigSaveId );
	sceKernelDeleteThread( gFileCtrlId );
	sceKernelDeleteThread( gThumbId );
	sceKernelDeleteThread( gGetDirId[1] );
	sceKernelDeleteThread( gGetDirId[0] );
	return;
}


